'Copyright (c) 2003-2011 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class aoCheckBox
    Inherits System.Windows.Forms.UserControl

    Private prvItemName As String = "Name"
    Private prvItemID As Integer = 9999
    Private prvTabPage As System.Windows.Forms.TabPage

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents chkControl As System.Windows.Forms.CheckBox
    Friend WithEvents aocbTooltip As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.chkControl = New System.Windows.Forms.CheckBox
        Me.aocbTooltip = New System.Windows.Forms.ToolTip(Me.components)
        Me.SuspendLayout()
        '
        'chkControl
        '
        Me.chkControl.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkControl.Location = New System.Drawing.Point(0, 0)
        Me.chkControl.Name = "chkControl"
        Me.chkControl.Size = New System.Drawing.Size(336, 24)
        Me.chkControl.TabIndex = 0
        Me.chkControl.Text = "label"
        '
        'aoCheckBox
        '
        Me.Controls.Add(Me.chkControl)
        Me.Name = "aoCheckBox"
        Me.Size = New System.Drawing.Size(336, 24)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Property ItemName() As String
        Get
            Return prvItemName
        End Get
        Set(ByVal Value As String)
            prvItemName = Value
            Me.chkControl.Text = prvItemName
        End Set
    End Property

    Public Property ItemID() As Integer
        Get
            Return prvItemID
        End Get
        Set(ByVal Value As Integer)
            prvItemID = Value
            Me.aocbTooltip.AutoPopDelay = 6000
            Me.aocbTooltip.InitialDelay = 750
            Me.aocbTooltip.SetToolTip(Me.chkControl, ShowPerk(Value))
        End Set
    End Property

    Public Property ControlTabPage() As System.Windows.Forms.TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As System.Windows.Forms.TabPage)
            prvTabPage = Value
        End Set
    End Property

    Private Sub chkControl_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControl.CheckedChanged
        Dim pid As Integer
        Dim pn As Integer
        Dim i As Integer
        Dim numSelected As Integer
        Dim perkPointsReq As Integer

        If noRecalc = True Then
            Return
        End If
        ' get our id to look up perk array
        pid = Me.ItemID
        ' find which checkbox # we are
        pn = PerkArray(pid).PerkNo - 1
        If Me.chkControl.Checked = True Then
            ' ensure that sufficient perk points are available
            numSelected = 0
            For i = 0 To pn - 1
                If perkCA(i).chkControl.Checked = True Then
                    numSelected += 1
                End If
            Next
            perkPointsReq = (pn + 1) - numSelected
            If GetNumberOfPerks(CInt(fmMain.nudLevel.Value)) < (perkPointsReq + numPerks) Then
                ' not enough points, deny change and warn user
                Me.chkControl.Checked = False
                MsgBox("Insufficient Perk Points Available", MsgBoxStyle.OkOnly, "AOSkills")
            Else
                noRecalc = True
                ' ensure all previous levels checked
                For i = 0 To pn - 1
                    If perkCA(i).chkControl.Checked = False Then
                        perkCA(i).chkControl.Checked = True
                        If Not IsNothing(fmMain.LoggingHandle) Then
                            fmMain.LoggingHandle.LogPerk(perkCA(i).Name, False, True)
                        End If
                        AddPerk(perkCA(i).ItemID)
                    End If
                Next
                If Not IsNothing(fmMain.LoggingHandle) Then
                    fmMain.LoggingHandle.LogPerk(prvItemName, False, True)
                End If
                AddPerk(pid)
                noRecalc = False
            End If
        Else
            noRecalc = True
            ' ensure all later levels unchecked
            For i = pn + 1 To numPerkCheckboxes - 1
                If perkCA(i).chkControl.Checked = True Then
                    perkCA(i).chkControl.Checked = False
                    If Not IsNothing(fmMain.LoggingHandle) Then
                        fmMain.LoggingHandle.LogPerk(perkCA(i).Name, True, False)
                    End If
                    RemPerk(perkCA(i).ItemID)
                End If
            Next
            If Not IsNothing(fmMain.LoggingHandle) Then
                fmMain.LoggingHandle.LogPerk(prvItemName, True, False)
            End If
            RemPerk(pid)
            noRecalc = False
        End If
        If Not IsNothing(fmMain.LoggingHandle) Then
            fmMain.LoggingHandle.DisableLogging()
        End If
        ' recalc perks then all skills
        ConfigurePerks()
        updatePerkLabel(fmMain.lstPerks.SelectedIndex)
        If Not IsNothing(fmMain.LoggingHandle) Then
            fmMain.LoggingHandle.EnableLogging()
        End If
        hasChanges = True
    End Sub

End Class
