'Copyright (c) 2003-2011 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class aoskillControl
    Inherits System.Windows.Forms.UserControl

    Private prvBaseValue As Integer = 0
    Private prvIPTracker As Integer = 0
    Private prvLastIPTracker As Integer = 0
    Private prvMaxImprove As Integer = 0
    Private prvTrickleDown As Integer = 0
    Private prvItemName As String = "Name"
    Private prvItemID As Integer = -1
    Private prvBreedID As Integer
    Private prvProfID As Integer
    Private prvIPLeft As Int32
    Private prvUseHandler As Boolean = False

    Private prvTabPage As System.Windows.Forms.TabPage

    Private prvHandler As System.EventHandler
    Friend WithEvents txtBuff As System.Windows.Forms.TextBox

    Private prvTrackValue As Integer

    Event doStatus(ByVal en As Integer)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl1 overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents lblName As System.Windows.Forms.Label
    Friend WithEvents lblValue As System.Windows.Forms.Label
    Friend WithEvents cmdMin As System.Windows.Forms.Button
    Friend WithEvents cmdMax As System.Windows.Forms.Button
    Friend WithEvents nudBasicSkill As System.Windows.Forms.NumericUpDown
    Friend WithEvents nudPerk As System.Windows.Forms.TextBox
    Friend WithEvents nudImplant As System.Windows.Forms.TextBox
    Friend WithEvents nudOther As System.Windows.Forms.TextBox
    Friend WithEvents nudBuff As System.Windows.Forms.NumericUpDown
    Friend WithEvents nudMisc As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lblName = New System.Windows.Forms.Label()
        Me.lblValue = New System.Windows.Forms.Label()
        Me.nudBasicSkill = New System.Windows.Forms.NumericUpDown()
        Me.cmdMin = New System.Windows.Forms.Button()
        Me.cmdMax = New System.Windows.Forms.Button()
        Me.nudPerk = New System.Windows.Forms.TextBox()
        Me.nudImplant = New System.Windows.Forms.TextBox()
        Me.nudOther = New System.Windows.Forms.TextBox()
        Me.nudBuff = New System.Windows.Forms.NumericUpDown()
        Me.nudMisc = New System.Windows.Forms.TextBox()
        Me.txtBuff = New System.Windows.Forms.TextBox()
        CType(Me.nudBasicSkill, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.nudBuff, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'lblName
        '
        Me.lblName.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblName.Location = New System.Drawing.Point(0, 0)
        Me.lblName.Name = "lblName"
        Me.lblName.Size = New System.Drawing.Size(200, 26)
        Me.lblName.TabIndex = 0
        Me.lblName.Text = "Name"
        Me.lblName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblValue
        '
        Me.lblValue.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblValue.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblValue.Location = New System.Drawing.Point(200, 0)
        Me.lblValue.Name = "lblValue"
        Me.lblValue.Size = New System.Drawing.Size(56, 26)
        Me.lblValue.TabIndex = 1
        Me.lblValue.Text = "0"
        Me.lblValue.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'nudBasicSkill
        '
        Me.nudBasicSkill.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudBasicSkill.Location = New System.Drawing.Point(264, 0)
        Me.nudBasicSkill.Maximum = New Decimal(New Integer() {1500, 0, 0, 0})
        Me.nudBasicSkill.Name = "nudBasicSkill"
        Me.nudBasicSkill.Size = New System.Drawing.Size(56, 26)
        Me.nudBasicSkill.TabIndex = 2
        Me.nudBasicSkill.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'cmdMin
        '
        Me.cmdMin.Location = New System.Drawing.Point(608, 0)
        Me.cmdMin.Name = "cmdMin"
        Me.cmdMin.Size = New System.Drawing.Size(48, 26)
        Me.cmdMin.TabIndex = 8
        Me.cmdMin.Text = "Min"
        '
        'cmdMax
        '
        Me.cmdMax.Location = New System.Drawing.Point(656, 0)
        Me.cmdMax.Name = "cmdMax"
        Me.cmdMax.Size = New System.Drawing.Size(48, 26)
        Me.cmdMax.TabIndex = 9
        Me.cmdMax.Text = "Max"
        '
        'nudPerk
        '
        Me.nudPerk.BackColor = System.Drawing.Color.White
        Me.nudPerk.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudPerk.Location = New System.Drawing.Point(488, 0)
        Me.nudPerk.Name = "nudPerk"
        Me.nudPerk.ReadOnly = True
        Me.nudPerk.Size = New System.Drawing.Size(56, 26)
        Me.nudPerk.TabIndex = 6
        Me.nudPerk.Text = "0"
        Me.nudPerk.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudImplant
        '
        Me.nudImplant.BackColor = System.Drawing.Color.White
        Me.nudImplant.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudImplant.Location = New System.Drawing.Point(320, 0)
        Me.nudImplant.Name = "nudImplant"
        Me.nudImplant.ReadOnly = True
        Me.nudImplant.Size = New System.Drawing.Size(56, 26)
        Me.nudImplant.TabIndex = 3
        Me.nudImplant.Text = "0"
        Me.nudImplant.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudOther
        '
        Me.nudOther.BackColor = System.Drawing.Color.White
        Me.nudOther.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudOther.Location = New System.Drawing.Point(432, 0)
        Me.nudOther.Name = "nudOther"
        Me.nudOther.ReadOnly = True
        Me.nudOther.Size = New System.Drawing.Size(56, 26)
        Me.nudOther.TabIndex = 5
        Me.nudOther.Text = "0"
        Me.nudOther.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'nudBuff
        '
        Me.nudBuff.Enabled = False
        Me.nudBuff.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudBuff.Location = New System.Drawing.Point(376, 0)
        Me.nudBuff.Maximum = New Decimal(New Integer() {1500, 0, 0, 0})
        Me.nudBuff.Name = "nudBuff"
        Me.nudBuff.Size = New System.Drawing.Size(56, 26)
        Me.nudBuff.TabIndex = 13
        Me.nudBuff.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        Me.nudBuff.Visible = False
        '
        'nudMisc
        '
        Me.nudMisc.BackColor = System.Drawing.Color.White
        Me.nudMisc.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudMisc.Location = New System.Drawing.Point(544, 0)
        Me.nudMisc.Name = "nudMisc"
        Me.nudMisc.ReadOnly = True
        Me.nudMisc.Size = New System.Drawing.Size(56, 26)
        Me.nudMisc.TabIndex = 7
        Me.nudMisc.Text = "0"
        Me.nudMisc.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'txtBuff
        '
        Me.txtBuff.BackColor = System.Drawing.Color.White
        Me.txtBuff.Font = New System.Drawing.Font("Arial", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtBuff.Location = New System.Drawing.Point(376, 0)
        Me.txtBuff.Name = "txtBuff"
        Me.txtBuff.ReadOnly = True
        Me.txtBuff.Size = New System.Drawing.Size(56, 26)
        Me.txtBuff.TabIndex = 4
        Me.txtBuff.Text = "0"
        Me.txtBuff.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'aoskillControl
        '
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.Controls.Add(Me.txtBuff)
        Me.Controls.Add(Me.nudMisc)
        Me.Controls.Add(Me.nudBuff)
        Me.Controls.Add(Me.nudOther)
        Me.Controls.Add(Me.nudImplant)
        Me.Controls.Add(Me.nudPerk)
        Me.Controls.Add(Me.cmdMax)
        Me.Controls.Add(Me.cmdMin)
        Me.Controls.Add(Me.nudBasicSkill)
        Me.Controls.Add(Me.lblValue)
        Me.Controls.Add(Me.lblName)
        Me.Name = "aoskillControl"
        Me.Size = New System.Drawing.Size(720, 26)
        CType(Me.nudBasicSkill, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.nudBuff, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public Property ItemName() As String
        Get
            Return prvItemName
        End Get
        Set(ByVal Value As String)
            prvItemName = Value
            Me.lblName.Text = prvItemName
        End Set
    End Property

    Public Property ItemID() As Integer
        Get
            Return prvItemID
        End Get
        Set(ByVal Value As Integer)
            prvItemID = Value
        End Set
    End Property

    Public Property BaseValue() As Integer
        Get
            Return prvBaseValue
        End Get
        Set(ByVal Value As Integer)
            prvBaseValue = Value
            updateMinMaxVal()
            changed()
        End Set
    End Property

    Public Property TrickleDown() As Integer
        Get
            Return prvTrickleDown
        End Get
        Set(ByVal Value As Integer)
            prvTrickleDown = Value
            updateMinMaxVal()
            changed()
        End Set
    End Property

    Public Property MaxImprove() As Integer
        Get
            Return prvMaxImprove
        End Get
        Set(ByVal Value As Integer)
            prvMaxImprove = Value
            updateMinMaxVal()
            changed()
        End Set
    End Property

    Public Property Improvement() As Integer
        Get
            Return prvIPTracker
        End Get
        Set(ByVal Value As Integer)
            prvIPTracker = Value
            'Me.nudBasicSkill.Value = prvIPTracker + prvBaseValue + prvTrickleDown
            changed()
        End Set
    End Property

    Public Property Buff() As Integer
        Get
            Return CInt(Me.nudBuff.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudBuff.Text = CStr(Value)
            Me.txtBuff.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Implant() As Integer
        Get
            Return CInt(Me.nudImplant.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudImplant.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Other() As Integer
        Get
            Return CInt(Me.nudOther.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudOther.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Perk() As Integer
        Get
            Return CInt(Me.nudPerk.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudPerk.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public Property Misc() As Integer
        Get
            Return CInt(Me.nudMisc.Text)
        End Get
        Set(ByVal Value As Integer)
            Me.nudMisc.Text = CStr(Value)
            changed()
        End Set
    End Property

    Public ReadOnly Property Value() As String
        Get
            Return CStr(prvIPTracker + prvBaseValue + prvTrickleDown + CInt(Me.nudBuff.Text) + CInt(Me.nudImplant.Text) + CInt(Me.nudOther.Text) + Me.Perk + CInt(Me.nudMisc.Text))
        End Get
    End Property

    Public ReadOnly Property NakedValue() As String
        Get
            Return CStr(prvIPTracker + prvBaseValue + prvTrickleDown + CInt(Me.nudBuff.Text) + Me.Perk + CInt(Me.nudMisc.Text))
        End Get
    End Property

    Public ReadOnly Property LastValue() As String
        Get
            Return CStr(prvLastIPTracker + prvBaseValue + prvTrickleDown + CInt(Me.nudBuff.Text) + CInt(Me.nudImplant.Text) + CInt(Me.nudOther.Text) + Me.Perk + CInt(Me.nudMisc.Text))
        End Get
    End Property

    Public ReadOnly Property Unbuffed() As Integer
        Get
            Return prvIPTracker + prvBaseValue + prvTrickleDown
        End Get
    End Property

    Public Property BreedID() As Integer
        Get
            Return prvBreedID
        End Get
        Set(ByVal Value As Integer)
            prvBreedID = Value
        End Set
    End Property

    Public Property ProfID() As Integer
        Get
            Return prvProfID
        End Get
        Set(ByVal Value As Integer)
            prvProfID = Value
        End Set
    End Property

    Public Property IPLeft() As Int32
        Get
            Return prvIPLeft
        End Get
        Set(ByVal Value As Int32)
            prvIPLeft = Value
        End Set
    End Property

    Public Property UseHandler() As Boolean
        Get
            Return prvUseHandler
        End Get
        Set(ByVal Value As Boolean)
            prvUseHandler = Value
        End Set
    End Property

    Public Property ControlTabPage() As System.Windows.Forms.TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As System.Windows.Forms.TabPage)
            prvTabPage = Value
        End Set
    End Property

    Public Property ChangeHandler() As System.EventHandler
        Get
            Return prvHandler
        End Get
        Set(ByVal Value As System.EventHandler)
            prvHandler = Value
        End Set
    End Property

    Private Sub nudBasicSkill_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudBasicSkill.Enter
        prvTrackValue = CInt(Me.nudBasicSkill.Value)
    End Sub

    Private Sub nudBasicSkill_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudBasicSkill.Leave
        If prvTrackValue <> Me.nudBasicSkill.Value Then
            nudBasicSkill_ValueChanged(sender, e)
        End If
    End Sub

    Private Sub nudBasicSkill_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles nudBasicSkill.Click
        Me.nudBasicSkill.Select(0, Me.nudBasicSkill.Text.Length)
    End Sub

    Private Function checkIP(ByVal currentVal As Int32, ByVal newValue As Int32) As Boolean
        Dim elID As Integer
        Dim elCost As Int32

        ' only check if we are increasing
        If newValue > currentVal Then
            If CInt(Me.ItemID) < 100 Then
                elID = CInt(Me.ItemID)
                elCost = calcTotalAttrCost(newValue, Me.BreedID, elID) - calcTotalAttrCost(currentVal, Me.BreedID, elID)
            Else
                elID = CInt(Me.ItemID) - 100
                elCost = calcTotalSkillCost(newValue, Me.ProfID, elID) - calcTotalSkillCost(currentVal, Me.ProfID, elID)
            End If
            If elCost > Me.IPLeft Then
                Return False
            Else
                Return True
            End If
        End If
        Return True
    End Function

    Private Sub nudBasicSkill_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudBasicSkill.ValueChanged
        prvIPTracker = CInt(Me.nudBasicSkill.Value - prvBaseValue - prvTrickleDown)
        ' really need to check if IP available and factor that in...
        If checkIP(prvLastIPTracker, prvIPTracker) = False Then
            prvIPTracker = prvLastIPTracker
            Me.nudBasicSkill.Value = prvIPTracker + prvBaseValue + prvTrickleDown
            MsgBox("Insufficient IP available.", MsgBoxStyle.OkOnly, "Warning")
        End If
        If Not IsNothing(fmMain.LoggingHandle) And prvLastIPTracker <> prvIPTracker Then
            fmMain.LoggingHandle.LogIP(Me.prvItemName, prvLastIPTracker, prvIPTracker)
        End If
        changed()
        If prvUseHandler = True Then
            prvHandler(Me, e)
        End If
        hasChanges = True
        prvLastIPTracker = prvIPTracker
    End Sub

    Private Sub updateMinMaxVal()
        Dim c_val As Decimal
        Dim n_val As Decimal
        Dim c_min As Decimal
        Dim c_max As Decimal
        Dim n_min As Decimal
        Dim n_max As Decimal

        c_val = Me.nudBasicSkill.Value
        c_min = Me.nudBasicSkill.Minimum
        c_max = Me.nudBasicSkill.Maximum
        n_val = prvIPTracker + prvBaseValue + prvTrickleDown
        n_min = prvBaseValue + prvTrickleDown
        n_max = prvBaseValue + prvMaxImprove + prvTrickleDown
        If n_val > n_max Then
            n_val = n_max
        End If
        If n_val < n_min Then
            n_val = n_min
        End If
        If c_min < n_min And c_max < n_max Then
            Me.nudBasicSkill.Maximum = n_max
            Me.nudBasicSkill.Value = n_min
            Me.nudBasicSkill.Minimum = n_min
            Me.nudBasicSkill.Value = n_val
        ElseIf c_min > n_min And c_max > n_max Then
            Me.nudBasicSkill.Minimum = n_min
            Me.nudBasicSkill.Value = n_max
            Me.nudBasicSkill.Maximum = n_max
            Me.nudBasicSkill.Value = n_val
        ElseIf c_min < n_min And c_max > n_max Then
            Me.nudBasicSkill.Value = n_min
            Me.nudBasicSkill.Minimum = n_min
            Me.nudBasicSkill.Maximum = n_max
            Me.nudBasicSkill.Value = n_val
        ElseIf c_min > n_min And c_max < n_max Then
            Me.nudBasicSkill.Minimum = n_min
            Me.nudBasicSkill.Maximum = n_max
            Me.nudBasicSkill.Value = n_val
        Else
            Me.nudBasicSkill.Minimum = n_min
            Me.nudBasicSkill.Maximum = n_max
            Me.nudBasicSkill.Value = n_val
        End If
    End Sub

    Public Sub changed()
        Me.lblValue.Text = CStr(prvIPTracker + prvBaseValue + prvTrickleDown + CInt(Me.nudBuff.Text) + CInt(Me.nudImplant.Text) + CInt(Me.nudOther.Text) + Me.Perk + CInt(Me.nudMisc.Text))
    End Sub

    Private Sub cmdMin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdMin.Click
        Me.nudBasicSkill.Value = Me.nudBasicSkill.Minimum
    End Sub

    Private Sub cmdMax_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdMax.Click
        Dim newIP As Int32
        Dim currentIP As Int32
        Dim inc As Int32

        ' determine if we have IP to do this... if not, determine what we can increase to and use that instead
        newIP = CInt(Me.nudBasicSkill.Maximum - prvBaseValue - prvTrickleDown)
        currentIP = CInt(Me.nudBasicSkill.Value - prvBaseValue - prvTrickleDown)
        If checkIP(currentIP, newIP) Then
            Me.nudBasicSkill.Value = Me.nudBasicSkill.Maximum
        Else
            inc = 0
            Do
                If checkIP(currentIP, currentIP + inc + 1) = False Then
                    Exit Do
                End If
                inc = inc + 1
            Loop
            inc = currentIP + inc + prvBaseValue + prvTrickleDown
            If inc > CInt(Me.nudBasicSkill.Maximum) Then
                inc = CInt(Me.nudBasicSkill.Maximum)
            End If
            Me.nudBasicSkill.Value = inc
        End If
    End Sub

    Private Sub aoskillControl_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.MouseEnter
        RaiseEvent doStatus(prvItemID)
    End Sub

    Private Sub aoskillControl_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.MouseLeave
        RaiseEvent doStatus(-1)
    End Sub

    Private Sub lblName_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblName.MouseEnter
        RaiseEvent doStatus(prvItemID)
    End Sub

    Private Sub lblName_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblName.MouseLeave
        RaiseEvent doStatus(-1)
    End Sub

    Private Sub lblValue_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblValue.MouseEnter
        RaiseEvent doStatus(prvItemID)
    End Sub

    Private Sub lblValue_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles lblValue.MouseLeave
        RaiseEvent doStatus(-1)
    End Sub

End Class
