'Copyright (c) 2010-2013 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports Microsoft.VisualBasic
Imports System.Collections.Specialized

Module modEquipment

    ' slots 0 to 14 are weapon tab slots
    ' slots 15 to 29 are armor tab slots
    ' slots 30 to 42 are implant tab slots
    Public Const FIRST_WEAPON_SLOT As Integer = 0
    Public Const FIRST_ARMOR_SLOT As Integer = 15
    Public Const FIRST_IMP_SLOT As Integer = 30
    Public Const MAX_SLOT As Integer = 42
    Public Const LOW_AOID As Integer = 0
    Public Const HIGH_AOID As Integer = 1
    Public Const ITEM_QL As Integer = 2
    Public equipment_slots(MAX_SLOT, 2) As Integer

    Public Const SEL_STRING As String = "                   ...                   "

    Public Const EQUIP_MODS As Integer = 0
    Public Const IMP_MODS As Integer = 1
    Public combinedSkillMods(NUM_SKILLS - 1, 1) As Integer
    Public combinedAttributeMods(NUM_ATTRS - 1, 1) As Integer
    Public combinedHPNPMods(1, 1) As Integer

    Public objSkillDict As New skillDict

    Public Sub initSkillDict(ByVal oSkillDict As skillDict)
        oSkillDict.AddSkill(0, "Body Dev", 152, "Body Development", "Body Development")
        oSkillDict.AddSkill(1, "Nano Pool", 132, "Nano Pool", "Nano Energy Pool")
        oSkillDict.AddSkill(2, "Martial Arts", 100, "Martial Arts", "Martial Arts")
        oSkillDict.AddSkill(3, "Brawling", 142, "Brawling", "Brawling")
        oSkillDict.AddSkill(4, "Dimach", 144, "Dimach", "Dimach (Soul Attack)")
        oSkillDict.AddSkill(5, "Riposte", 143, "Riposte", "Riposte")
        oSkillDict.AddSkill(6, "Adventuring", 137, "Adventuring", "Adventuring")
        oSkillDict.AddSkill(7, "Swimming", 138, "Swimming", "Swimming")
        oSkillDict.AddSkill(8, "1h Blunt", 102, "1 Handed Blunt Weapons", "1 Hand Blunt Weapons")
        oSkillDict.AddSkill(9, "1h Edged", 103, "1 Handed Edged Weapon", "1 Hand Edged Weapons")
        oSkillDict.AddSkill(10, "Piercing", 106, "Piercing", "Piercing Weapons")
        oSkillDict.AddSkill(11, "2h Blunt", 107, "2 Handed Blunt Weapons", "2 Handed Blunt Weapons")
        oSkillDict.AddSkill(12, "2h Edged", 105, "2 Handed Edged Weapons", "2 Handed Edged Weapons")
        oSkillDict.AddSkill(13, "Melee Energy", 104, "Melee Energy Weapons", "Melee Energy Weapons")
        oSkillDict.AddSkill(14, "Parry", 145, "Parry", "Parry")
        oSkillDict.AddSkill(15, "Sneak Attack", 146, "Sneak Attack", "Sneak Attack")
        oSkillDict.AddSkill(16, "Mult. Melee", 101, "Multiple Melee Weapons", "Multiple Melee Weapons")
        oSkillDict.AddSkill(17, "Fast Attack", 147, "Fast Attack", "Fast Attack")
        oSkillDict.AddSkill(18, "Sharp Obj", 108, "Sharp Objects", "Knife or Sharp Object Throwing")
        oSkillDict.AddSkill(19, "Grenade", 109, "Grenade Throwing", "Grenade or Lumping Throwing")
        oSkillDict.AddSkill(20, "Heavy Weapons", 110, "Heavy Weapons", "Operate Heavy Machinery")
        oSkillDict.AddSkill(21, "Bow", 111, "Bow", "Bow")
        oSkillDict.AddSkill(22, "Pistol", 112, "Pistol", "Pistol")
        oSkillDict.AddSkill(23, "Assault Rif", 116, "Assault Rifle", "Assault Rifle")
        oSkillDict.AddSkill(24, "MG/SMG", 114, "MG/SMG", "Machine Guns (MG) and Sub Machine Guns (SMG)")
        oSkillDict.AddSkill(25, "Shotgun", 115, "Shotgun", "Shotgun")
        oSkillDict.AddSkill(26, "Rifle", 113, "Rifle", "Rifle and Sniper-Rifle")
        oSkillDict.AddSkill(27, "Ranged Energy", 133, "Ranged Energy", "Ranged Energy Weapons")
        oSkillDict.AddSkill(28, "Fling Shot", 150, "Fling Shot", "Fling Shot")
        oSkillDict.AddSkill(29, "Aimed Shot", 151, "Aimed Shot", "Aimed Shot")
        oSkillDict.AddSkill(30, "Burst", 148, "Burst", "Burst")
        oSkillDict.AddSkill(31, "Full Auto", 167, "Full Auto", "Full Auto")
        oSkillDict.AddSkill(32, "Bow Spc Att", 121, "Bow Special Attack", "Bow Special Attack")
        oSkillDict.AddSkill(33, "Multi Ranged", 134, "Multiple Ranged Weapons", "Multiple Ranged Weapons")
        oSkillDict.AddSkill(34, "Melee Init", 118, "Melee Weapons Initiative", "Melee Weapons Initiative")
        oSkillDict.AddSkill(35, "Ranged Init", 119, "Ranged Initiative", "Ranged Weapons Initiative")
        oSkillDict.AddSkill(36, "Physical Init", 120, "Physical Initiative", "Physical Prowess and Martial Arts Initiative")
        oSkillDict.AddSkill(37, "NanoC Init.", 149, "Nano Initiative", "Nano Execution Init")
        oSkillDict.AddSkill(38, "Dodge-Rng", 154, "Dodge Ranged Attacks", "Dodge Ranged Attacks")
        oSkillDict.AddSkill(39, "Evade-ClsC", 155, "Evade Close Combat", "Evade Close Combat and Martial Art Attacks")
        oSkillDict.AddSkill(40, "Duck-Exp", 153, "Duck Explosives", "Duck Explosions and Thrown Objects")
        oSkillDict.AddSkill(41, "Nano Resist", 168, "Nano Resistance", "Nano Resistance")
        oSkillDict.AddSkill(42, "Run Speed", 156, "Run Speed", "Run Speed")
        oSkillDict.AddSkill(43, "Mech Eng", 125, "Mechanical Engineering", "Mechanical Enginering")
        oSkillDict.AddSkill(44, "Elec Eng", 126, "Electrical Engineering", "Electrical Engineering")
        oSkillDict.AddSkill(45, "Quantum FT", 157, "Quantum Physics", "Quantum Force field Technology")
        oSkillDict.AddSkill(46, "Weapon Smith", 158, "Weapon Smithing", "Weapon Smithing")
        oSkillDict.AddSkill(47, "Pharma Tech", 159, "Pharmaceuticals", "Pharmacological Technology")
        oSkillDict.AddSkill(48, "Nano Program", 160, "Nano Programming", "Nano-Bot Programming")
        oSkillDict.AddSkill(49, "Comp Lit", 161, "Computer Literacy", "Computer Literacy")
        oSkillDict.AddSkill(50, "Psychology", 162, "Psychology", "Psychology")
        oSkillDict.AddSkill(51, "Chemistry", 163, "Chemistry", "Chemistry")
        oSkillDict.AddSkill(52, "Tutoring", 141, "Tutoring", "Tutoring")
        oSkillDict.AddSkill(53, "Mat Met", 127, "Matter Metamorphosis", "Matter Metamorphoses")
        oSkillDict.AddSkill(54, "Bio Met", 128, "Biological Metamorphosis", "Biological Metamorphoses")
        oSkillDict.AddSkill(55, "Psycho Modi", 129, "Psychological Modifications", "Psychological Modifications")
        oSkillDict.AddSkill(56, "Mat Create", 130, "Matter Creation", "Matter Creations")
        oSkillDict.AddSkill(57, "Time & Space", 131, "Time and Space", "Time and Space Alteration")
        oSkillDict.AddSkill(58, "Sensory Imp", 122, "Sensory Improvement", "Sensory Improvement and Modification")
        oSkillDict.AddSkill(59, "First Aid", 123, "First Aid", "First Aid")
        oSkillDict.AddSkill(60, "Treatment", 124, "Treatment", "Treatment")
        oSkillDict.AddSkill(61, "Concealment", 164, "Concealment", "Concealment")
        oSkillDict.AddSkill(62, "Break & Entry", 165, "Breaking and Entry", "Breaking and Entering")
        oSkillDict.AddSkill(63, "Trap Disarm.", 135, "Trap Disarming", "Trap Disarmament")
        oSkillDict.AddSkill(64, "Perception", 136, "Perception", "Perception and spotting")
        oSkillDict.AddSkill(65, "Vehicle Air", 139, "Vehicle Air", "Vehicle Navigation, Airborne")
        oSkillDict.AddSkill(66, "Vehicle Ground", 166, "Vehicle Ground", "Vehicle Navigation, Ground")
        oSkillDict.AddSkill(67, "Vehicle Water", 117, "Vehicle Water", "Vehicle Navigation, Waterbased")
        oSkillDict.AddSkill(68, "Map Navigation", 140, "Map Navigation", "Map Navigation")
        oSkillDict.AddSkill(100, "Hit Points", 1, "Max Health", "life")
        oSkillDict.AddSkill(101, "Nano Points", 221, "Max Nano", "Max Nano")
        oSkillDict.AddSkill(200, "Strength", 16, "Strength", "Strength")
        oSkillDict.AddSkill(201, "Agility", 17, "Agility", "Agility")
        oSkillDict.AddSkill(202, "Stamina", 18, "Stamina", "Stamina")
        oSkillDict.AddSkill(203, "Intelligence", 19, "Intelligence", "Intelligence")
        oSkillDict.AddSkill(204, "Sense", 20, "Sense", "Sense")
        oSkillDict.AddSkill(205, "Psychic", 21, "Psychic", "Psychic")
        oSkillDict.AddSkill(400, "Chemical AC", 93, "Chemical AC", "Chemical Armor-Class")
        oSkillDict.AddSkill(401, "Cold AC", 95, "Cold AC", "Cold Armor-Class")
        oSkillDict.AddSkill(402, "Poison AC", 96, "Poison AC", "Disease and Poison Armor-Class")
        oSkillDict.AddSkill(403, "Energy AC", 92, "Energy AC", "Energy Attack Armor-Class")
        oSkillDict.AddSkill(404, "Fire AC", 97, "Fire AC", "Fire Armor-Class")
        oSkillDict.AddSkill(405, "Projectile AC", 90, "Projectile AC", "Impact and Projectile Weapon Armor-Class")
        oSkillDict.AddSkill(406, "Melee AC", 91, "Melee AC", "Melee Attacks and Martial Art Armor-Class")
        oSkillDict.AddSkill(407, "Radiation AC", 94, "Radiation AC", "Radiation Armor-Class")
        oSkillDict.AddSkill(408, "Nano Delta*", 364, "Nano Delta*", "")
        oSkillDict.AddSkill(409, "Heal Delta*", 343, "Heal Delta*", "Health Regeneration Add")
        oSkillDict.AddSkill(410, "Add All Defense*", 277, "Add All Defense*", "Percentage Added to all Defencive Rolls")
        oSkillDict.AddSkill(411, "Add All Offense*", 276, "Add All Offense*", "Percentage Added to all Offensive Rolls")
        oSkillDict.AddSkill(412, "Add Max NCU*", 181, "Add Max NCU*", "NCU Count")
        oSkillDict.AddSkill(413, "Add XP (%)*", 319, "Add XP (%)*", "Percentage Additional Experience")
        oSkillDict.AddSkill(414, "Add Weapon Range (%)*", 380, "Add Weapon Range (%)*", "Range Increaser Weapon")
        oSkillDict.AddSkill(415, "Add Nano Range (%)*", 381, "Add Nano Range (%)*", "Range Increaser Nano Formula")
        oSkillDict.AddSkill(416, "Nano Interrupt (%)*", 383, "Nano Interrupt (%)*", "Percentage Change in chance of being interrupted while Executing Nanos")
        oSkillDict.AddSkill(417, "Nano Cost (%)*", 318, "Nano Cost (%)*", "Nano Execution Cost Percentage Change")
        oSkillDict.AddSkill(418, "Skill Lock (%)*", 382, "Skill Lock (%)*", "Percentage Change in Skill Timer Lock")
        oSkillDict.AddSkill(419, "Add Chemical Damage*", 281, "Add Chemical Damage*", "Points Added to Chemical Damage")
        oSkillDict.AddSkill(420, "Add Cold Damage*", 311, "Add Cold Damage*", "NONE001")
        oSkillDict.AddSkill(421, "Add Energy Damage*", 280, "Add Energy Damage*", "Points Added to Energy Damage")
        oSkillDict.AddSkill(422, "Add Fire Damage*", 316, "Add Fire Damage*", "Points Added to Fire Damage")
        oSkillDict.AddSkill(423, "Add Melee Damage*", 279, "Add Melee Damage*", "Points Added to Melee Damage")
        oSkillDict.AddSkill(424, "Add Poison Damage*", 317, "Add Poison Damage*", "Points Added to Poison Damage")
        oSkillDict.AddSkill(425, "Add Projectile Damage*", 278, "Add Projectile Damage*", "Points Added to Projectile Damage")
        oSkillDict.AddSkill(426, "Add Radiation Damage*", 282, "Add Radiation Damage*", "Points Added to Radiation Damage")
        oSkillDict.AddSkill(427, "Chemical Damage Shield*", 229, "Chemical Damage Shield*", "Shield Chemical AC")
        oSkillDict.AddSkill(428, "Cold Damage Shield*", 231, "Cold Damage Shield*", "Shield Cold AC")
        oSkillDict.AddSkill(429, "Energy Damage Shield*", 228, "Energy Damage Shield*", "Shield Energy AC")
        oSkillDict.AddSkill(430, "Fire Damage Shield*", 233, "Fire Damage Shield*", "Shield Fire AC")
        oSkillDict.AddSkill(431, "Melee Damage Shield*", 227, "Melee Damage Shield*", "Shield Melee AC")
        oSkillDict.AddSkill(432, "Poison Damage Shield*", 234, "Poison Damage Shield*", "Shield Poison AC")
        oSkillDict.AddSkill(433, "Projectile Damage Shield*", 226, "Projectile Damage Shield*", "Shield Projectile AC")
        oSkillDict.AddSkill(434, "Radiation Damage Shield*", 230, "Radiation Damage Shield*", "Shield Radiation AC")
        oSkillDict.AddSkill(435, "MaxReflectedMeleeAC", 476, "MaxReflectedMeleeAC", "MaxReflectedMeleeAC")
        oSkillDict.AddSkill(436, "MaxReflectedProjectileAC", 475, "MaxReflectedProjectileAC", "MaxReflectedProjectileAC")
        oSkillDict.AddSkill(437, "MaxReflectedEnergyAC", 477, "MaxReflectedEnergyAC", "MaxReflectedEnergyAC")
        oSkillDict.AddSkill(438, "MaxReflectedChemicalAC", 478, "MaxReflectedChemicalAC", "MaxReflectedChemicalAC")
        oSkillDict.AddSkill(439, "MaxReflectedPoisonAC", 483, "MaxReflectedPoisonAC", "MaxReflectedPoisonAC")
        oSkillDict.AddSkill(440, "MaxReflectedRadiationAC", 479, "MaxReflectedRadiationAC", "MaxReflectedRadiationAC")
        oSkillDict.AddSkill(441, "MaxReflectedColdAC", 480, "MaxReflectedColdAC", "MaxReflectedColdAC")
        oSkillDict.AddSkill(442, "MaxReflectedFireAC", 482, "MaxReflectedFireAC", "MaxReflectedFireAC")
        oSkillDict.AddSkill(443, "ReflectEnergyAC", 207, "ReflectEnergyAC", "ReflectEnergyAC")
        oSkillDict.AddSkill(444, "ReflectMeleeAC", 206, "ReflectMeleeAC", "ReflectMeleeAC")
        oSkillDict.AddSkill(445, "ReflectProjectileAC", 205, "ReflectProjectileAC", "ReflectProjectileAC")
        oSkillDict.AddSkill(446, "ReflectChemicalAC", 208, "ReflectChemicalAC", "ReflectChemicalAC")
        oSkillDict.AddSkill(447, "ReflectPoisonAC", 225, "ReflectPoisonAC", "ReflectPoisonAC")
        oSkillDict.AddSkill(448, "ReflectRadiationAC", 216, "ReflectRadiationAC", "ReflectRadiationAC")
        oSkillDict.AddSkill(449, "ReflectColdAC", 217, "ReflectColdAC", "ReflectColdAC")
        oSkillDict.AddSkill(450, "ReflectFireAC", 219, "ReflectFireAC", "ReflectFireAC")
        oSkillDict.AddSkill(451, "NanoDamageMultiplier", 536, "NanoDamageMultiplier", "NanoDamageMultiplier")
        oSkillDict.AddSkill(452, "CriticalIncrease", 379, "CriticalIncrease", "CriticalIncrease")
        oSkillDict.AddSkill(453, "CriticalResistance", 391, "CriticalResistance", "CriticalResistance")
        oSkillDict.AddSkill(454, "Scale", 360, "Scale", "Scale")
        oSkillDict.AddSkill(-1, SEL_STRING, -1, "Empty", "Empty")
    End Sub

    Public Function convertKeyToName(ByVal p_StatNo As String) As String
        'Dim aosid As Integer
        Dim value As String

        value = objSkillDict.Find_AOSName_From_AOInternalID(Convert.ToInt32(p_StatNo))
        If value = "" Then
            Return "[" & p_StatNo & "]"
        Else
            Return value
        End If
    End Function

    Public Sub resetCombinedModArrays()
        Dim i As Integer

        For i = 0 To NUM_SKILLS - 1
            combinedSkillMods(i, EQUIP_MODS) = 0
            combinedSkillMods(i, IMP_MODS) = 0
        Next
        For i = 0 To NUM_ATTRS - 1
            combinedAttributeMods(i, EQUIP_MODS) = 0
            combinedAttributeMods(i, IMP_MODS) = 0
        Next
        combinedHPNPMods(0, EQUIP_MODS) = 0
        combinedHPNPMods(0, IMP_MODS) = 0
        combinedHPNPMods(1, EQUIP_MODS) = 0
        combinedHPNPMods(1, IMP_MODS) = 0
    End Sub

    Public Sub resetEquipment()
        Dim i As Integer

        For i = 0 To MAX_SLOT
            equipment_slots(i, 0) = 0
            equipment_slots(i, 1) = 0
            equipment_slots(i, 2) = 0
        Next
        ' reset implants too as those are not covered by the above
        For i = 0 To MAX_IMPS
            impA(i).UseHandler = False
            impA(i).setType("I")
            impA(i).setElement("Shiny", SEL_STRING)
            impA(i).setElement("Bright", SEL_STRING)
            impA(i).setElement("Faded", SEL_STRING)
            impA(i).QL = 1
            impA(i).MaxQL = 1
            impA(i).UseHandler = True
        Next
        noRecalc = True
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Other = 0
            skillsCA.Item(i).Implant = 0
        Next
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Other = 0
            attrCA.Item(i).Implant = 0
        Next
        hpCA.Other = 0
        npCA.Other = 0
        hpCA.Implant = 0
        npCA.Implant = 0
        noRecalc = False
        recalcIP()
    End Sub

    Public Function interpolateLimit(ByVal lo_val As Integer, ByVal lo_ql As Integer, ByVal hi_val As Integer, ByVal hi_ql As Integer, ByVal n_val As Integer) As Integer
        Dim rv As Integer

        If hi_val = lo_val Then
            rv = lo_val
        Else
            rv = CInt(Math.Floor((n_val - lo_val) / (hi_val - lo_val) * (hi_ql - lo_ql) + lo_ql))
        End If
        Return rv
    End Function

    Public Function findBreakPoint(ByVal hi_ql As Integer, ByVal lo_ql As Integer, ByVal hi_val As Integer, ByVal lo_val As Integer, ByVal n_val As Integer) As Integer
        Dim qx As Integer
        Dim vx As Integer
        Dim q1 As Integer
        Dim q2 As Integer

        q1 = lo_ql
        q2 = hi_ql
        qx = CType(Math.Round((q2 - q1) / 2), Integer)
        If n_val >= hi_val Then
            qx = hi_ql + 1
        Else
            Do
                vx = CType(Math.Round(((qx - lo_ql) / (hi_ql - lo_ql)) * (hi_val - lo_val) + lo_val), Integer)
                If vx <= n_val Then
                    q1 = qx
                End If
                If vx > n_val Then
                    q2 = qx
                End If
                If q2 - q1 <= 1 Then
                    Exit Do
                End If
                qx = CType(Math.Round((q2 - q1) / 2) + q1, Integer)
            Loop
        End If
        Return qx - 1
    End Function

    Public Sub getItemModifiers(ByVal lo_aoid As Integer, ByVal hi_aoid As Integer, ByVal ql As Integer, ByRef tmpMods() As Integer)
        Dim lo_mods As String
        Dim hi_mods As String

        lo_mods = getStrModifiers(lo_aoid)
        hi_mods = getStrModifiers(hi_aoid)
        ' now parse lo_mods/hi_mods into tmpMods using ql to interpolate with
        parseInterpolateAndAppend(db_conn, lo_aoid, hi_aoid, lo_mods, hi_mods, CType(ql, Integer), tmpMods)
    End Sub

    Public Sub parseInterpolateAndAppend(ByRef db_conn As SQLite.SQLiteConnection, ByVal lo_aoid As Integer, ByVal hi_aoid As Integer, ByVal lo_mods As String, ByVal hi_mods As String, ByVal ql As Integer, ByRef tmpMods() As Integer)
        Dim lo_array() As String
        Dim hi_array() As String
        Dim lo_pairs() As String
        Dim hi_pairs() As String
        Dim lo_ql As Integer
        Dim hi_ql As Integer
        Dim i As Integer
        Dim mod_id As Integer
        Dim mod_val As Integer

        If lo_mods = "" And hi_mods = "" Then
            Return
        End If
        lo_ql = getQL(lo_aoid)
        hi_ql = getQL(hi_aoid)
        ' split out each "stat=value" pair from the comma seperated list
        lo_array = lo_mods.Split(CChar(","))
        hi_array = hi_mods.Split(CChar(","))
        For i = 0 To lo_array.Length() - 1
            ' now split out the stats from the values, and construct a new string, interpolating the values to the appropriate QL
            lo_pairs = lo_array(i).Split(CChar("="))
            hi_pairs = hi_array(i).Split(CChar("="))
            mod_id = CInt(lo_pairs(0))
            mod_val = CInt(interpolate(lo_ql, CType(lo_pairs(1), Integer), hi_ql, CType(hi_pairs(1), Integer), ql))
            If mod_id >= 0 And mod_id <= 68 Then
                ' 0 to 68 hold attributes
                tmpMods(mod_id) = tmpMods(mod_id) + mod_val
            ElseIf mod_id = 100 Then
                ' 75 holds max hps
                tmpMods(75) = tmpMods(75) + mod_val
            ElseIf mod_id = 101 Then
                ' 76 holds max nps
                tmpMods(76) = tmpMods(76) + mod_val
            ElseIf mod_id >= 200 And mod_id <= 205 Then
                ' 69 to 74 hold attributes
                tmpMods(mod_id - 200 + 69) = tmpMods(mod_id - 200 + 69) + mod_val
            End If
        Next i
    End Sub

    Public Sub calculateTotalModifiers(ByRef combinedSkillMods(,) As Integer, ByRef combinedAttributeMods(,) As Integer, ByRef combinedHPNPMods(,) As Integer, Optional ByVal slotToSkip As Integer = -1)
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim tmpMods(NUM_SKILLS + NUM_ATTRS + 1) As Integer
        Dim lo_aoid As Integer
        Dim hi_aoid As Integer

        ' initialise arrays
        For i = 0 To tmpMods.GetLength(0) - 1
            tmpMods(i) = 0
        Next i
        For i = 0 To NUM_SKILLS - 1
            combinedSkillMods(i, EQUIP_MODS) = 0
            combinedSkillMods(i, IMP_MODS) = 0
        Next
        For i = 0 To NUM_ATTRS - 1
            combinedAttributeMods(i, EQUIP_MODS) = 0
            combinedAttributeMods(i, IMP_MODS) = 0
        Next
        For i = 0 To 1
            combinedHPNPMods(i, EQUIP_MODS) = 0
            combinedHPNPMods(i, IMP_MODS) = 0
        Next
        ' process armour and weapon tabs
        For i = 0 To FIRST_IMP_SLOT - 1
            If i <> slotToSkip Then
                getItemModifiers(equipment_slots(i, LOW_AOID), equipment_slots(i, HIGH_AOID), equipment_slots(i, ITEM_QL), tmpMods)
                For j = 0 To NUM_SKILLS - 1
                    combinedSkillMods(j, EQUIP_MODS) = combinedSkillMods(j, EQUIP_MODS) + tmpMods(j)
                Next
                For j = 0 To NUM_ATTRS - 1
                    combinedAttributeMods(j, EQUIP_MODS) = combinedAttributeMods(j, EQUIP_MODS) + tmpMods(j + NUM_SKILLS)
                Next
                combinedHPNPMods(0, EQUIP_MODS) = combinedHPNPMods(0, EQUIP_MODS) + tmpMods(NUM_SKILLS + NUM_ATTRS)
                combinedHPNPMods(1, EQUIP_MODS) = combinedHPNPMods(1, EQUIP_MODS) + tmpMods(NUM_SKILLS + NUM_ATTRS + 1)
            End If
            ' reset temp array
            For k = 0 To tmpMods.GetLength(0) - 1
                tmpMods(k) = 0
            Next
        Next
        ' process implants
        For i = 0 To MAX_IMPS
            ' need implant/symb/spirit LOW_AOID, HIGH_AOID and ITEM_QL
            impA(i).getImplantAOIDs(lo_aoid, hi_aoid)
            getItemModifiers(lo_aoid, hi_aoid, impA(i).QL, tmpMods)
            For j = 0 To NUM_SKILLS - 1
                combinedSkillMods(j, IMP_MODS) = combinedSkillMods(j, IMP_MODS) + tmpMods(j)
            Next
            For j = 0 To NUM_ATTRS - 1
                combinedAttributeMods(j, IMP_MODS) = combinedAttributeMods(j, IMP_MODS) + tmpMods(j + NUM_SKILLS)
            Next
            combinedHPNPMods(0, IMP_MODS) = combinedHPNPMods(0, IMP_MODS) + tmpMods(NUM_SKILLS + NUM_ATTRS)
            combinedHPNPMods(1, IMP_MODS) = combinedHPNPMods(1, IMP_MODS) + tmpMods(NUM_SKILLS + NUM_ATTRS + 1)
            ' reset temp array
            For k = 0 To tmpMods.GetLength(0) - 1
                tmpMods(k) = 0
            Next
        Next
    End Sub

    Public Function determineLimit(ByVal min_reqs As Integer(,), ByVal min_ql As Integer, ByVal max_reqs As Integer(,), ByVal max_ql As Integer) As Integer
        ' we need to be able to compare each relevant attribute, we'll need a lookup table for each db stat to the internal stat
        Dim i As Integer
        Dim max_seq As Integer
        Dim attr As Integer
        Dim min_attr_val As Integer
        Dim attr_op As Integer
        Dim max_attr_val As Integer
        Dim result As Integer
        Dim internal_attr As Integer
        Dim internal_title_level As Integer
        Dim limited_ql As Integer
        Dim lo_val As Integer
        Dim hi_val As Integer

        result = max_ql
        ' in case the arrays are of unequal length, always use the lowest bound
        max_seq = Math.Min(min_reqs.GetUpperBound(1), max_reqs.GetUpperBound(1))
        i = min_reqs.GetLowerBound(1)
        Do While i <= max_seq
            attr = min_reqs(0, i)
            min_attr_val = min_reqs(1, i)
            max_attr_val = max_reqs(1, i)
            attr_op = min_reqs(2, i)
            ' now, find matching attribute internally... and do test, set result to false and exit if it fails
            If attr = 33 Then
                ' side... we don't have this atm, so ignore
            ElseIf attr = 37 Then
                ' title level
                internal_title_level = calcTitleLevel(CType(fmMain.nudLevel.Value, Integer))
                ' if these are the same, then we'll have already checked
                If min_attr_val <> max_attr_val Then
                    limited_ql = findBreakPoint(max_ql, min_ql, CType(max_attr_val, Integer), CType(min_attr_val, Integer), internal_title_level - 1)
                    If limited_ql < result Then
                        result = limited_ql
                    End If
                End If
            ElseIf attr = 54 Then
                ' level
                If CType(fmMain.nudLevel.Value, Integer) <= max_attr_val Then
                    If min_attr_val <> max_attr_val Then
                        limited_ql = findBreakPoint(max_ql, min_ql, CType(max_attr_val, Integer), CType(min_attr_val, Integer), CType(fmMain.nudLevel.Value, Integer))
                        If limited_ql < result Then
                            result = limited_ql
                        End If
                    End If
                End If
            ElseIf attr = 60 Then
                ' can ignore this as we'll have already checked
            ElseIf attr = 368 Then
                ' can ignore this as we'll have already checked
            ElseIf attr = 4 Then
                ' can ignore this as we'll have already checked
            ElseIf attr > 0 And attr <= 224 Then
                'internal_attr = statLookupTable(CType(attr, Integer))
                internal_attr = objSkillDict.Find_AOSID_From_AOInternalID(CType(attr, Integer))
                If internal_attr <> -1 Then
                    ' TODO: get implant mods from the relevant control, combinedSkillMods will now only do Equipment
                    ' ok, we have an attribute or skill (or hp/np!)
                    If internal_attr < 100 Then
                        ' skill
                        lo_val = CType(min_attr_val, Integer)
                        hi_val = CType(max_attr_val, Integer)
                        limited_ql = interpolateLimit(lo_val, min_ql, hi_val, max_ql, CType(skillsCA.Item(internal_attr).NakedValue, Integer) + combinedSkillMods(internal_attr, EQUIP_MODS) + skillsCA.Item(internal_attr).Implant)
                        If limited_ql < result Then
                            result = limited_ql
                        End If
                    ElseIf internal_attr >= 200 And internal_attr <= 205 Then
                        ' attribute
                        lo_val = CType(min_attr_val, Integer)
                        hi_val = CType(max_attr_val, Integer)
                        limited_ql = interpolateLimit(lo_val, min_ql, hi_val, max_ql, CType(attrCA.Item(internal_attr - 200).NakedValue, Integer) + combinedAttributeMods(internal_attr - 200, EQUIP_MODS) + attrCA.Item(internal_attr - 200).Implant)
                        If limited_ql < result Then
                            result = limited_ql
                        End If
                    End If
                End If
            ElseIf attr = 0 And attr_op = 93 Then
                ' ATE1 is 1250
                ' ATE2 is 1251
                ' ATE3 is 1252
                ' check which level of ATE we have and calc a limit from that? what do we do if no ATE trained? Should have already filtered such items out?
            End If
            i = i + 1
        Loop
        Return result
    End Function

    Public Function getClusterBonus(ByVal slot As Integer, ByRef fadedName As String, ByRef brightName As String, ByRef shinyName As String, ByVal ql As Integer) As Integer
        ' slot = 1 for faded, 2 for bright, 3 for shiny
        Dim s_aoids As String
        Dim a_aoids() As String
        Dim lo_aoid As Integer
        Dim hi_aoid As Integer
        Dim lo_ql As Integer
        Dim hi_ql As Integer
        Dim lo_stat As Integer
        Dim hi_stat As Integer
        Dim cluster_name As String
        Dim cluster_id As Integer

        fadedName = IIf(fadedName = SEL_STRING, "Empty", fadedName).ToString()
        brightName = IIf(brightName = SEL_STRING, "Empty", brightName).ToString()
        shinyName = IIf(shinyName = SEL_STRING, "Empty", shinyName).ToString()
        s_aoids = findByClusters(shinyName, brightName, fadedName)
        If s_aoids = "NOMATCH" Then
            Return 0
        Else
            a_aoids = Split(s_aoids, "#"c)
            If ql >= 1 And ql <= 200 Then
                lo_aoid = CType(a_aoids(0), Integer)
                hi_aoid = CType(a_aoids(1), Integer)
                lo_ql = 1
                hi_ql = 200
            ElseIf ql >= 201 And ql <= 300 Then
                lo_aoid = CType(a_aoids(2), Integer)
                hi_aoid = CType(a_aoids(3), Integer)
                lo_ql = 201
                hi_ql = 300
            Else
                Return 0
            End If
            If slot = 1 Then
                cluster_name = fadedName
            ElseIf slot = 2 Then
                cluster_name = brightName
            ElseIf slot = 3 Then
                cluster_name = shinyName
            End If
            cluster_id = objSkillDict.Find_AOInternalID_From_AOInternalName(cluster_name)
            'Return cluster_id
            If cluster_id = -1 Then
                Return 0
            Else
                lo_stat = getSpecificModifier(lo_aoid, cluster_id)
                hi_stat = getSpecificModifier(hi_aoid, cluster_id)
                Return CInt(interpolate(lo_ql, lo_stat, hi_ql, hi_stat, ql))
            End If
        End If
    End Function

    Public Function getSymbiantAndSpiritBonuses(ByRef symbiantName As String) As String
        Dim aoid As Integer
        Dim mods As String
        Dim p As Integer
        Dim realname As String

        If symbiantName = SEL_STRING Then
            Return ""
        End If
        p = symbiantName.IndexOf("(QL")
        realname = symbiantName.Substring(0, p - 1)
        aoid = symbGetAOIDByName(realname)
        ' can now use that to get the relevant stat modifiers from tblItemEffects
        mods = getStrModifiers(aoid, False)
        ' convert to expected format
        mods = mods.Replace("=", " : ").Replace(",", "#")
        ' TODO: convert the numbers to skills somehow...
        Return mods
    End Function

    ' this will require the aoid that matches these clusters...
    Public Function findImplantLimit(ByRef shinyClusterName As String, ByRef brightClusterName As String, ByRef fadedClusterName As String, ByVal ql As Integer) As Integer
        ' slot = 1 for faded, 2 for bright, 3 for shiny
        Dim s_aoids As String
        Dim a_aoids() As String
        Dim lo_aoid As Integer
        Dim hi_aoid As Integer
        Dim lo_ql As Integer
        Dim hi_ql As Integer
        Dim lo_stats(,) As Integer
        Dim hi_stats(,) As Integer
        Dim limit_ql As Integer = -1
        Dim limit_2_ql As Integer = -1

        fadedClusterName = IIf(fadedClusterName = SEL_STRING, "Empty", fadedClusterName).ToString()
        brightClusterName = IIf(brightClusterName = SEL_STRING, "Empty", brightClusterName).ToString()
        shinyClusterName = IIf(shinyClusterName = SEL_STRING, "Empty", shinyClusterName).ToString()
        s_aoids = findByClusters(shinyClusterName, brightClusterName, fadedClusterName)
        If s_aoids = "NOMATCH" Then
            Return -1
        Else
            a_aoids = Split(s_aoids, "#"c)
            If ql >= 1 And ql <= 200 Then
                lo_aoid = CType(a_aoids(0), Integer)
                hi_aoid = CType(a_aoids(1), Integer)
                lo_ql = 1
                hi_ql = 200
            ElseIf ql >= 201 And ql <= 300 Then
                lo_aoid = CType(a_aoids(2), Integer)
                hi_aoid = CType(a_aoids(3), Integer)
                lo_ql = 201
                hi_ql = 300
            Else
                Return -1
            End If
            ' get requirement arrays and then determine limiting ql (we will use compareReqToChar(lo_stats) for symbiants/spirits)
            lo_stats = getRequirements(lo_aoid)
            hi_stats = getRequirements(hi_aoid)
            limit_ql = determineLimit(lo_stats, lo_ql, hi_stats, hi_ql)
            If hi_ql = 200 And limit_ql = 200 Then
                lo_aoid = CType(a_aoids(2), Integer)
                hi_aoid = CType(a_aoids(3), Integer)
                lo_ql = 201
                hi_ql = 300
                ' get requirement arrays and then determine limiting ql (we will use compareReqToChar(lo_stats) for symbiants/spirits)
                lo_stats = getRequirements(lo_aoid)
                hi_stats = getRequirements(hi_aoid)
                limit_2_ql = determineLimit(lo_stats, lo_ql, hi_stats, hi_ql)
                If limit_2_ql > limit_ql Then
                    limit_ql = limit_2_ql
                End If
            End If
        End If
        Return limit_ql
    End Function

    Public Function isSymbSpiritEquipable(ByRef symbiantName As String) As Boolean
        Dim aoid As Integer
        Dim stats(,) As Integer

        ' get aoid and from name...
        aoid = symbGetAOIDByName(symbiantName)
        If aoid = -1 Then
            Return False
        End If
        stats = getRequirements(aoid)
        Return compareReqToChar(stats)
    End Function

End Module

