'Copyright (c) 2003-2013 Donald Milne
'All rights reserved.
'
'This file is part of AOSkills3.
'
'AOSkills3 is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'AOSkills3 is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with AOSkills3. If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.XML
Imports Microsoft.VisualBasic

Module modPerks

    Public NUM_PERKS As Integer
    Public NUM_ALIEN_PERKS As Integer
    Public NUM_RESEARCH As Integer

    Public PerkArray(1) As Perks
    Public AlienPerkArray(1) As Perks
    Public ResearchArray(1) As Perks

    Public numPerks As Integer = 0
    Public numAlienPerks As Integer = 0
    Public numResearch As Integer = 0

    Public Const NUM_BONUSES As Integer = 34 ' is actually the number of bonuses times two

    Private suspendUpdatePerks As Boolean = False


    Public Structure Perks
        Public PerkName As String
        Public PerkNo As Integer
        Public PerkLevel As Integer
        Public AllowedProfs() As String
        Public AllowedBreeds() As String
        Public Bonuses() As Integer
        Public Selected As Boolean
        Public PerkSpecial As String

        Public Sub New(ByVal nm As String, ByVal no As Integer, ByVal lv As Integer, ByVal ap As String, ByVal ab As String, ByVal bn() As Integer, ByVal ps As String)
            Dim i As Integer

            Me.PerkName = nm
            Me.PerkNo = no
            Me.PerkLevel = lv
            ReDim Me.AllowedProfs(NUM_PROFS)
            For i = 0 To NUM_PROFS - 1
                Me.AllowedProfs(i) = Mid(ap, i + 1, 1)
            Next
            ReDim Me.AllowedBreeds(NUM_BREEDS)
            For i = 0 To NUM_BREEDS - 1
                Me.AllowedBreeds(i) = Mid(ab, i + 1, 1)
            Next
            ReDim Me.Bonuses(NUM_BONUSES)
            For i = 0 To NUM_BONUSES - 1
                Me.Bonuses(i) = bn(i)
            Next
            Me.Selected = False
            Me.PerkSpecial = ps
        End Sub
    End Structure

    Public Sub AddPerk(ByVal idx As Integer)
        If PerkArray(idx).Selected = False Then
            PerkArray(idx).Selected = True
            numPerks += 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub RemPerk(ByVal idx As Integer)
        If PerkArray(idx).Selected = True Then
            PerkArray(idx).Selected = False
            numPerks -= 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub AddAlienPerk(ByVal idx As Integer)
        If AlienPerkArray(idx).Selected = False Then
            AlienPerkArray(idx).Selected = True
            numAlienPerks += 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub RemAlienPerk(ByVal idx As Integer)
        If AlienPerkArray(idx).Selected = True Then
            AlienPerkArray(idx).Selected = False
            numAlienPerks -= 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub AddResearch(ByVal idx As Integer)
        If ResearchArray(idx).Selected = False Then
            ResearchArray(idx).Selected = True
            numResearch += 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub RemResearch(ByVal idx As Integer)
        If ResearchArray(idx).Selected = True Then
            ResearchArray(idx).Selected = False
            numResearch -= 1
            fmMain.updatePerks()
        End If
    End Sub

    Public Sub ConfigurePerks()
        Dim i As Integer
        Dim j As Integer
        Dim ab(NUM_ATTRS) As Integer
        Dim sk(NUM_SKILLS) As Integer
        Dim hp As Integer = 0
        Dim np As Integer = 0
        Dim old_noRecalc As Boolean

        For i = 0 To NUM_ATTRS - 1
            ab(i) = 0
        Next
        For i = 0 To NUM_SKILLS - 1
            sk(i) = 0
        Next
        For i = 0 To NUM_PERKS
            If PerkArray(i).Selected = True Then
                For j = 0 To NUM_BONUSES - 1 Step 2
                    If PerkArray(i).Bonuses(j) <> -1 Then
                        If PerkArray(i).Bonuses(j) < 100 Then
                            sk(PerkArray(i).Bonuses(j)) += PerkArray(i).Bonuses(j + 1)
                        ElseIf PerkArray(i).Bonuses(j) >= 200 Then
                            ab(PerkArray(i).Bonuses(j) - 200) += PerkArray(i).Bonuses(j + 1)
                        ElseIf PerkArray(i).Bonuses(j) = 100 Then
                            hp += PerkArray(i).Bonuses(j + 1)
                        ElseIf PerkArray(i).Bonuses(j) = 101 Then
                            np += PerkArray(i).Bonuses(j + 1)
                        End If
                    End If
                Next
            End If
        Next
        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).Selected = True Then
                For j = 0 To NUM_BONUSES - 1 Step 2
                    If AlienPerkArray(i).Bonuses(j) <> -1 Then
                        If AlienPerkArray(i).Bonuses(j) < 100 Then
                            sk(AlienPerkArray(i).Bonuses(j)) += AlienPerkArray(i).Bonuses(j + 1)
                        ElseIf AlienPerkArray(i).Bonuses(j) >= 200 Then
                            ab(AlienPerkArray(i).Bonuses(j) - 200) += AlienPerkArray(i).Bonuses(j + 1)
                        ElseIf AlienPerkArray(i).Bonuses(j) = 100 Then
                            hp += AlienPerkArray(i).Bonuses(j + 1)
                        ElseIf AlienPerkArray(i).Bonuses(j) = 101 Then
                            np += AlienPerkArray(i).Bonuses(j + 1)
                        End If
                    End If
                Next
            End If
        Next
        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).Selected = True Then
                For j = 0 To NUM_BONUSES - 1 Step 2
                    If ResearchArray(i).Bonuses(j) <> -1 Then
                        If ResearchArray(i).Bonuses(j) < 100 Then
                            sk(ResearchArray(i).Bonuses(j)) += ResearchArray(i).Bonuses(j + 1)
                        ElseIf ResearchArray(i).Bonuses(j) >= 200 Then
                            ab(ResearchArray(i).Bonuses(j) - 200) += ResearchArray(i).Bonuses(j + 1)
                        ElseIf ResearchArray(i).Bonuses(j) = 100 Then
                            hp += ResearchArray(i).Bonuses(j + 1)
                        ElseIf ResearchArray(i).Bonuses(j) = 101 Then
                            np += ResearchArray(i).Bonuses(j + 1)
                        End If
                    End If
                Next
            End If
        Next
        old_noRecalc = noRecalc
        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Perk = ab(i)
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Perk = sk(i)
        Next
        hpCA.Perk = hp
        npCA.Perk = np
        noRecalc = old_noRecalc
        recalcIP()
    End Sub

    Public Function AppendLine(ByVal s1 As String, ByVal s2 As String) As String
        Return CStr(IIf(Len(s1) > 0, s1 & Chr(10) & s2, s2))
    End Function

    Public Function ShowPerk(ByVal idx As Integer) As String
        Dim j As Integer
        Dim s As String = ""

        For j = 0 To NUM_BONUSES - 1 Step 2
            If PerkArray(idx).Bonuses(j) <> -1 Then
                If PerkArray(idx).Bonuses(j) < 100 Then
                    s = AppendLine(s, skillNames(PerkArray(idx).Bonuses(j)) & " : " & CStr(PerkArray(idx).Bonuses(j + 1)))
                ElseIf PerkArray(idx).Bonuses(j) >= 200 Then
                    s = AppendLine(s, attrNames(PerkArray(idx).Bonuses(j) - 200) & " : " & CStr(PerkArray(idx).Bonuses(j + 1)))
                ElseIf PerkArray(idx).Bonuses(j) = 100 Then
                    s = AppendLine(s, "Max HP : " & CStr(PerkArray(idx).Bonuses(j + 1)))
                ElseIf PerkArray(idx).Bonuses(j) = 101 Then
                    s = AppendLine(s, "Max NP : " & CStr(PerkArray(idx).Bonuses(j + 1)))
                End If
            End If
        Next
        If PerkArray(idx).PerkSpecial <> "" Then
            s = AppendLine(s, "[" & PerkArray(idx).PerkSpecial & "]")
        End If
        If s = "" Then
            s = "Perk has no relevant modifiers"
        End If
        Return s
    End Function

    Public Function ShowAIPerk(ByVal idx As Integer) As String
        Dim j As Integer
        Dim s As String = ""

        For j = 0 To NUM_BONUSES - 1 Step 2
            If AlienPerkArray(idx).Bonuses(j) <> -1 Then
                If AlienPerkArray(idx).Bonuses(j) < 100 Then
                    s = AppendLine(s, skillNames(AlienPerkArray(idx).Bonuses(j)) & " : " & CStr(AlienPerkArray(idx).Bonuses(j + 1)))
                ElseIf AlienPerkArray(idx).Bonuses(j) >= 200 Then
                    s = AppendLine(s, attrNames(AlienPerkArray(idx).Bonuses(j) - 200) & " : " & CStr(AlienPerkArray(idx).Bonuses(j + 1)))
                ElseIf AlienPerkArray(idx).Bonuses(j) = 100 Then
                    s = AppendLine(s, "Max HP : " & CStr(AlienPerkArray(idx).Bonuses(j + 1)))
                ElseIf AlienPerkArray(idx).Bonuses(j) = 101 Then
                    s = AppendLine(s, "Max NP : " & CStr(AlienPerkArray(idx).Bonuses(j + 1)))
                End If
            End If
        Next
        If AlienPerkArray(idx).PerkSpecial <> "" Then
            s = AppendLine(s, "[" & AlienPerkArray(idx).PerkSpecial & "]")
        End If
        If s = "" Then
            s = "Perk has no relevant modifiers"
        End If
        Return s
    End Function

    Public Function ShowResearch(ByVal idx As Integer) As String
        Dim j As Integer
        Dim s As String = ""

        For j = 0 To NUM_BONUSES - 1 Step 2
            If ResearchArray(idx).Bonuses(j) <> -1 And ResearchArray(idx).Bonuses(j + 1) > 0 Then
                If ResearchArray(idx).Bonuses(j) < 100 Then
                    s = AppendLine(s, skillNames(ResearchArray(idx).Bonuses(j)) & " : " & CStr(ResearchArray(idx).Bonuses(j + 1)))
                ElseIf ResearchArray(idx).Bonuses(j) >= 200 Then
                    s = AppendLine(s, attrNames(ResearchArray(idx).Bonuses(j) - 200) & " : " & CStr(ResearchArray(idx).Bonuses(j + 1)))
                ElseIf ResearchArray(idx).Bonuses(j) = 100 Then
                    s = AppendLine(s, "Max HP : " & CStr(ResearchArray(idx).Bonuses(j + 1)))
                ElseIf ResearchArray(idx).Bonuses(j) = 101 Then
                    s = AppendLine(s, "Max NP : " & CStr(ResearchArray(idx).Bonuses(j + 1)))
                End If
            End If
        Next
        If ResearchArray(idx).PerkSpecial <> "" Then
            s = AppendLine(s, "[" & ResearchArray(idx).PerkSpecial & "]")
        End If
        If s = "" Then
            s = "Perk has no relevant modifiers"
        End If
        Return s
    End Function

    Public Sub ClearPerks()
        Dim i As Integer
        Dim old_noRecalc As Boolean

        For i = 0 To NUM_PERKS
            PerkArray(i).Selected = False
        Next
        numPerks = 0
        For i = 0 To NUM_ALIEN_PERKS
            AlienPerkArray(i).Selected = False
        Next
        numAlienPerks = 0
        For i = 0 To NUM_RESEARCH
            ResearchArray(i).Selected = False
        Next
        numResearch = 0
        old_noRecalc = noRecalc
        noRecalc = True
        For i = 0 To NUM_ATTRS - 1
            attrCA.Item(i).Perk = 0
        Next
        For i = 0 To NUM_SKILLS - 1
            skillsCA.Item(i).Perk = 0
        Next
        hpCA.Perk = 0
        npCA.Perk = 0
        noRecalc = old_noRecalc
        updateCheckboxes()
        updateAICheckboxes()
        updateLECheckboxes()
        recalcIP()
        fmMain.updatePerks()
        ' TO DO: remove perk checkboxes here...
    End Sub

    Public Function GetPerkIndex(ByVal perk_name As String, ByVal perk_num As Integer) As Integer
        Dim i As Integer

        For i = 0 To NUM_PERKS
            If PerkArray(i).PerkName = perk_name And PerkArray(i).PerkNo = perk_num Then
                Return i
            End If
        Next
        Return -1
    End Function

    Public Function GetAlienPerkIndex(ByVal perk_name As String, ByVal perk_num As Integer) As Integer
        Dim i As Integer

        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).PerkName = perk_name And AlienPerkArray(i).PerkNo = perk_num Then
                Return i
            End If
        Next
        Return -1
    End Function

    Public Function GetResearchIndex(ByVal perk_name As String, ByVal perk_num As Integer) As Integer
        Dim i As Integer

        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).PerkName = perk_name And ResearchArray(i).PerkNo = perk_num Then
                Return i
            End If
        Next
        Return -1
    End Function

    Public Function GetPerksByProfAndBreed(ByVal pn As Integer, ByVal bn As Integer) As String()
        Dim i As Integer
        Dim perk_list As String = ""

        ' cope with first call when prof combo set...
        If bn = -1 Then
            Return Split("", "|")
        End If
        For i = 0 To NUM_PERKS
            If PerkArray(i).AllowedProfs(pn) = "y" And PerkArray(i).AllowedBreeds(bn) = "y" Then
                If InStr(perk_list, PerkArray(i).PerkName) = 0 Then
                    If Len(perk_list) = 0 Then
                        perk_list = perk_list & PerkArray(i).PerkName
                    Else
                        perk_list = perk_list & "|" & PerkArray(i).PerkName
                    End If
                End If
            End If
        Next
        Return Split(perk_list, "|")
    End Function

    Public Function GetAIPerksByProfAndBreed(ByVal pn As Integer, ByVal bn As Integer) As String()
        Dim i As Integer
        Dim perk_list As String = ""

        ' cope with first call when prof combo set...
        If bn = -1 Then
            Return Split("", "|")
        End If
        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).AllowedProfs(pn) = "y" And AlienPerkArray(i).AllowedBreeds(bn) = "y" Then
                If InStr(perk_list, AlienPerkArray(i).PerkName) = 0 Then
                    If Len(perk_list) = 0 Then
                        perk_list = perk_list & AlienPerkArray(i).PerkName
                    Else
                        perk_list = perk_list & "|" & AlienPerkArray(i).PerkName
                    End If
                End If
            End If
        Next
        Return Split(perk_list, "|")
    End Function

    Public Function GetResearchByProfAndBreed(ByVal pn As Integer, ByVal bn As Integer) As String()
        Dim i As Integer
        Dim perk_list As String = ""

        ' cope with first call when prof combo set...
        If bn = -1 Then
            Return Split("", "|")
        End If
        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).AllowedProfs(pn) = "y" And ResearchArray(i).AllowedBreeds(bn) = "y" Then
                If InStr(perk_list, ResearchArray(i).PerkName) = 0 Then
                    If Len(perk_list) = 0 Then
                        perk_list = perk_list & ResearchArray(i).PerkName
                    Else
                        perk_list = perk_list & "|" & ResearchArray(i).PerkName
                    End If
                End If
            End If
        Next
        Return Split(perk_list, "|")
    End Function

    Public Function GetNumberOfEntriesByPerk(ByVal perk As String) As Integer
        Dim i As Integer
        Dim cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_PERKS
            If PerkArray(i).PerkName = perk Then
                exit_flag = True
                cnt += 1
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return cnt
    End Function

    Public Function GetNumberOfEntriesByAIPerk(ByVal perk As String) As Integer
        Dim i As Integer
        Dim cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).PerkName = perk Then
                exit_flag = True
                cnt += 1
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return cnt
    End Function

    Public Function GetNumberOfEntriesByResearch(ByVal perk As String) As Integer
        Dim i As Integer
        Dim cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).PerkName = perk Then
                exit_flag = True
                cnt += 1
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return cnt
    End Function

    Public Function GetIndicesByPerk(ByVal perk As String) As Integer()
        Dim i As Integer
        Dim idx() As Integer = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_PERKS
            If PerkArray(i).PerkName = perk Then
                exit_flag = True
                idx(PostIncr(idx_cnt)) = i
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx
    End Function

    Public Function GetIndicesByAIPerk(ByVal perk As String) As Integer()
        Dim i As Integer
        Dim idx() As Integer = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).PerkName = perk Then
                exit_flag = True
                idx(PostIncr(idx_cnt)) = i
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx
    End Function

    Public Function GetIndicesByResearch(ByVal perk As String) As Integer()
        Dim i As Integer
        Dim idx() As Integer = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).PerkName = perk Then
                exit_flag = True
                idx(PostIncr(idx_cnt)) = i
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx
    End Function

    Public Function GetValidPerks(ByVal perk As String, ByVal lvl As Integer, ByVal prf As Integer, ByVal brd As Integer) As Integer()
        Dim i As Integer
        Dim vf() As Integer = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        Dim vf_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_PERKS
            If PerkArray(i).PerkName = perk Then
                exit_flag = True
                If lvl >= PerkArray(i).PerkLevel And PerkArray(i).AllowedProfs(prf) = "y" And PerkArray(i).AllowedBreeds(brd) = "y" Then
                    vf(PostIncr(vf_cnt)) = 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return vf
    End Function

    Public Function GetValidAIPerks(ByVal perk As String, ByVal lvl As Integer, ByVal prf As Integer, ByVal brd As Integer) As Integer()
        Dim i As Integer
        Dim vf() As Integer = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        Dim vf_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).PerkName = perk Then
                exit_flag = True
                If lvl >= AlienPerkArray(i).PerkLevel And AlienPerkArray(i).AllowedProfs(prf) = "y" And AlienPerkArray(i).AllowedBreeds(brd) = "y" Then
                    vf(PostIncr(vf_cnt)) = 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return vf
    End Function

    Public Function GetValidResearch(ByVal perk As String, ByVal lvl As Integer, ByVal prf As Integer, ByVal brd As Integer) As Integer()
        Dim i As Integer
        Dim vf() As Integer = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        Dim vf_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).PerkName = perk Then
                exit_flag = True
                If lvl >= ResearchArray(i).PerkLevel And ResearchArray(i).AllowedProfs(prf) = "y" And ResearchArray(i).AllowedBreeds(brd) = "y" Then
                    vf(PostIncr(vf_cnt)) = 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return vf
    End Function

    Public Function GetNumberOfPerks(ByVal lvl As Integer) As Integer
        If lvl <= 200 Then
            Return CInt(Math.Floor(lvl / 10))
        Else
            Return 20 + lvl - 200
        End If
    End Function

    Public Function GetNumberOfAIPerks(ByVal lvl As Integer) As Integer
        Return fmMain.NudAlienTitleValue
    End Function

    Public Sub updateCheckboxes()
        Dim np As Integer
        Dim ns As Integer
        Dim i As Integer
        Dim j As Integer
        Dim idx() As Integer
        Dim vf() As Integer
        Dim tchk As aoCheckBox
        Dim strName As String

        If suspendUpdatePerks Then
            Return
        End If
        If fmMain.lstPerks.SelectedIndex = -1 Then
            If Not (perkCA Is Nothing) Then
                Do While perkCA.Count > 0
                    perkCA.Remove()
                Loop
            End If
            updatePerkLabels()
            Return
        End If
        strName = GetPerkNamePart(CStr(fmMain.lstPerks.Items(fmMain.lstPerks.SelectedIndex)))
        ' extract number of perks from selected perk...
        np = GetNumberOfEntriesByPerk(strName)
        ns = CountSelectedPerks(strName)
        ' remove existing checkboxes
        fmMain.SuspendLayout()
        For i = 1 To numPerkCheckboxes
            perkCA.Remove()
        Next
        idx = GetIndicesByPerk(strName)
        vf = GetValidPerks(strName, fmMain.NudLevelValue, fmMain.ProfIndex, fmMain.BreedIndex)
        ' add new checkboxes ( @ 212,28 (first checkbox coors))
        For i = 1 To np
            tchk = perkCA.AddNewCHK(fmMain.tabPerks, PerkArray(idx(i - 1)).PerkName & " " & CStr(PerkArray(idx(i - 1)).PerkNo), idx(i - 1))
            tchk.Top = 24 + ((i - 1) * 26)
            tchk.Left = fmMain.lstPerks.Left + fmMain.lstPerks.Width + 20
            If vf(i - 1) = 0 Then
                If PerkArray(idx(i - 1)).Selected = True Then
                    RemPerk(idx(i - 1))
                End If
                tchk.Enabled = False
            Else
                tchk.Enabled = True
            End If
        Next
        numPerkCheckboxes = np
        ' clear checkboxes
        For j = 0 To numPerkCheckboxes - 1
            perkCA(j).chkControl.Checked = False
        Next
        ' populate values as needed from UserPerks array
        noRecalc = True
        For j = 0 To numPerkCheckboxes - 1
            If PerkArray(perkCA(j).ItemID).Selected = True Then
                perkCA(j).chkControl.Checked = True
            End If
        Next
        updatePerkLabels()
        noRecalc = False
        fmMain.ResumeLayout()
    End Sub

    Public Sub updateAICheckboxes()
        Dim np As Integer
        Dim i As Integer
        Dim j As Integer
        Dim idx() As Integer
        Dim vf() As Integer
        Dim tchk As aoCheckBoxAI
        Dim strName As String

        If suspendUpdatePerks Then
            Return
        End If
        If fmMain.lstAIPerks.SelectedIndex = -1 Then
            If Not (aiperkCA Is Nothing) Then
                Do While aiperkCA.Count > 0
                    aiperkCA.Remove()
                Loop
            End If
            updateAIPerkLabels()
            Return
        End If
        strName = GetPerkNamePart(CStr(fmMain.lstAIPerks.Items(fmMain.lstAIPerks.SelectedIndex)))
        ' extract number of perks from selected perk...
        np = GetNumberOfEntriesByAIPerk(strName)
        ' remove existing checkboxes
        fmMain.SuspendLayout()
        For i = 1 To numAIPerkCheckboxes
            aiperkCA.Remove()
        Next
        idx = GetIndicesByAIPerk(strName)
        vf = GetValidAIPerks(strName, fmMain.NudLevelValue, fmMain.ProfIndex, fmMain.BreedIndex)
        ' add new checkboxes ( @ 232,28 (first checkbox coors))
        For i = 1 To np
            tchk = aiperkCA.AddNewCHK(fmMain.tabAIPerks, AlienPerkArray(idx(i - 1)).PerkName & " " & CStr(AlienPerkArray(idx(i - 1)).PerkNo), idx(i - 1))
            tchk.Top = 24 + ((i - 1) * 26)
            tchk.Left = fmMain.lstAIPerks.Left + fmMain.lstAIPerks.Width + 20
            If vf(i - 1) = 0 Then
                If AlienPerkArray(idx(i - 1)).Selected = True Then
                    RemAlienPerk(idx(i - 1))
                End If
                tchk.Enabled = False
            Else
                tchk.Enabled = True
            End If
        Next
        numAIPerkCheckboxes = np
        ' clear checkboxes
        For j = 0 To numAIPerkCheckboxes - 1
            aiperkCA(j).chkControl.Checked = False
        Next
        ' populate values as needed from UserPerks array
        noRecalc = True
        For j = 0 To numAIPerkCheckboxes - 1
            If AlienPerkArray(aiperkCA(j).ItemID).Selected = True Then
                aiperkCA(j).chkControl.Checked = True
            End If
        Next
        updateAIPerkLabels()
        noRecalc = False
        fmMain.ResumeLayout()
    End Sub

    Public Sub updateLECheckboxes()
        Dim np As Integer
        Dim i As Integer
        Dim j As Integer
        Dim idx() As Integer
        Dim vf() As Integer
        Dim tchk As aoCheckBoxLE
        Dim strName As String

        If suspendUpdatePerks Then
            Return
        End If
        If fmMain.lstResearch.SelectedIndex = -1 Then
            If Not (researchCA Is Nothing) Then
                Do While researchCA.Count > 0
                    researchCA.Remove()
                Loop
            End If
            updateResearchLabels()
            Return
        End If
        strName = GetPerkNamePart(CStr(fmMain.lstResearch.Items(fmMain.lstResearch.SelectedIndex)))
        ' extract number of perks from selected perk...
        np = GetNumberOfEntriesByResearch(strName)
        ' remove existing checkboxes
        fmMain.SuspendLayout()
        For i = 1 To numResearchCheckboxes
            researchCA.Remove()
        Next
        idx = GetIndicesByResearch(strName)
        vf = GetValidResearch(strName, fmMain.NudLevelValue, fmMain.ProfIndex, fmMain.BreedIndex)
        ' add new checkboxes ( @ 232,28 (first checkbox coors))
        For i = 1 To np
            tchk = researchCA.AddNewCHK(fmMain.tabResearch, ResearchArray(idx(i - 1)).PerkName & " " & CStr(ResearchArray(idx(i - 1)).PerkNo), idx(i - 1))
            tchk.Top = 24 + ((i - 1) * 26)
            tchk.Left = fmMain.lstResearch.Left + fmMain.lstResearch.Width + 20
            If vf(i - 1) = 0 Then
                If ResearchArray(idx(i - 1)).Selected = True Then
                    RemResearch(idx(i - 1))
                End If
                tchk.Enabled = False
            Else
                tchk.Enabled = True
            End If
        Next
        numResearchCheckboxes = np
        ' clear checkboxes
        For j = 0 To numResearchCheckboxes - 1
            researchCA(j).chkControl.Checked = False
        Next
        ' populate values as needed from UserPerks array
        noRecalc = True
        For j = 0 To numResearchCheckboxes - 1
            If ResearchArray(researchCA(j).ItemID).Selected = True Then
                researchCA(j).chkControl.Checked = True
            End If
        Next
        updateResearchLabels()
        noRecalc = False
        fmMain.ResumeLayout()
    End Sub

    Function PostIncr(ByRef n As Integer) As Integer
        Dim old_n As Integer
        old_n = n
        n += 1
        Return old_n
    End Function

    Public Function loadPerksFromXML(ByVal file_name As String, ByVal working_array() As Perks) As Integer
        Dim rdr As Xml.XmlTextReader
        Dim node_name As String = ""
        Dim bonus_id As Integer
        Dim num As Integer
        Dim name As String
        Dim level As Integer
        Dim profs As String
        Dim breeds As String
        Dim bonuses(NUM_BONUSES) As Integer
        Dim special As String

        Dim tmp As String

        Dim noError As Boolean = True

        Dim i As Integer

        Dim n As Integer = 0

        For i = 0 To NUM_BONUSES - 1
            bonuses(i) = -1
        Next

        Try
            rdr = New Xml.XmlTextReader(file_name)
            Do While rdr.Read()
                Select Case rdr.NodeType
                    Case Xml.XmlNodeType.Element
                        Select Case rdr.Name
                            Case "PERK"
                                num = CInt(rdr.GetAttribute("NUM"))
                                name = rdr.GetAttribute("NAME")
                            Case "BONUS"
                                bonus_id = CInt(rdr.GetAttribute("ID"))
                        End Select
                        node_name = rdr.Name
                    Case Xml.XmlNodeType.Text
                        Select Case node_name
                            Case "LEVEL"
                                level = CInt(rdr.Value)
                            Case "PROFS"
                                profs = rdr.Value
                            Case "BREEDS"
                                breeds = rdr.Value
                            Case "BONUS"
                                tmp = rdr.Value
                                bonuses(bonus_id * 2) = CInt(Left(tmp, InStr(tmp, "/") - 1))
                                bonuses((bonus_id * 2) + 1) = CInt(Mid(tmp, InStr(tmp, "/") + 1))
                            Case "SPECIAL"
                                special = rdr.Value
                        End Select
                    Case Xml.XmlNodeType.EndElement
                        Select Case rdr.Name
                            Case "PERK"
                                working_array(PostIncr(n)) = New Perks(name, num, level, profs, breeds, bonuses, special)
                                special = ""
                                For i = 0 To NUM_BONUSES - 1
                                    bonuses(i) = -1
                                Next
                            Case "PERKLIST"
                                Exit Do
                        End Select
                End Select
            Loop
        Catch
            noError = False
            MsgBox("There was a problem loading the perk data file (" & file_name & "), aborting.", CType(MsgBoxStyle.Critical + MsgBoxStyle.OKOnly, Microsoft.VisualBasic.MsgBoxStyle), "File Open Error")
            End
        Finally
            If Not (rdr Is Nothing) Then
                rdr.Close()
            End If
        End Try
        ReDim Preserve working_array(n - 1)
        Return n - 1
    End Function

    Public Function CountSelectedPerks(ByVal perk As String) As Integer
        Dim i As Integer
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_PERKS
            If PerkArray(i).PerkName = perk Then
                exit_flag = True
                If PerkArray(i).Selected Then
                    idx_cnt += 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx_cnt
    End Function

    Public Function CountSelectedAIPerks(ByVal perk As String) As Integer
        Dim i As Integer
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_ALIEN_PERKS
            If AlienPerkArray(i).PerkName = perk Then
                exit_flag = True
                If AlienPerkArray(i).Selected Then
                    idx_cnt += 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx_cnt
    End Function

    Public Function CountSelectedLEPerks(ByVal perk As String) As Integer
        Dim i As Integer
        Dim idx_cnt As Integer = 0
        Dim exit_flag As Boolean = False

        For i = 0 To NUM_RESEARCH
            If ResearchArray(i).PerkName = perk Then
                exit_flag = True
                If ResearchArray(i).Selected Then
                    idx_cnt += 1
                End If
            Else
                If exit_flag = True Then
                    Exit For
                End If
            End If
        Next
        Return idx_cnt
    End Function

    Public Function GetPerkNamePart(strItem As String) As String
        Dim intPos As Integer
        Dim strName As String

        intPos = strItem.IndexOf(" (")
        If intPos > 0 Then
            strName = strItem.SubString(0, intPos)
        Else
            strName = strItem
        End If
        Return strName
    End Function

    Public Function ConstructPerkListName(strItem As String, intSelected As Integer, intTotal As Integer) As String
        Dim strName As String

        strName = strItem & " (" & CStr(intSelected).Trim() & "/" & CStr(intTotal).Trim() & ")"
        Return strName
    End Function

    Public Sub updatePerkLabel(ByVal intIndex As Integer)
        Dim strPerkName As String
        Dim numPerks As Integer
        Dim numSelectedPerks As Integer

        strPerkName = GetPerkNamePart(CStr(fmMain.lstPerks.Items(intIndex)))
        numPerks = GetNumberOfEntriesByPerk(strPerkName)
        numSelectedPerks = CountSelectedPerks(strPerkName)
        strPerkName = ConstructPerkListName(strPerkName, numSelectedPerks, numPerks)
        suspendUpdatePerks = True
        fmMain.lstPerks.Items(intIndex) = strPerkName
        suspendUpdatePerks = False
    End Sub

    Public Sub updateAIPerkLabel(ByVal intIndex As Integer)
        Dim strPerkName As String
        Dim numPerks As Integer
        Dim numSelectedPerks As Integer

        strPerkName = GetPerkNamePart(CStr(fmMain.lstAIPerks.Items(intIndex)))
        numPerks = GetNumberOfEntriesByAIPerk(strPerkName)
        numSelectedPerks = CountSelectedAIPerks(strPerkName)
        strPerkName = ConstructPerkListName(strPerkName, numSelectedPerks, numPerks)
        suspendUpdatePerks = True
        fmMain.lstAIPerks.Items(intIndex) = strPerkName
        suspendUpdatePerks = False
    End Sub

    Public Sub updateLEPerkLabel(ByVal intIndex As Integer)
        Dim strPerkName As String
        Dim numPerks As Integer
        Dim numSelectedPerks As Integer

        strPerkName = GetPerkNamePart(CStr(fmMain.lstResearch.Items(intIndex)))
        numPerks = GetNumberOfEntriesByResearch(strPerkName)
        numSelectedPerks = CountSelectedLEPerks(strPerkName)
        strPerkName = ConstructPerkListName(strPerkName, numSelectedPerks, numPerks)
        suspendUpdatePerks = True
        fmMain.lstResearch.Items(intIndex) = strPerkName
        suspendUpdatePerks = False
    End Sub

    Private Sub updatePerkLabels()
        Dim intIndex As Integer
        Dim intCount As Integer

        intCount = fmMain.lstPerks.Items.Count - 1
        For intIndex = 0 To intCount
            updatePerkLabel(intIndex)
        Next
    End Sub

    Private Sub updateAIPerkLabels()
        Dim intIndex As Integer
        Dim intCount As Integer

        intCount = fmMain.lstAIPerks.Items.Count - 1
        For intIndex = 0 To intCount
            updateAIPerkLabel(intIndex)
        Next
    End Sub

    Private Sub updateResearchLabels()
        Dim intIndex As Integer
        Dim intCount As Integer

        intCount = fmMain.lstResearch.Items.Count - 1
        For intIndex = 0 To intCount
            updateLEPerkLabel(intIndex)
        Next
    End Sub

End Module
