'Copyright (c) 2005-2013 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Data
Imports System.Drawing
Imports System.Drawing.Printing
Imports System.Windows.Forms
Imports System.Collections
Imports Microsoft.VisualBasic

Public Class frmMain : Inherits Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        dbPath = CurDir()
        If Not openConnection(dbPath) Then
            MsgBox("Unable to open database, check ihData.db is in same folder as this program", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly, My.Application.Info.Title)
            End
        End If

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
            closeConnection()
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents mainMenu As System.Windows.Forms.MainMenu
    Friend WithEvents mmiFile As System.Windows.Forms.MenuItem
    Friend WithEvents miNew As System.Windows.Forms.MenuItem
    Friend WithEvents miSeperator1 As System.Windows.Forms.MenuItem
    Friend WithEvents miOpen As System.Windows.Forms.MenuItem
    Friend WithEvents miOpenIM As System.Windows.Forms.MenuItem
    Friend WithEvents miSeperator2 As System.Windows.Forms.MenuItem
    Friend WithEvents miSave As System.Windows.Forms.MenuItem
    Friend WithEvents miSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents miSaveAsAOSkills As System.Windows.Forms.MenuItem
    Friend WithEvents miSeperator3 As System.Windows.Forms.MenuItem
    Friend WithEvents miPrintPreview As System.Windows.Forms.MenuItem
    Friend WithEvents miPrint As System.Windows.Forms.MenuItem
    Friend WithEvents miSeperator4 As System.Windows.Forms.MenuItem
    Friend WithEvents miExit As System.Windows.Forms.MenuItem
    Friend WithEvents mmiEdit As System.Windows.Forms.MenuItem
    Friend WithEvents miSetQL1 As System.Windows.Forms.MenuItem
    Friend WithEvents miSetQL100 As System.Windows.Forms.MenuItem
    Friend WithEvents miSetQL200 As System.Windows.Forms.MenuItem
    Friend WithEvents miSetQL250 As System.Windows.Forms.MenuItem
    Friend WithEvents miSetQL300 As System.Windows.Forms.MenuItem
    Friend WithEvents miSeperator5 As System.Windows.Forms.MenuItem
    Friend WithEvents miAllImplants As System.Windows.Forms.MenuItem
    Friend WithEvents miAllSymbs As System.Windows.Forms.MenuItem
    Friend WithEvents mmiHelp As System.Windows.Forms.MenuItem
    Friend WithEvents miAbout As System.Windows.Forms.MenuItem
    Friend WithEvents fdOpen As System.Windows.Forms.OpenFileDialog
    Friend WithEvents fdSave As System.Windows.Forms.SaveFileDialog
    Friend WithEvents fdSaveAOSkills As System.Windows.Forms.SaveFileDialog
    Friend WithEvents fdOpenIM As System.Windows.Forms.OpenFileDialog
    Friend WithEvents sePrintDocument As System.Drawing.Printing.PrintDocument
    Friend WithEvents tpImplants As System.Windows.Forms.TabPage
    Friend WithEvents cmdSet As System.Windows.Forms.Button
    Friend WithEvents lblHAbility As System.Windows.Forms.Label
    Friend WithEvents lblFind As System.Windows.Forms.Label
    Friend WithEvents cmdBuild As System.Windows.Forms.Button
    Friend WithEvents cmbProfession As System.Windows.Forms.ComboBox
    Friend WithEvents cmbFind As System.Windows.Forms.ComboBox
    Friend WithEvents lblProfession As System.Windows.Forms.Label
    Friend WithEvents cmdSetQL As System.Windows.Forms.Button
    Friend WithEvents nudSetQL As System.Windows.Forms.NumericUpDown
    Friend WithEvents lblHQL As System.Windows.Forms.Label
    Friend WithEvents lblHFaded As System.Windows.Forms.Label
    Friend WithEvents lblHBright As System.Windows.Forms.Label
    Friend WithEvents lblHShiny As System.Windows.Forms.Label
    Friend WithEvents lblHType As System.Windows.Forms.Label
    Friend WithEvents lblFeet As System.Windows.Forms.Label
    Friend WithEvents lblRHand As System.Windows.Forms.Label
    Friend WithEvents lblLegs As System.Windows.Forms.Label
    Friend WithEvents lblLHand As System.Windows.Forms.Label
    Friend WithEvents lblRWrist As System.Windows.Forms.Label
    Friend WithEvents lblWaist As System.Windows.Forms.Label
    Friend WithEvents lblLWrist As System.Windows.Forms.Label
    Friend WithEvents lblEar As System.Windows.Forms.Label
    Friend WithEvents lblChest As System.Windows.Forms.Label
    Friend WithEvents lblLArm As System.Windows.Forms.Label
    Friend WithEvents lblRArm As System.Windows.Forms.Label
    Friend WithEvents lblHead As System.Windows.Forms.Label
    Friend WithEvents lblEye As System.Windows.Forms.Label
    Friend WithEvents tpBenefits As System.Windows.Forms.TabPage
    Friend WithEvents lstBenefits As System.Windows.Forms.ListBox
    Friend WithEvents tpRequirements As System.Windows.Forms.TabPage
    Friend WithEvents tpSuggest As System.Windows.Forms.TabPage
    Friend WithEvents cmdSuggest As System.Windows.Forms.Button
    Friend WithEvents gbSuggest As System.Windows.Forms.GroupBox
    Friend WithEvents chkSuggestStr As System.Windows.Forms.CheckBox
    Friend WithEvents chkSuggestAgl As System.Windows.Forms.CheckBox
    Friend WithEvents chkSuggestSta As System.Windows.Forms.CheckBox
    Friend WithEvents chkSuggestInt As System.Windows.Forms.CheckBox
    Friend WithEvents chkSuggestSen As System.Windows.Forms.CheckBox
    Friend WithEvents chkSuggestPsy As System.Windows.Forms.CheckBox
    Friend WithEvents tpShopping As System.Windows.Forms.TabPage
    Friend WithEvents lblFaded As System.Windows.Forms.Label
    Friend WithEvents lblBright As System.Windows.Forms.Label
    Friend WithEvents lblShiny As System.Windows.Forms.Label
    Friend WithEvents tcMain As System.Windows.Forms.TabControl
    Friend WithEvents lblQL As System.Windows.Forms.Label
    Friend WithEvents lvReqs As System.Windows.Forms.ListView
    Friend WithEvents chSlot As System.Windows.Forms.ColumnHeader
    Friend WithEvents chTreatment As System.Windows.Forms.ColumnHeader
    Friend WithEvents chLevel As System.Windows.Forms.ColumnHeader
    Friend WithEvents chAbilities As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBuild As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvBenefit1 As System.Windows.Forms.ListView
    Friend WithEvents lvBenefit2 As System.Windows.Forms.ListView
    Friend WithEvents lvBenefit3 As System.Windows.Forms.ListView
    Friend WithEvents chBenefits1A As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBenefits1B As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBenefits2A As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBenefits2B As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBenefits3A As System.Windows.Forms.ColumnHeader
    Friend WithEvents chBenefits3B As System.Windows.Forms.ColumnHeader
    Friend WithEvents lvSuggest As System.Windows.Forms.ListView
    Friend WithEvents chSuggestCluster As System.Windows.Forms.ColumnHeader
    Friend WithEvents chSuggestSlot As System.Windows.Forms.ColumnHeader
    Friend WithEvents chSuggestClusterType As System.Windows.Forms.ColumnHeader
    Friend WithEvents lblSuggestInfo As System.Windows.Forms.Label
    Friend WithEvents cmdSelect As System.Windows.Forms.Button
    Friend WithEvents lblName As System.Windows.Forms.Label
    Friend WithEvents chResultantAbility As System.Windows.Forms.ColumnHeader
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(frmMain))
        Me.mainMenu = New System.Windows.Forms.MainMenu(Me.components)
        Me.mmiFile = New System.Windows.Forms.MenuItem()
        Me.miNew = New System.Windows.Forms.MenuItem()
        Me.miSeperator1 = New System.Windows.Forms.MenuItem()
        Me.miOpen = New System.Windows.Forms.MenuItem()
        Me.miOpenIM = New System.Windows.Forms.MenuItem()
        Me.miSeperator2 = New System.Windows.Forms.MenuItem()
        Me.miSave = New System.Windows.Forms.MenuItem()
        Me.miSaveAs = New System.Windows.Forms.MenuItem()
        Me.miSaveAsAOSkills = New System.Windows.Forms.MenuItem()
        Me.miSeperator3 = New System.Windows.Forms.MenuItem()
        Me.miPrintPreview = New System.Windows.Forms.MenuItem()
        Me.miPrint = New System.Windows.Forms.MenuItem()
        Me.miSeperator4 = New System.Windows.Forms.MenuItem()
        Me.miExit = New System.Windows.Forms.MenuItem()
        Me.mmiEdit = New System.Windows.Forms.MenuItem()
        Me.miSetQL1 = New System.Windows.Forms.MenuItem()
        Me.miSetQL100 = New System.Windows.Forms.MenuItem()
        Me.miSetQL200 = New System.Windows.Forms.MenuItem()
        Me.miSetQL250 = New System.Windows.Forms.MenuItem()
        Me.miSetQL300 = New System.Windows.Forms.MenuItem()
        Me.miSeperator5 = New System.Windows.Forms.MenuItem()
        Me.miAllImplants = New System.Windows.Forms.MenuItem()
        Me.miAllSymbs = New System.Windows.Forms.MenuItem()
        Me.mmiHelp = New System.Windows.Forms.MenuItem()
        Me.miAbout = New System.Windows.Forms.MenuItem()
        Me.fdOpen = New System.Windows.Forms.OpenFileDialog()
        Me.fdSave = New System.Windows.Forms.SaveFileDialog()
        Me.fdSaveAOSkills = New System.Windows.Forms.SaveFileDialog()
        Me.sePrintDocument = New System.Drawing.Printing.PrintDocument()
        Me.tpImplants = New System.Windows.Forms.TabPage()
        Me.lblQL = New System.Windows.Forms.Label()
        Me.cmdSet = New System.Windows.Forms.Button()
        Me.lblHAbility = New System.Windows.Forms.Label()
        Me.lblFind = New System.Windows.Forms.Label()
        Me.cmdBuild = New System.Windows.Forms.Button()
        Me.cmbProfession = New System.Windows.Forms.ComboBox()
        Me.cmbFind = New System.Windows.Forms.ComboBox()
        Me.lblProfession = New System.Windows.Forms.Label()
        Me.cmdSetQL = New System.Windows.Forms.Button()
        Me.nudSetQL = New System.Windows.Forms.NumericUpDown()
        Me.lblHQL = New System.Windows.Forms.Label()
        Me.lblHFaded = New System.Windows.Forms.Label()
        Me.lblHBright = New System.Windows.Forms.Label()
        Me.lblHShiny = New System.Windows.Forms.Label()
        Me.lblHType = New System.Windows.Forms.Label()
        Me.lblFeet = New System.Windows.Forms.Label()
        Me.lblRHand = New System.Windows.Forms.Label()
        Me.lblLegs = New System.Windows.Forms.Label()
        Me.lblLHand = New System.Windows.Forms.Label()
        Me.lblRWrist = New System.Windows.Forms.Label()
        Me.lblWaist = New System.Windows.Forms.Label()
        Me.lblLWrist = New System.Windows.Forms.Label()
        Me.lblEar = New System.Windows.Forms.Label()
        Me.lblChest = New System.Windows.Forms.Label()
        Me.lblLArm = New System.Windows.Forms.Label()
        Me.lblRArm = New System.Windows.Forms.Label()
        Me.lblHead = New System.Windows.Forms.Label()
        Me.lblEye = New System.Windows.Forms.Label()
        Me.tpBenefits = New System.Windows.Forms.TabPage()
        Me.lvBenefit3 = New System.Windows.Forms.ListView()
        Me.chBenefits3A = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chBenefits3B = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.lvBenefit2 = New System.Windows.Forms.ListView()
        Me.chBenefits2A = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chBenefits2B = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.lvBenefit1 = New System.Windows.Forms.ListView()
        Me.chBenefits1A = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chBenefits1B = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.lstBenefits = New System.Windows.Forms.ListBox()
        Me.tpRequirements = New System.Windows.Forms.TabPage()
        Me.lvReqs = New System.Windows.Forms.ListView()
        Me.chSlot = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chTreatment = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chLevel = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chAbilities = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chBuild = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.tpSuggest = New System.Windows.Forms.TabPage()
        Me.lblSuggestInfo = New System.Windows.Forms.Label()
        Me.lvSuggest = New System.Windows.Forms.ListView()
        Me.chSuggestSlot = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chSuggestClusterType = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chSuggestCluster = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.chResultantAbility = CType(New System.Windows.Forms.ColumnHeader(), System.Windows.Forms.ColumnHeader)
        Me.cmdSuggest = New System.Windows.Forms.Button()
        Me.gbSuggest = New System.Windows.Forms.GroupBox()
        Me.chkSuggestStr = New System.Windows.Forms.CheckBox()
        Me.chkSuggestAgl = New System.Windows.Forms.CheckBox()
        Me.chkSuggestSta = New System.Windows.Forms.CheckBox()
        Me.chkSuggestInt = New System.Windows.Forms.CheckBox()
        Me.chkSuggestSen = New System.Windows.Forms.CheckBox()
        Me.chkSuggestPsy = New System.Windows.Forms.CheckBox()
        Me.cmdSelect = New System.Windows.Forms.Button()
        Me.tpShopping = New System.Windows.Forms.TabPage()
        Me.lblName = New System.Windows.Forms.Label()
        Me.lblFaded = New System.Windows.Forms.Label()
        Me.lblBright = New System.Windows.Forms.Label()
        Me.lblShiny = New System.Windows.Forms.Label()
        Me.tcMain = New System.Windows.Forms.TabControl()
        Me.fdOpenIM = New System.Windows.Forms.OpenFileDialog()
        Me.tpImplants.SuspendLayout()
        CType(Me.nudSetQL, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.tpBenefits.SuspendLayout()
        Me.tpRequirements.SuspendLayout()
        Me.tpSuggest.SuspendLayout()
        Me.gbSuggest.SuspendLayout()
        Me.tpShopping.SuspendLayout()
        Me.tcMain.SuspendLayout()
        Me.SuspendLayout()
        '
        'mainMenu
        '
        Me.mainMenu.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mmiFile, Me.mmiEdit, Me.mmiHelp})
        '
        'mmiFile
        '
        Me.mmiFile.Index = 0
        Me.mmiFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miNew, Me.miSeperator1, Me.miOpen, Me.miOpenIM, Me.miSeperator2, Me.miSave, Me.miSaveAs, Me.miSaveAsAOSkills, Me.miSeperator3, Me.miPrintPreview, Me.miPrint, Me.miSeperator4, Me.miExit})
        Me.mmiFile.Text = "&File"
        '
        'miNew
        '
        Me.miNew.Index = 0
        Me.miNew.Text = "&New"
        '
        'miSeperator1
        '
        Me.miSeperator1.Index = 1
        Me.miSeperator1.Text = "-"
        '
        'miOpen
        '
        Me.miOpen.Index = 2
        Me.miOpen.Text = "&Open..."
        '
        'miOpenIM
        '
        Me.miOpenIM.Index = 3
        Me.miOpenIM.Text = "Open &IMatrix..."
        '
        'miSeperator2
        '
        Me.miSeperator2.Index = 4
        Me.miSeperator2.Text = "-"
        '
        'miSave
        '
        Me.miSave.Index = 5
        Me.miSave.Text = "&Save"
        '
        'miSaveAs
        '
        Me.miSaveAs.Index = 6
        Me.miSaveAs.Text = "Save &As..."
        '
        'miSaveAsAOSkills
        '
        Me.miSaveAsAOSkills.Enabled = False
        Me.miSaveAsAOSkills.Index = 7
        Me.miSaveAsAOSkills.Text = "Save As AOSkills..."
        '
        'miSeperator3
        '
        Me.miSeperator3.Index = 8
        Me.miSeperator3.Text = "-"
        '
        'miPrintPreview
        '
        Me.miPrintPreview.Index = 9
        Me.miPrintPreview.Text = "Print Pre&view..."
        '
        'miPrint
        '
        Me.miPrint.Index = 10
        Me.miPrint.Text = "&Print..."
        '
        'miSeperator4
        '
        Me.miSeperator4.Index = 11
        Me.miSeperator4.Text = "-"
        '
        'miExit
        '
        Me.miExit.Index = 12
        Me.miExit.Text = "E&xit"
        '
        'mmiEdit
        '
        Me.mmiEdit.Index = 1
        Me.mmiEdit.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miSetQL1, Me.miSetQL100, Me.miSetQL200, Me.miSetQL250, Me.miSetQL300, Me.miSeperator5, Me.miAllImplants, Me.miAllSymbs})
        Me.mmiEdit.Text = "&Edit"
        '
        'miSetQL1
        '
        Me.miSetQL1.Index = 0
        Me.miSetQL1.Text = "Set To QL 1"
        '
        'miSetQL100
        '
        Me.miSetQL100.Index = 1
        Me.miSetQL100.Text = "Set To QL 100"
        '
        'miSetQL200
        '
        Me.miSetQL200.Index = 2
        Me.miSetQL200.Text = "Set To QL 200"
        '
        'miSetQL250
        '
        Me.miSetQL250.Index = 3
        Me.miSetQL250.Text = "Set To QL 250"
        '
        'miSetQL300
        '
        Me.miSetQL300.Index = 4
        Me.miSetQL300.Text = "Set To QL 300"
        '
        'miSeperator5
        '
        Me.miSeperator5.Index = 5
        Me.miSeperator5.Text = "-"
        '
        'miAllImplants
        '
        Me.miAllImplants.Index = 6
        Me.miAllImplants.Text = "All &Implants"
        '
        'miAllSymbs
        '
        Me.miAllSymbs.Enabled = False
        Me.miAllSymbs.Index = 7
        Me.miAllSymbs.Text = "All &Symbs/Spirits"
        '
        'mmiHelp
        '
        Me.mmiHelp.Index = 2
        Me.mmiHelp.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.miAbout})
        Me.mmiHelp.Text = "&Help"
        '
        'miAbout
        '
        Me.miAbout.Index = 0
        Me.miAbout.Text = "&About"
        '
        'fdOpen
        '
        Me.fdOpen.DefaultExt = "ih"
        Me.fdOpen.Filter = "implantHelper Files (*.ih)|*.ih"
        Me.fdOpen.InitialDirectory = "implant_layouts"
        Me.fdOpen.RestoreDirectory = True
        '
        'fdSave
        '
        Me.fdSave.DefaultExt = "ih"
        Me.fdSave.Filter = "implantHelper Files (*.ih)|*.ih"
        Me.fdSave.InitialDirectory = "implant_layouts"
        Me.fdSave.RestoreDirectory = True
        '
        'fdSaveAOSkills
        '
        Me.fdSaveAOSkills.DefaultExt = "imps"
        Me.fdSaveAOSkills.Filter = "Character Implants File|*.imps"
        Me.fdSaveAOSkills.InitialDirectory = "implants"
        Me.fdSaveAOSkills.RestoreDirectory = True
        '
        'sePrintDocument
        '
        '
        'tpImplants
        '
        Me.tpImplants.Controls.Add(Me.lblQL)
        Me.tpImplants.Controls.Add(Me.cmdSet)
        Me.tpImplants.Controls.Add(Me.lblHAbility)
        Me.tpImplants.Controls.Add(Me.lblFind)
        Me.tpImplants.Controls.Add(Me.cmdBuild)
        Me.tpImplants.Controls.Add(Me.cmbProfession)
        Me.tpImplants.Controls.Add(Me.cmbFind)
        Me.tpImplants.Controls.Add(Me.lblProfession)
        Me.tpImplants.Controls.Add(Me.cmdSetQL)
        Me.tpImplants.Controls.Add(Me.nudSetQL)
        Me.tpImplants.Controls.Add(Me.lblHQL)
        Me.tpImplants.Controls.Add(Me.lblHFaded)
        Me.tpImplants.Controls.Add(Me.lblHBright)
        Me.tpImplants.Controls.Add(Me.lblHShiny)
        Me.tpImplants.Controls.Add(Me.lblHType)
        Me.tpImplants.Controls.Add(Me.lblFeet)
        Me.tpImplants.Controls.Add(Me.lblRHand)
        Me.tpImplants.Controls.Add(Me.lblLegs)
        Me.tpImplants.Controls.Add(Me.lblLHand)
        Me.tpImplants.Controls.Add(Me.lblRWrist)
        Me.tpImplants.Controls.Add(Me.lblWaist)
        Me.tpImplants.Controls.Add(Me.lblLWrist)
        Me.tpImplants.Controls.Add(Me.lblEar)
        Me.tpImplants.Controls.Add(Me.lblChest)
        Me.tpImplants.Controls.Add(Me.lblLArm)
        Me.tpImplants.Controls.Add(Me.lblRArm)
        Me.tpImplants.Controls.Add(Me.lblHead)
        Me.tpImplants.Controls.Add(Me.lblEye)
        Me.tpImplants.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpImplants.Location = New System.Drawing.Point(4, 24)
        Me.tpImplants.Name = "tpImplants"
        Me.tpImplants.Size = New System.Drawing.Size(776, 488)
        Me.tpImplants.TabIndex = 0
        Me.tpImplants.Text = "Implants"
        '
        'lblQL
        '
        Me.lblQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblQL.Location = New System.Drawing.Point(643, 456)
        Me.lblQL.Name = "lblQL"
        Me.lblQL.Size = New System.Drawing.Size(29, 24)
        Me.lblQL.TabIndex = 27
        Me.lblQL.Text = "QL"
        '
        'cmdSet
        '
        Me.cmdSet.BackColor = System.Drawing.Color.Gray
        Me.cmdSet.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdSet.ForeColor = System.Drawing.Color.White
        Me.cmdSet.Location = New System.Drawing.Point(472, 456)
        Me.cmdSet.Name = "cmdSet"
        Me.cmdSet.Size = New System.Drawing.Size(40, 24)
        Me.cmdSet.TabIndex = 3
        Me.cmdSet.Text = "Set"
        Me.cmdSet.UseVisualStyleBackColor = False
        '
        'lblHAbility
        '
        Me.lblHAbility.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHAbility.Location = New System.Drawing.Point(728, 8)
        Me.lblHAbility.Name = "lblHAbility"
        Me.lblHAbility.Size = New System.Drawing.Size(48, 24)
        Me.lblHAbility.TabIndex = 26
        Me.lblHAbility.Text = "Ability"
        '
        'lblFind
        '
        Me.lblFind.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFind.Location = New System.Drawing.Point(238, 456)
        Me.lblFind.Name = "lblFind"
        Me.lblFind.Size = New System.Drawing.Size(42, 24)
        Me.lblFind.TabIndex = 25
        Me.lblFind.Text = "Find"
        '
        'cmdBuild
        '
        Me.cmdBuild.BackColor = System.Drawing.Color.LimeGreen
        Me.cmdBuild.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdBuild.ForeColor = System.Drawing.Color.FromArgb(CType(CType(0, Byte), Integer), CType(CType(64, Byte), Integer), CType(CType(0, Byte), Integer))
        Me.cmdBuild.Location = New System.Drawing.Point(536, 456)
        Me.cmdBuild.Name = "cmdBuild"
        Me.cmdBuild.Size = New System.Drawing.Size(88, 24)
        Me.cmdBuild.TabIndex = 4
        Me.cmdBuild.Text = "&Build >>"
        Me.cmdBuild.UseVisualStyleBackColor = False
        '
        'cmbProfession
        '
        Me.cmbProfession.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbProfession.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbProfession.ItemHeight = 16
        Me.cmbProfession.Location = New System.Drawing.Point(88, 456)
        Me.cmbProfession.MaxDropDownItems = 14
        Me.cmbProfession.Name = "cmbProfession"
        Me.cmbProfession.Size = New System.Drawing.Size(144, 24)
        Me.cmbProfession.TabIndex = 1
        '
        'cmbFind
        '
        Me.cmbFind.BackColor = System.Drawing.SystemColors.Window
        Me.cmbFind.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cmbFind.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmbFind.ItemHeight = 16
        Me.cmbFind.Location = New System.Drawing.Point(280, 456)
        Me.cmbFind.MaxDropDownItems = 16
        Me.cmbFind.Name = "cmbFind"
        Me.cmbFind.Size = New System.Drawing.Size(192, 24)
        Me.cmbFind.TabIndex = 2
        '
        'lblProfession
        '
        Me.lblProfession.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblProfession.Location = New System.Drawing.Point(8, 456)
        Me.lblProfession.Name = "lblProfession"
        Me.lblProfession.Size = New System.Drawing.Size(80, 24)
        Me.lblProfession.TabIndex = 23
        Me.lblProfession.Text = "Profession"
        '
        'cmdSetQL
        '
        Me.cmdSetQL.BackColor = System.Drawing.Color.Gray
        Me.cmdSetQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdSetQL.ForeColor = System.Drawing.Color.White
        Me.cmdSetQL.Location = New System.Drawing.Point(720, 456)
        Me.cmdSetQL.Name = "cmdSetQL"
        Me.cmdSetQL.Size = New System.Drawing.Size(40, 24)
        Me.cmdSetQL.TabIndex = 6
        Me.cmdSetQL.Text = "Set"
        Me.cmdSetQL.UseVisualStyleBackColor = False
        '
        'nudSetQL
        '
        Me.nudSetQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.nudSetQL.Location = New System.Drawing.Point(672, 456)
        Me.nudSetQL.Maximum = New Decimal(New Integer() {300, 0, 0, 0})
        Me.nudSetQL.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.nudSetQL.Name = "nudSetQL"
        Me.nudSetQL.Size = New System.Drawing.Size(48, 22)
        Me.nudSetQL.TabIndex = 5
        Me.nudSetQL.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'lblHQL
        '
        Me.lblHQL.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHQL.Location = New System.Drawing.Point(672, 8)
        Me.lblHQL.Name = "lblHQL"
        Me.lblHQL.Size = New System.Drawing.Size(48, 24)
        Me.lblHQL.TabIndex = 17
        Me.lblHQL.Text = "QL"
        '
        'lblHFaded
        '
        Me.lblHFaded.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHFaded.Location = New System.Drawing.Point(488, 8)
        Me.lblHFaded.Name = "lblHFaded"
        Me.lblHFaded.Size = New System.Drawing.Size(160, 24)
        Me.lblHFaded.TabIndex = 16
        Me.lblHFaded.Text = "Faded"
        '
        'lblHBright
        '
        Me.lblHBright.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHBright.Location = New System.Drawing.Point(304, 8)
        Me.lblHBright.Name = "lblHBright"
        Me.lblHBright.Size = New System.Drawing.Size(160, 24)
        Me.lblHBright.TabIndex = 15
        Me.lblHBright.Text = "Bright"
        '
        'lblHShiny
        '
        Me.lblHShiny.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHShiny.Location = New System.Drawing.Point(120, 8)
        Me.lblHShiny.Name = "lblHShiny"
        Me.lblHShiny.Size = New System.Drawing.Size(160, 24)
        Me.lblHShiny.TabIndex = 14
        Me.lblHShiny.Text = "Shiny"
        '
        'lblHType
        '
        Me.lblHType.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHType.Location = New System.Drawing.Point(80, 8)
        Me.lblHType.Name = "lblHType"
        Me.lblHType.Size = New System.Drawing.Size(40, 24)
        Me.lblHType.TabIndex = 13
        Me.lblHType.Text = "Type"
        '
        'lblFeet
        '
        Me.lblFeet.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFeet.Location = New System.Drawing.Point(8, 416)
        Me.lblFeet.Name = "lblFeet"
        Me.lblFeet.Size = New System.Drawing.Size(80, 24)
        Me.lblFeet.TabIndex = 12
        Me.lblFeet.Text = "Feet"
        Me.lblFeet.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblRHand
        '
        Me.lblRHand.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRHand.Location = New System.Drawing.Point(8, 320)
        Me.lblRHand.Name = "lblRHand"
        Me.lblRHand.Size = New System.Drawing.Size(80, 24)
        Me.lblRHand.TabIndex = 11
        Me.lblRHand.Text = "Right Hand"
        Me.lblRHand.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblLegs
        '
        Me.lblLegs.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLegs.Location = New System.Drawing.Point(8, 352)
        Me.lblLegs.Name = "lblLegs"
        Me.lblLegs.Size = New System.Drawing.Size(80, 24)
        Me.lblLegs.TabIndex = 10
        Me.lblLegs.Text = "Legs"
        Me.lblLegs.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblLHand
        '
        Me.lblLHand.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLHand.Location = New System.Drawing.Point(8, 384)
        Me.lblLHand.Name = "lblLHand"
        Me.lblLHand.Size = New System.Drawing.Size(80, 24)
        Me.lblLHand.TabIndex = 9
        Me.lblLHand.Text = "Left Hand"
        Me.lblLHand.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblRWrist
        '
        Me.lblRWrist.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRWrist.Location = New System.Drawing.Point(8, 224)
        Me.lblRWrist.Name = "lblRWrist"
        Me.lblRWrist.Size = New System.Drawing.Size(80, 24)
        Me.lblRWrist.TabIndex = 8
        Me.lblRWrist.Text = "Right Wrist"
        Me.lblRWrist.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblWaist
        '
        Me.lblWaist.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblWaist.Location = New System.Drawing.Point(8, 256)
        Me.lblWaist.Name = "lblWaist"
        Me.lblWaist.Size = New System.Drawing.Size(80, 24)
        Me.lblWaist.TabIndex = 7
        Me.lblWaist.Text = "Waist"
        Me.lblWaist.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblLWrist
        '
        Me.lblLWrist.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLWrist.Location = New System.Drawing.Point(8, 288)
        Me.lblLWrist.Name = "lblLWrist"
        Me.lblLWrist.Size = New System.Drawing.Size(80, 24)
        Me.lblLWrist.TabIndex = 6
        Me.lblLWrist.Text = "Left Wrist"
        Me.lblLWrist.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblEar
        '
        Me.lblEar.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblEar.Location = New System.Drawing.Point(8, 96)
        Me.lblEar.Name = "lblEar"
        Me.lblEar.Size = New System.Drawing.Size(80, 24)
        Me.lblEar.TabIndex = 5
        Me.lblEar.Text = "Ear"
        Me.lblEar.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblChest
        '
        Me.lblChest.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblChest.Location = New System.Drawing.Point(8, 160)
        Me.lblChest.Name = "lblChest"
        Me.lblChest.Size = New System.Drawing.Size(80, 24)
        Me.lblChest.TabIndex = 4
        Me.lblChest.Text = "Chest"
        Me.lblChest.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblLArm
        '
        Me.lblLArm.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblLArm.Location = New System.Drawing.Point(8, 192)
        Me.lblLArm.Name = "lblLArm"
        Me.lblLArm.Size = New System.Drawing.Size(80, 24)
        Me.lblLArm.TabIndex = 3
        Me.lblLArm.Text = "Left Arm"
        Me.lblLArm.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblRArm
        '
        Me.lblRArm.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRArm.Location = New System.Drawing.Point(8, 128)
        Me.lblRArm.Name = "lblRArm"
        Me.lblRArm.Size = New System.Drawing.Size(80, 24)
        Me.lblRArm.TabIndex = 2
        Me.lblRArm.Text = "Right Arm"
        Me.lblRArm.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblHead
        '
        Me.lblHead.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblHead.Location = New System.Drawing.Point(8, 64)
        Me.lblHead.Name = "lblHead"
        Me.lblHead.Size = New System.Drawing.Size(80, 24)
        Me.lblHead.TabIndex = 1
        Me.lblHead.Text = "Head"
        Me.lblHead.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'lblEye
        '
        Me.lblEye.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblEye.Location = New System.Drawing.Point(8, 32)
        Me.lblEye.Name = "lblEye"
        Me.lblEye.Size = New System.Drawing.Size(80, 24)
        Me.lblEye.TabIndex = 0
        Me.lblEye.Text = "Eye"
        Me.lblEye.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'tpBenefits
        '
        Me.tpBenefits.Controls.Add(Me.lvBenefit3)
        Me.tpBenefits.Controls.Add(Me.lvBenefit2)
        Me.tpBenefits.Controls.Add(Me.lvBenefit1)
        Me.tpBenefits.Controls.Add(Me.lstBenefits)
        Me.tpBenefits.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpBenefits.Location = New System.Drawing.Point(4, 24)
        Me.tpBenefits.Name = "tpBenefits"
        Me.tpBenefits.Size = New System.Drawing.Size(776, 488)
        Me.tpBenefits.TabIndex = 2
        Me.tpBenefits.Text = "Benefits"
        '
        'lvBenefit3
        '
        Me.lvBenefit3.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chBenefits3A, Me.chBenefits3B})
        Me.lvBenefit3.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lvBenefit3.FullRowSelect = True
        Me.lvBenefit3.GridLines = True
        Me.lvBenefit3.Location = New System.Drawing.Point(504, 8)
        Me.lvBenefit3.Name = "lvBenefit3"
        Me.lvBenefit3.Size = New System.Drawing.Size(240, 464)
        Me.lvBenefit3.TabIndex = 3
        Me.lvBenefit3.UseCompatibleStateImageBehavior = False
        Me.lvBenefit3.View = System.Windows.Forms.View.Details
        '
        'chBenefits3A
        '
        Me.chBenefits3A.Width = 160
        '
        'chBenefits3B
        '
        Me.chBenefits3B.Text = "Benefit"
        Me.chBenefits3B.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'lvBenefit2
        '
        Me.lvBenefit2.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chBenefits2A, Me.chBenefits2B})
        Me.lvBenefit2.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lvBenefit2.FullRowSelect = True
        Me.lvBenefit2.GridLines = True
        Me.lvBenefit2.Location = New System.Drawing.Point(256, 8)
        Me.lvBenefit2.Name = "lvBenefit2"
        Me.lvBenefit2.Size = New System.Drawing.Size(240, 464)
        Me.lvBenefit2.TabIndex = 2
        Me.lvBenefit2.UseCompatibleStateImageBehavior = False
        Me.lvBenefit2.View = System.Windows.Forms.View.Details
        '
        'chBenefits2A
        '
        Me.chBenefits2A.Width = 160
        '
        'chBenefits2B
        '
        Me.chBenefits2B.Text = "Benefit"
        Me.chBenefits2B.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'lvBenefit1
        '
        Me.lvBenefit1.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chBenefits1A, Me.chBenefits1B})
        Me.lvBenefit1.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lvBenefit1.FullRowSelect = True
        Me.lvBenefit1.GridLines = True
        Me.lvBenefit1.Location = New System.Drawing.Point(8, 8)
        Me.lvBenefit1.Name = "lvBenefit1"
        Me.lvBenefit1.Size = New System.Drawing.Size(240, 464)
        Me.lvBenefit1.TabIndex = 1
        Me.lvBenefit1.UseCompatibleStateImageBehavior = False
        Me.lvBenefit1.View = System.Windows.Forms.View.Details
        '
        'chBenefits1A
        '
        Me.chBenefits1A.Width = 160
        '
        'chBenefits1B
        '
        Me.chBenefits1B.Text = "Benefit"
        Me.chBenefits1B.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'lstBenefits
        '
        Me.lstBenefits.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstBenefits.ItemHeight = 15
        Me.lstBenefits.Location = New System.Drawing.Point(752, 8)
        Me.lstBenefits.Name = "lstBenefits"
        Me.lstBenefits.Size = New System.Drawing.Size(16, 19)
        Me.lstBenefits.TabIndex = 0
        Me.lstBenefits.Visible = False
        '
        'tpRequirements
        '
        Me.tpRequirements.Controls.Add(Me.lvReqs)
        Me.tpRequirements.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpRequirements.Location = New System.Drawing.Point(4, 24)
        Me.tpRequirements.Name = "tpRequirements"
        Me.tpRequirements.Size = New System.Drawing.Size(776, 488)
        Me.tpRequirements.TabIndex = 1
        Me.tpRequirements.Text = "Requirements"
        '
        'lvReqs
        '
        Me.lvReqs.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chSlot, Me.chTreatment, Me.chLevel, Me.chAbilities, Me.chBuild})
        Me.lvReqs.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lvReqs.FullRowSelect = True
        Me.lvReqs.GridLines = True
        Me.lvReqs.Location = New System.Drawing.Point(8, 8)
        Me.lvReqs.Name = "lvReqs"
        Me.lvReqs.Size = New System.Drawing.Size(760, 240)
        Me.lvReqs.TabIndex = 1
        Me.lvReqs.UseCompatibleStateImageBehavior = False
        Me.lvReqs.View = System.Windows.Forms.View.Details
        '
        'chSlot
        '
        Me.chSlot.Text = "Implant Slot"
        Me.chSlot.Width = 150
        '
        'chTreatment
        '
        Me.chTreatment.Text = "Treatment"
        Me.chTreatment.Width = 100
        '
        'chLevel
        '
        Me.chLevel.Text = "Level"
        Me.chLevel.Width = 50
        '
        'chAbilities
        '
        Me.chAbilities.Text = "Abilities"
        Me.chAbilities.Width = 280
        '
        'chBuild
        '
        Me.chBuild.Text = "To Build"
        Me.chBuild.Width = 150
        '
        'tpSuggest
        '
        Me.tpSuggest.Controls.Add(Me.lblSuggestInfo)
        Me.tpSuggest.Controls.Add(Me.lvSuggest)
        Me.tpSuggest.Controls.Add(Me.cmdSuggest)
        Me.tpSuggest.Controls.Add(Me.gbSuggest)
        Me.tpSuggest.Controls.Add(Me.cmdSelect)
        Me.tpSuggest.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpSuggest.Location = New System.Drawing.Point(4, 24)
        Me.tpSuggest.Name = "tpSuggest"
        Me.tpSuggest.Size = New System.Drawing.Size(776, 488)
        Me.tpSuggest.TabIndex = 3
        Me.tpSuggest.Text = "Suggest"
        '
        'lblSuggestInfo
        '
        Me.lblSuggestInfo.BackColor = System.Drawing.SystemColors.Window
        Me.lblSuggestInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.lblSuggestInfo.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblSuggestInfo.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblSuggestInfo.Location = New System.Drawing.Point(8, 224)
        Me.lblSuggestInfo.Name = "lblSuggestInfo"
        Me.lblSuggestInfo.Size = New System.Drawing.Size(144, 224)
        Me.lblSuggestInfo.TabIndex = 10
        '
        'lvSuggest
        '
        Me.lvSuggest.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.chSuggestSlot, Me.chSuggestClusterType, Me.chSuggestCluster, Me.chResultantAbility})
        Me.lvSuggest.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lvSuggest.FullRowSelect = True
        Me.lvSuggest.GridLines = True
        Me.lvSuggest.Location = New System.Drawing.Point(160, 8)
        Me.lvSuggest.Name = "lvSuggest"
        Me.lvSuggest.Size = New System.Drawing.Size(608, 440)
        Me.lvSuggest.TabIndex = 9
        Me.lvSuggest.UseCompatibleStateImageBehavior = False
        Me.lvSuggest.View = System.Windows.Forms.View.Details
        '
        'chSuggestSlot
        '
        Me.chSuggestSlot.Text = "Implant Slot"
        Me.chSuggestSlot.Width = 100
        '
        'chSuggestClusterType
        '
        Me.chSuggestClusterType.Text = "Cluster Type"
        Me.chSuggestClusterType.Width = 100
        '
        'chSuggestCluster
        '
        Me.chSuggestCluster.Text = "Suggested Skill, Ability or Statistic"
        Me.chSuggestCluster.Width = 210
        '
        'chResultantAbility
        '
        Me.chResultantAbility.Text = "Resultant Ability"
        Me.chResultantAbility.Width = 155
        '
        'cmdSuggest
        '
        Me.cmdSuggest.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdSuggest.Location = New System.Drawing.Point(8, 192)
        Me.cmdSuggest.Name = "cmdSuggest"
        Me.cmdSuggest.Size = New System.Drawing.Size(144, 23)
        Me.cmdSuggest.TabIndex = 7
        Me.cmdSuggest.Text = "Suggest"
        '
        'gbSuggest
        '
        Me.gbSuggest.Controls.Add(Me.chkSuggestStr)
        Me.gbSuggest.Controls.Add(Me.chkSuggestAgl)
        Me.gbSuggest.Controls.Add(Me.chkSuggestSta)
        Me.gbSuggest.Controls.Add(Me.chkSuggestInt)
        Me.gbSuggest.Controls.Add(Me.chkSuggestSen)
        Me.gbSuggest.Controls.Add(Me.chkSuggestPsy)
        Me.gbSuggest.Location = New System.Drawing.Point(8, 8)
        Me.gbSuggest.Name = "gbSuggest"
        Me.gbSuggest.Size = New System.Drawing.Size(144, 176)
        Me.gbSuggest.TabIndex = 6
        Me.gbSuggest.TabStop = False
        Me.gbSuggest.Text = "Preferred Abilities"
        '
        'chkSuggestStr
        '
        Me.chkSuggestStr.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestStr.Location = New System.Drawing.Point(24, 24)
        Me.chkSuggestStr.Name = "chkSuggestStr"
        Me.chkSuggestStr.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestStr.TabIndex = 0
        Me.chkSuggestStr.Text = "Strength"
        '
        'chkSuggestAgl
        '
        Me.chkSuggestAgl.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestAgl.Location = New System.Drawing.Point(24, 48)
        Me.chkSuggestAgl.Name = "chkSuggestAgl"
        Me.chkSuggestAgl.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestAgl.TabIndex = 1
        Me.chkSuggestAgl.Text = "Agility"
        '
        'chkSuggestSta
        '
        Me.chkSuggestSta.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestSta.Location = New System.Drawing.Point(24, 72)
        Me.chkSuggestSta.Name = "chkSuggestSta"
        Me.chkSuggestSta.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestSta.TabIndex = 2
        Me.chkSuggestSta.Text = "Stamina"
        '
        'chkSuggestInt
        '
        Me.chkSuggestInt.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestInt.Location = New System.Drawing.Point(24, 96)
        Me.chkSuggestInt.Name = "chkSuggestInt"
        Me.chkSuggestInt.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestInt.TabIndex = 3
        Me.chkSuggestInt.Text = "Intelligence"
        '
        'chkSuggestSen
        '
        Me.chkSuggestSen.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestSen.Location = New System.Drawing.Point(24, 120)
        Me.chkSuggestSen.Name = "chkSuggestSen"
        Me.chkSuggestSen.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestSen.TabIndex = 4
        Me.chkSuggestSen.Text = "Sense"
        '
        'chkSuggestPsy
        '
        Me.chkSuggestPsy.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkSuggestPsy.Location = New System.Drawing.Point(24, 144)
        Me.chkSuggestPsy.Name = "chkSuggestPsy"
        Me.chkSuggestPsy.Size = New System.Drawing.Size(104, 24)
        Me.chkSuggestPsy.TabIndex = 5
        Me.chkSuggestPsy.Text = "Psychic"
        '
        'cmdSelect
        '
        Me.cmdSelect.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdSelect.Location = New System.Drawing.Point(160, 456)
        Me.cmdSelect.Name = "cmdSelect"
        Me.cmdSelect.Size = New System.Drawing.Size(200, 24)
        Me.cmdSelect.TabIndex = 1
        Me.cmdSelect.Text = "Select"
        '
        'tpShopping
        '
        Me.tpShopping.Controls.Add(Me.lblName)
        Me.tpShopping.Controls.Add(Me.lblFaded)
        Me.tpShopping.Controls.Add(Me.lblBright)
        Me.tpShopping.Controls.Add(Me.lblShiny)
        Me.tpShopping.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tpShopping.Location = New System.Drawing.Point(4, 24)
        Me.tpShopping.Name = "tpShopping"
        Me.tpShopping.Size = New System.Drawing.Size(776, 488)
        Me.tpShopping.TabIndex = 4
        Me.tpShopping.Text = "Shopping"
        '
        'lblName
        '
        Me.lblName.AutoSize = True
        Me.lblName.Location = New System.Drawing.Point(9, 8)
        Me.lblName.Name = "lblName"
        Me.lblName.Size = New System.Drawing.Size(83, 15)
        Me.lblName.TabIndex = 27
        Me.lblName.Text = "Implant Slot \/"
        '
        'lblFaded
        '
        Me.lblFaded.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblFaded.Location = New System.Drawing.Point(549, 8)
        Me.lblFaded.Name = "lblFaded"
        Me.lblFaded.Size = New System.Drawing.Size(160, 24)
        Me.lblFaded.TabIndex = 26
        Me.lblFaded.Text = "Faded"
        '
        'lblBright
        '
        Me.lblBright.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBright.Location = New System.Drawing.Point(325, 8)
        Me.lblBright.Name = "lblBright"
        Me.lblBright.Size = New System.Drawing.Size(160, 24)
        Me.lblBright.TabIndex = 25
        Me.lblBright.Text = "Bright"
        '
        'lblShiny
        '
        Me.lblShiny.Font = New System.Drawing.Font("Arial", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblShiny.Location = New System.Drawing.Point(101, 8)
        Me.lblShiny.Name = "lblShiny"
        Me.lblShiny.Size = New System.Drawing.Size(160, 24)
        Me.lblShiny.TabIndex = 24
        Me.lblShiny.Text = "Shiny"
        '
        'tcMain
        '
        Me.tcMain.Controls.Add(Me.tpImplants)
        Me.tcMain.Controls.Add(Me.tpSuggest)
        Me.tcMain.Controls.Add(Me.tpShopping)
        Me.tcMain.Controls.Add(Me.tpBenefits)
        Me.tcMain.Controls.Add(Me.tpRequirements)
        Me.tcMain.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.tcMain.ItemSize = New System.Drawing.Size(67, 20)
        Me.tcMain.Location = New System.Drawing.Point(4, 8)
        Me.tcMain.Name = "tcMain"
        Me.tcMain.SelectedIndex = 0
        Me.tcMain.Size = New System.Drawing.Size(784, 516)
        Me.tcMain.TabIndex = 0
        '
        'fdOpenIM
        '
        Me.fdOpenIM.DefaultExt = "mtx"
        Me.fdOpenIM.Filter = "IMatrix File|*.mtx"
        Me.fdOpenIM.InitialDirectory = "im_layouts"
        Me.fdOpenIM.RestoreDirectory = True
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(802, 561)
        Me.Controls.Add(Me.tcMain)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MaximumSize = New System.Drawing.Size(1050, 730)
        Me.Menu = Me.mainMenu
        Me.MinimumSize = New System.Drawing.Size(810, 590)
        Me.Name = "frmMain"
        Me.Text = "implantHelper"
        Me.tpImplants.ResumeLayout(False)
        CType(Me.nudSetQL, System.ComponentModel.ISupportInitialize).EndInit()
        Me.tpBenefits.ResumeLayout(False)
        Me.tpRequirements.ResumeLayout(False)
        Me.tpSuggest.ResumeLayout(False)
        Me.gbSuggest.ResumeLayout(False)
        Me.tpShopping.ResumeLayout(False)
        Me.tpShopping.PerformLayout()
        Me.tcMain.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As EventArgs) Handles MyBase.Load
        Dim i As Integer

        Me.Text = My.Application.Info.Title
        For i = 0 To 12
            shopA.AddNewShop(Me.tpShopping, i)
            shopA(i).clearAll()
            impA.AddNewImp(Me.tpImplants, i)
            impA(i).loadClusters()
            impA(i).ChangeHandler = AddressOf evtHandler
        Next
        ' call a routine to re-layout labels and size form based on sizes of impA(0) elements
        layoutLabels()
        Me.cmbProfession.Items.Add("<select profession>")
        For i = 0 To profNames.Length - 1
            Me.cmbProfession.Items.Add(profNames(i))
        Next
        Me.cmbProfession.SelectedIndex = 0
        loadFind(Me.cmbFind)
        Me.lblSuggestInfo.Text = "Select one or more Abilities using the Preferred Abilities checkboxes and press the Suggest button." & _
                                 Chr(10) & Chr(10) & _
                                 "For a specific Implant Slot and Cluster Type combination, select the line containing the " & _
                                 "Skill, Ability or Statistic you wish to use at that location and press the Select button." & _
                                 Chr(10) & Chr(10) & _
                                 "This will enter that Skill, Ability or Statistic into that location and rebuild the suggestions list."
        loadWinSize()
    End Sub

    Private Sub cmdSetQL_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmdSetQL.Click
        Dim i As Integer

        For i = 0 To 12
            impA(i).QL = Me.nudSetQL.Value
        Next
    End Sub

    Private Sub cmbProfession_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmbProfession.SelectedIndexChanged
        Dim i As Integer

        For i = 0 To 12
            impA(i).ProfessionID = Me.cmbProfession.SelectedIndex
        Next
        If Me.cmbProfession.SelectedIndex > 0 Then
            Me.miAllSymbs.Enabled = True
        Else
            Me.miAllSymbs.Enabled = False
        End If
    End Sub

    Private Sub cmbFind_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmbFind.SelectedIndexChanged
        Dim i As Integer

        ' get selected skill and pass it to a method in each impA() which should highlight those slots that skill can fit into
        For i = 0 To 12
            impA(i).highlightSpecified(Me.cmbFind.Items(Me.cmbFind.SelectedIndex))
            impA(i).filterSpecified(Me.cmbFind.Items(Me.cmbFind.SelectedIndex))
        Next
    End Sub

    Private Sub cmdBuild_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmdBuild.Click
        doBuild()
        objFrmMain.tcMain.SelectedTab = objFrmMain.tpBenefits
    End Sub

    Private Sub miNew_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miNew.Click
        doReset()
    End Sub

    Private Sub miOpen_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miOpen.Click
        Dim result As DialogResult

        ' read in saved data file after asking user which one
        result = Me.fdOpen.ShowDialog(Me)
        If result = DialogResult.OK Then
            currentFile = fdOpen.FileName
            loadXML(currentFile)
            Me.Text = My.Application.Info.Title & " : " & currentFile
        End If
    End Sub

    Private Sub miOpenIM_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miOpenIM.Click
        Dim result As DialogResult

        ' read in saved imatrix data file after asking user which one
        result = Me.fdOpenIM.ShowDialog(Me)
        If result = DialogResult.OK Then
            loadIMatrixXML(fdOpenIM.FileName)
            currentFile = ""
            Me.Text = My.Application.Info.Title & " : " & currentFile
        End If
    End Sub

    Private Sub miSave_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSave.Click
        ' save current data to current open data file (assuming there is one)
        If currentFile <> "" Then
            saveXML(currentFile)
        End If
    End Sub

    Private Sub miSaveAs_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSaveAs.Click
        ' ask user what file name to save current data to and save that data
        Dim result As DialogResult

        result = Me.fdSave.ShowDialog(Me)
        If result = DialogResult.OK Then
            currentFile = fdSave.FileName
            saveXML(currentFile)
            Me.Text = My.Application.Info.Title & " : " & currentFile
        End If
    End Sub

    Private Sub miSaveAsAOSkills_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSaveAsAOSkills.Click
        ' ask user what file name to save current data to and save that data
        Dim result As System.Windows.Forms.DialogResult

        result = Me.fdSaveAOSkills.ShowDialog(Me)
        If result = DialogResult.OK Then
            currentFile = fdSaveAOSkills.FileName
            saveAOSkillsXML(currentFile)
        End If
    End Sub

    Private Sub miPrintPreview_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miPrintPreview.Click
        Dim ppd As New PrintPreviewDialog
        Dim sps As New PageSettings

        sps.Margins.Top = 35
        sps.Margins.Bottom = 35
        sps.Margins.Left = 50
        sps.Margins.Right = 50
        sps.Landscape = True
        Me.sePrintDocument.DefaultPageSettings = sps
        ppd.Document = Me.sePrintDocument
        ppd.ShowDialog()
    End Sub

    Private Sub miPrint_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miPrint.Click
        Dim dlg As New PrintDialog
        Dim sps As New PageSettings

        sps.Margins.Top = 35
        sps.Margins.Bottom = 35
        sps.Margins.Left = 50
        sps.Margins.Right = 50
        sps.Landscape = True
        Me.sePrintDocument.DefaultPageSettings = sps
        dlg.Document = Me.sePrintDocument
        Dim result As DialogResult = dlg.ShowDialog()
        If (result = System.Windows.Forms.DialogResult.OK) Then
            Me.sePrintDocument.Print()
        End If
    End Sub

    Private Sub miExit_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miExit.Click
        ' exit program
        saveWinSize()
        End
    End Sub

    Private Sub miSetQL1_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSetQL1.Click
        Dim i As Integer

        ' set all implant QLs to 1
        For i = 0 To 12
            impA(i).QL = 1
        Next
    End Sub

    Private Sub miSetQL100_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSetQL100.Click
        Dim i As Integer

        ' set all implant QLs to 100
        For i = 0 To 12
            impA(i).QL = 100
        Next
    End Sub

    Private Sub miSetQL200_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSetQL200.Click
        Dim i As Integer

        ' set all implant QLs to 200
        For i = 0 To 12
            impA(i).QL = 200
        Next
    End Sub

    Private Sub miSetQL250_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSetQL250.Click
        Dim i As Integer

        ' set all implant QLs to 250
        For i = 0 To 12
            impA(i).QL = 250
        Next
    End Sub

    Private Sub miSetQL300_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miSetQL300.Click
        Dim i As Integer

        ' set all implant QLs to 300
        For i = 0 To 12
            impA(i).QL = 300
        Next
    End Sub

    Private Sub miAllImplants_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miAllImplants.Click
        Dim i As Integer

        ' set all to implant
        For i = 0 To 12
            impA(i).setType("I")
        Next
    End Sub

    Private Sub miAllSymbs_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miAllSymbs.Click
        Dim i As Integer

        ' set all to symbs/spirits if possible
        For i = 0 To 12
            impA(i).setType("S")
        Next
    End Sub

    Private Sub miAbout_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles miAbout.Click
        ' show about dialog box

        MsgBox(My.Application.Info.Title & Chr(10) & My.Application.Info.Copyright & Chr(10) & "Database derived from iMatrix by Kewlpack Software, used with kind permission.", _
               MsgBoxStyle.Information + MsgBoxStyle.OkOnly, My.Application.Info.Title)
    End Sub

    Private Sub cmdSuggest_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmdSuggest.Click
        doSuggestClick()
    End Sub

    Private Sub chkSuggestStr_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestStr.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub chkSuggestAgl_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestAgl.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub chkSuggestSta_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestSta.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub chkSuggestInt_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestInt.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub chkSuggestSen_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestSen.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub chkSuggestPsy_CheckedChanged(ByVal sender As System.Object, ByVal e As EventArgs) Handles chkSuggestPsy.CheckedChanged
        Me.lvSuggest.Items.Clear()
    End Sub

    Private Sub sePrintDocument_PrintPage(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles sePrintDocument.PrintPage
        Dim drawFontH As New Font("Arial", 10)
        Dim drawFont As New Font("Courier New", 8)
        Dim yPos As Double = 0
        Dim i As Integer
        Dim sc As New SortedList
        Dim de As DictionaryEntry
        Dim ql As Integer

        yPos = e.MarginBounds.Top
        printLine("Implant Layout", drawFontH, yPos, e)
        printLine("", drawFont, yPos, e)
        For i = 0 To 12
            printLine(getImpLine(i), drawFont, yPos, e)
        Next
        printLine("", drawFont, yPos, e)
        printLine("Shopping List", drawFontH, yPos, e)
        printLine("", drawFont, yPos, e)
        For i = 0 To 12
            ' build list of clusters in type then alpha order with minimum ql
            If impA(i).ShinyCluster <> SEL_STRING Then
                ql = Math.Ceiling(impA(i).QL * 0.86)
                If impA(i).ShinyCluster.Substring(impA(i).ShinyCluster.Length - 1, 1) = "*" Then
                    sc.Add("A) Shiny Jobe Cluster (" & impA(i).ShinyCluster & ")", CStr(ql))
                Else
                    sc.Add("A) Shiny Cluster (" & impA(i).ShinyCluster & ")", CStr(ql))
                End If
            End If
            If impA(i).BrightCluster <> SEL_STRING Then
                ql = Math.Ceiling(impA(i).QL * 0.84)
                If impA(i).BrightCluster.Substring(impA(i).BrightCluster.Length - 1, 1) = "*" Then
                    sc.Add("B) Bright Jobe Cluster (" & impA(i).BrightCluster & ")", CStr(ql))
                Else
                    sc.Add("B) Bright Cluster (" & impA(i).BrightCluster & ")", CStr(ql))
                End If
            End If
            If impA(i).FadedCluster <> SEL_STRING Then
                ql = Math.Ceiling(impA(i).QL * 0.82)
                If impA(i).FadedCluster.Substring(impA(i).FadedCluster.Length - 1, 1) = "*" Then
                    sc.Add("C) Faded Jobe Cluster (" & impA(i).FadedCluster & ")", CStr(ql))
                Else
                    sc.Add("C) Faded Cluster (" & impA(i).FadedCluster & ")", CStr(ql))
                End If
            End If
        Next
        For Each de In sc
            printLine(CStr(de.Key).Substring(3) & " at least QL " & CStr(de.Value), drawFont, yPos, e)
        Next
    End Sub

    ' print a line and adjust draw position
    Private Sub printLine(ByRef line As String, ByRef fnt As Font, ByRef yPos As Double, ByVal e As PrintPageEventArgs)
        e.Graphics.DrawString(line, fnt, Brushes.Black, e.MarginBounds.Left, CSng(yPos), New StringFormat)
        yPos = yPos + fnt.GetHeight(e.Graphics)
    End Sub

    ' function to format an implant slot line for printing
    Private Function getImpLine(ByVal i As Integer) As String
        Dim r As String

        r = impSlots(i)
        If impA(i).SorI = "I" Then
            r &= " Implant QL" & CStr(impA(i).QL) & " : "
             If impA(i).ShinyCluster <> SEL_STRING Then
                r &= "Shiny (" & impA(i).ShinyCluster & ") "
            Else
                r &= "Shiny (Empty) "
            End If
            If impA(i).BrightCluster <> SEL_STRING Then
                r &= "Bright (" & impA(i).BrightCluster & ") "
            Else
                r &= "Bright (Empty) "
            End If
            If impA(i).FadedCluster <> SEL_STRING Then
                r &= "Faded (" & impA(i).FadedCluster & ") "
            Else
                r &= "Faded (Empty) "
            End If
            ' only if we have built...
            If objFrmMain.miSaveAsAOSkills.Enabled Then
                If impA(i).NPRequisites <> -1 Then
                    r &= " [NP: " & impA(i).NPRequisites & "]"
                End If
                If impA(i).Requisites <> "" Then
                    r &= " [Reqs: " & impA(i).Requisites & "]"
                End If
            End If
            r = r.TrimEnd()
        Else
            If Me.cmbProfession.SelectedIndex = SHADE_ID Then
                r &= " Spirit : "
            Else
                r &= " Symbiant : "
            End If
            ' only if we have built...
            If objFrmMain.miSaveAsAOSkills.Enabled Then
                If impA(i).Requisites <> "" Then
                    r &= " [Reqs: " & impA(i).Requisites & "]"
                End If
            End If
            r &= impA(i).SymbiantOrSpirit()
        End If
        Return r
    End Function

    ' simple format routine to ensure a string is a certain size by trimming or space padding
    Function fixWidth(ByVal s As String, ByVal w As Integer, Optional ByVal before As Boolean = False) As String
        If s.Length > w Then
            Return s.Substring(0, w)
        End If
        If before = True Then
            Return s & Space(w).Substring(0, w - s.Length)
        End If
        Return Space(w).Substring(0, w - s.Length) & s
    End Function

    Private Sub cmdSet_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles cmdSet.Click
        Dim i As Integer

        For i = 0 To 12
            If impA(i).SorI = "I" Then
                impA(i).changeSpecified(Me.cmbFind.Items(Me.cmbFind.SelectedIndex))
            End If
        Next
        Me.cmbFind.SelectedIndex = 0
        Me.cmbFind.Focus()
    End Sub

    Private Sub lvSuggest_MouseUp(ByVal sender As Object, ByVal e As MouseEventArgs) Handles lvSuggest.MouseUp
    End Sub

    Private Sub lvBenefit1_ColumnClick(ByVal o As Object, ByVal e As ColumnClickEventArgs) Handles lvBenefit1.ColumnClick
        doSortBenefits(e.Column)
    End Sub

    Private Sub lvBenefit2_ColumnClick(ByVal o As Object, ByVal e As ColumnClickEventArgs) Handles lvBenefit2.ColumnClick
        doSortBenefits(e.Column)
    End Sub

    Private Sub lvBenefit3_ColumnClick(ByVal o As Object, ByVal e As ColumnClickEventArgs) Handles lvBenefit3.ColumnClick
        doSortBenefits(e.Column)
    End Sub

    Private Sub doSuggestClick()
        Dim abl As String = ""

        If chkSuggestStr.Checked Then
            abl &= "'Strength'"
        End If
        If chkSuggestAgl.Checked Then
            If abl.Length <> 0 Then
                abl &= ","
            End If
            abl &= "'Agility'"
        End If
        If chkSuggestSta.Checked Then
            If abl.Length <> 0 Then
                abl &= ","
            End If
            abl &= "'Stamina'"
        End If
        If chkSuggestInt.Checked Then
            If abl.Length <> 0 Then
                abl &= ","
            End If
            abl &= "'Intelligence'"
        End If
        If chkSuggestSen.Checked Then
            If abl.Length <> 0 Then
                abl &= ","
            End If
            abl &= "'Sense'"
        End If
        If chkSuggestPsy.Checked Then
            If abl.Length <> 0 Then
                abl &= ","
            End If
            abl &= "'Psychic'"
        End If
        If abl <> "" Then
            doSuggest(abl)
        End If
    End Sub

    Private Sub evtHandler(ByVal sender As System.Object, ByVal e As EventArgs)
        Me.lvReqs.Items.Clear()
        Me.lvBenefit1.Items.Clear()
        Me.lvBenefit2.Items.Clear()
        Me.lvBenefit3.Items.Clear()
        Me.lstBenefits.Items.Clear()
        Me.miSaveAsAOSkills.Enabled = False
        doBuild()
    End Sub

    Private Sub cmdSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSelect.Click
        Dim i As Integer
        Dim j As Integer
        Dim slot As String
        Dim type As String
        Dim clus As String

        If Me.lvSuggest.SelectedIndices.Count = 1 Then
            i = Me.lvSuggest.SelectedIndices.Item(0)
            slot = Me.lvSuggest.Items(i).SubItems(0).Text
            type = Me.lvSuggest.Items(i).SubItems(1).Text
            clus = Me.lvSuggest.Items(i).SubItems(2).Text
            For j = 0 To 12
                If impSlots(j) = slot Then
                    If impA(j).getElement(type) = clus Then
                        impA(j).setElement(type, "")
                    Else
                        impA(j).setElement(type, clus)
                    End If
                    doSuggestClick()
                    objFrmMain.tcMain.SelectedTab = objFrmMain.tpImplants
                    impA(j).setFocus(type)
                    Exit For
                End If
            Next
        End If
    End Sub

    Private Sub tcMain_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tcMain.KeyUp
        If e.Control = True And e.KeyCode = Keys.F Then
            Me.cmbFind.Focus()
        ElseIf e.KeyCode = Keys.Enter And Me.cmbFind.Focused = True Then
            Me.cmdSet.PerformClick()
        End If
    End Sub

    Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        saveWinSize()
    End Sub

    Private Sub frmMain_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Me.tcMain.Height = Me.Height - 74
        Me.tcMain.Width = Me.Width - 20
    End Sub

    Private Sub lblShiny_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblShiny.Click
        Dim i As Integer
        Dim j As Integer
        Dim sorter As New Generic.List(Of String)
        ' sort by cluster!
        ' shopA() contains the implants, we can use the ShinyCluster property to get the name...
        ' so need to get all of those into a list along with the index then sort it by the name then
        ' move the items about
        For i = 0 To 12
            If shopA(i).ShinyCluster = "<no cluster>" Then
                sorter.Add("XXX" & CStr(i))
            Else
                sorter.Add(shopA(i).ShinyCluster)
            End If
        Next
        sorter.Sort()
        For i = 0 To 12
            For j = 0 To 12
                If shopA(i).ShinyCluster = sorter(j) Then
                    shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                ElseIf shopA(i).ShinyCluster = "<no cluster>" Then
                    If sorter(j) = "XXX" & CStr(i) Then
                        shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                    End If
                End If
            Next
        Next
        lblShiny.Text = "Shiny \/"
        lblBright.Text = "Bright"
        lblFaded.Text = "Faded"
        lblName.Text = "Implant Slot"
    End Sub

    Private Sub lblBright_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblBright.Click
        Dim i As Integer
        Dim j As Integer
        Dim sorter As New Generic.List(Of String)
        ' sort by cluster!
        ' shopA() contains the implants, we can use the ShinyCluster property to get the name...
        ' so need to get all of those into a list along with the index then sort it by the name then
        ' move the items about
        For i = 0 To 12
            If shopA(i).BrightCluster = "<no cluster>" Then
                sorter.Add("XXX" & CStr(i))
            Else
                sorter.Add(shopA(i).BrightCluster)
            End If
        Next
        sorter.Sort()
        For i = 0 To 12
            For j = 0 To 12
                If shopA(i).BrightCluster = sorter(j) Then
                    shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                ElseIf shopA(i).BrightCluster = "<no cluster>" Then
                    If sorter(j) = "XXX" & CStr(i) Then
                        shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                    End If
                End If
            Next
        Next
        lblShiny.Text = "Shiny"
        lblBright.Text = "Bright \/"
        lblFaded.Text = "Faded"
        lblName.Text = "Implant Slot"
    End Sub

    Private Sub lblFaded_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblFaded.Click
        Dim i As Integer
        Dim j As Integer
        Dim sorter As New Generic.List(Of String)
        ' sort by cluster!
        ' shopA() contains the implants, we can use the ShinyCluster property to get the name...
        ' so need to get all of those into a list along with the index then sort it by the name then
        ' move the items about
        For i = 0 To 12
            If shopA(i).FadedCluster = "<no cluster>" Then
                sorter.Add("XXX" & CStr(i))
            Else
                sorter.Add(shopA(i).FadedCluster)
            End If
        Next
        sorter.Sort()
        For i = 0 To 12
            For j = 0 To 12
                If shopA(i).FadedCluster = sorter(j) Then
                    shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                ElseIf shopA(i).FadedCluster = "<no cluster>" Then
                    If sorter(j) = "XXX" & CStr(i) Then
                        shopA(i).Top = 32 + j * (shopA(0).Height + 8)
                    End If
                End If
            Next
        Next
        lblShiny.Text = "Shiny"
        lblBright.Text = "Bright"
        lblFaded.Text = "Faded \/"
        lblName.Text = "Implant Slot"
    End Sub

    Private Sub lblName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblName.Click
        Dim i As Integer
        For i = 0 To 12
            shopA(i).Top = 32 + i * (shopA(0).Height + 8)
        Next
        lblShiny.Text = "Shiny"
        lblBright.Text = "Bright"
        lblFaded.Text = "Faded"
        lblName.Text = "Implant Slot \/"
    End Sub

    Private Sub layoutLabels()
        ' we'll recalc horizontal label's positions from the elements of the first control
        Me.lblHType.Left = impA(0).lblType.Location.X + impA(0).Left - 2
        Me.lblHShiny.Left = impA(0).cmbShiny.Location.X + impA(0).Left
        Me.lblHBright.Left = impA(0).cmbBright.Location.X + impA(0).Left
        Me.lblHFaded.Left = impA(0).cmbFaded.Location.X + impA(0).Left
        Me.lblHQL.Left = impA(0).nudQL.Location.X + impA(0).Left
        Me.lblHAbility.Left = impA(0).lblAttrib.Location.X + impA(0).Left
        ' now position vertical labels
        Me.lblEye.Top = impA(0).Top
        Me.lblHead.Top = impA(1).Top
        Me.lblEar.Top = impA(2).Top
        Me.lblRArm.Top = impA(3).Top
        Me.lblChest.Top = impA(4).Top
        Me.lblLArm.Top = impA(5).Top
        Me.lblRWrist.Top = impA(6).Top
        Me.lblWaist.Top = impA(7).Top
        Me.lblLWrist.Top = impA(8).Top
        Me.lblRHand.Top = impA(9).Top
        Me.lblLegs.Top = impA(10).Top
        Me.lblLHand.Top = impA(11).Top
        Me.lblFeet.Top = impA(12).Top
        ' and do the same for shopping tab
        Me.lblName.Left = shopA(0).lblName.Location.X + shopA(0).Left - 2
        Me.lblShiny.Left = shopA(0).chkShiny.Location.X + shopA(0).Left
        Me.lblBright.Left = shopA(0).chkBright.Location.X + shopA(0).Left
        Me.lblFaded.Left = shopA(0).chkFaded.Location.X + shopA(0).Left
    End Sub

End Class
