'Copyright (c) 2005-2012 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Public Class ihControl2 : Inherits UserControl

    Private prvItemIdx As Integer = -1
    Friend WithEvents lblName As System.Windows.Forms.Label
    Private prvTabPage As TabPage

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.
    'Do not modify it using the code editor.
    Friend WithEvents chkShiny As System.Windows.Forms.CheckBox
    Friend WithEvents chkBright As System.Windows.Forms.CheckBox
    Friend WithEvents chkFaded As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.chkShiny = New System.Windows.Forms.CheckBox
        Me.chkBright = New System.Windows.Forms.CheckBox
        Me.chkFaded = New System.Windows.Forms.CheckBox
        Me.lblName = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'chkShiny
        '
        Me.chkShiny.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkShiny.Location = New System.Drawing.Point(96, 0)
        Me.chkShiny.Name = "chkShiny"
        Me.chkShiny.Size = New System.Drawing.Size(216, 24)
        Me.chkShiny.TabIndex = 1
        Me.chkShiny.Text = "Shiny Cluster"
        '
        'chkBright
        '
        Me.chkBright.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkBright.Location = New System.Drawing.Point(320, 0)
        Me.chkBright.Name = "chkBright"
        Me.chkBright.Size = New System.Drawing.Size(216, 24)
        Me.chkBright.TabIndex = 2
        Me.chkBright.Text = "Bright Cluster"
        '
        'chkFaded
        '
        Me.chkFaded.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.chkFaded.Location = New System.Drawing.Point(544, 0)
        Me.chkFaded.Name = "chkFaded"
        Me.chkFaded.Size = New System.Drawing.Size(216, 24)
        Me.chkFaded.TabIndex = 3
        Me.chkFaded.Text = "Faded Cluster"
        '
        'lblName
        '
        Me.lblName.AutoSize = True
        Me.lblName.Font = New System.Drawing.Font("Arial", 9.75!)
        Me.lblName.Location = New System.Drawing.Point(7, 4)
        Me.lblName.Name = "lblName"
        Me.lblName.Size = New System.Drawing.Size(88, 16)
        Me.lblName.TabIndex = 4
        Me.lblName.Text = "Implant Name"
        '
        'ihControl2
        '
        Me.Controls.Add(Me.lblName)
        Me.Controls.Add(Me.chkFaded)
        Me.Controls.Add(Me.chkBright)
        Me.Controls.Add(Me.chkShiny)
        Me.Name = "ihControl2"
        Me.Size = New System.Drawing.Size(768, 24)
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Public Property ItemIdx() As Integer
        Get
            Return prvItemIdx
        End Get
        Set(ByVal Value As Integer)
            prvItemIdx = Value
        End Set
    End Property

    Public Property ControlTabPage() As TabPage
        Get
            Return prvTabPage
        End Get
        Set(ByVal Value As TabPage)
            prvTabPage = Value
        End Set
    End Property

    Public Property ShoppingStatus() As String
        Get
            Return getShoppingStatus()
        End Get
        Set(ByVal Value As String)
            setShoppingStatus(Value)
        End Set
    End Property

    Public Property ImpName() As String
        Get
            Return lblName.Text
        End Get
        Set(ByVal Value As String)
            lblName.Text = Value
        End Set
    End Property

    Public ReadOnly Property ShinyCluster() As String
        Get
            Return Me.chkShiny.Text
        End Get
    End Property

    Public ReadOnly Property BrightCluster() As String
        Get
            Return Me.chkBright.Text
        End Get
    End Property

    Public ReadOnly Property FadedCluster() As String
        Get
            Return Me.chkFaded.Text
        End Get
    End Property

    Private Function getShoppingStatus() As String
        Dim s As String

        s = IIf(Me.chkShiny.Checked, "Y", "N")
        s &= IIf(Me.chkBright.Checked, "Y", "N")
        s &= IIf(Me.chkFaded.Checked, "Y", "N")
        Return s
    End Function

    Private Sub setShoppingStatus(ByVal v As String)
        If v.Length <> 3 Then
            Me.chkShiny.Checked = False
            Me.chkBright.Checked = False
            Me.chkFaded.Checked = False
        Else
            If v.Substring(0, 1) = "Y" Then
                Me.chkShiny.Checked = True
            Else
                Me.chkShiny.Checked = False
            End If
            If v.Substring(1, 1) = "Y" Then
                Me.chkBright.Checked = True
            Else
                Me.chkBright.Checked = False
            End If
            If v.Substring(2, 1) = "Y" Then
                Me.chkFaded.Checked = True
            Else
                Me.chkFaded.Checked = False
            End If
        End If
    End Sub

    Public Sub clearAll()
        Me.chkShiny.Checked = False
        Me.chkBright.Checked = False
        Me.chkFaded.Checked = False
        Me.chkShiny.Text = "<no cluster>"
        Me.chkBright.Text = "<no cluster>"
        Me.chkFaded.Text = "<no cluster>"
        Me.chkShiny.Enabled = False
        Me.chkBright.Enabled = False
        Me.chkFaded.Enabled = False
    End Sub

    Public Sub clearOne(ByVal n As Integer)
        If n = 1 Then
            Me.chkShiny.Checked = False
        ElseIf n = 2 Then
            Me.chkBright.Checked = False
        ElseIf n = 3 Then
            Me.chkFaded.Checked = False
        End If
    End Sub

    Public Sub setLabel(ByVal n As Integer, ByVal l As String, ByVal ql As Integer)
        If l = SEL_STRING Then
            l = "<no cluster>"
        End If
        If n = 1 Then
            If l = "<no cluster>" Then
                Me.chkShiny.Checked = False
                Me.chkShiny.Enabled = False
            Else
                Me.chkShiny.Checked = False
                Me.chkShiny.Enabled = True
                l &= " (" & Math.Ceiling(ql * 0.86) & ")"
            End If
            Me.chkShiny.Text = l
        ElseIf n = 2 Then
            If l = "<no cluster>" Then
                Me.chkBright.Checked = False
                Me.chkBright.Enabled = False
            Else
                Me.chkBright.Checked = False
                Me.chkBright.Enabled = True
                l &= " (" & Math.Ceiling(ql * 0.84) & ")"
            End If
            Me.chkBright.Text = l
        ElseIf n = 3 Then
            If l = "<no cluster>" Then
                Me.chkFaded.Checked = False
                Me.chkFaded.Enabled = False
            Else
                Me.chkFaded.Checked = False
                Me.chkFaded.Enabled = True
                l &= " (" & Math.Ceiling(ql * 0.82) & ")"
            End If
            Me.chkFaded.Text = l
        End If
    End Sub

End Class
