'Copyright (c) 2009-2010 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Collections
Imports Microsoft.VisualBasic
Imports System.Xml

Module modAlienEye

    ' These have multiple skills (like symbiants) but variable QL (like implants)

    ' Data is hard-coded rather than stored in the DB
    ' Data consists of a requirements section and a benefits section

    ' Adventurer, Agent, Bureaucrat, Engineer, Fixer, Soldier, Trader
    Private profsExterminatorOccularEnhancement() As Integer = { _
        1, 2, 3, 6, 7, 13, 14 _
    }

    Private reqsNameExterminatorOccularEnhancement() As String = { _
        "Level", "Treatement", "Strength", "Agility", "Sense" _
    }

    Private reqsValueExterminatorOccularEnhancement(,) As Integer = { _
        {2, 16, 7, 7, 7}, _
        {219, 2188, 1400, 1400, 1400} _
    }

    Private bonusNameExterminatorOccularEnhancement() As String = { _
      "Sharp Objects", "Grenade Throwing", "Heavy Weapons", "Bow", "Pistol", "Assault Rifle", "MG/SMG", "Shotgun", _
      "Rifle", "Ranged Energy", "Fling Shot", "Aimed Shot", "Burst", "Full Auto", "Multiple Ranged Weapons", _
      "Critical Increase", "Weapon Range %" _
    }

    ' skills etc as above @ QL1 and QL300
    Private bonusValueExterminatorOccularEnhancement(,) As Integer = { _
        {2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 2}, _
        {70, 90, 80, 80, 80, 80, 70, 70, 100, 100, 70, 100, 70, 70, 80, 3, 12} _
    }


    Public Function checkProfAlienEye(ByVal prof_id As Integer) As Boolean
        Dim i As Integer

        For i = 0 To profsExterminatorOccularEnhancement.Length - 1
            If prof_id = profsExterminatorOccularEnhancement(i) Then
                Return True
            End If
        Next
        Return False
    End Function

    Public Function getAlienEyeBonuses(ql As Integer) As String
        Dim result As String = ""
        Dim i As Integer
        Dim amt As Integer

        For i = 0 To bonusNameExterminatorOccularEnhancement.Length - 1
            amt = extrapolate(1,bonusValueExterminatorOccularEnhancement(0,i),300,bonusValueExterminatorOccularEnhancement(1,i),ql)
            result = result & "#" & bonusNameExterminatorOccularEnhancement(i) & " : " & CStr(amt)
        Next i
        Return Mid(result,2) ' eliminate initial "#"
    End Function

    Public Function getAlienEyeRequisites(ql As Integer) As String
        Dim result As String = ""
        Dim i As Integer
        Dim amt As Integer

        For i = 0 To reqsNameExterminatorOccularEnhancement.Length - 1
            amt = extrapolate(1, reqsValueExterminatorOccularEnhancement(0, i), 300, reqsValueExterminatorOccularEnhancement(1, i), ql)
            If reqsNameExterminatorOccularEnhancement(i) = "Level" Then
                result = CStr(amt) & "|"
            ElseIf reqsNameExterminatorOccularEnhancement(i) = "Treatement" Then
                result = result & CStr(amt) & "|"
            Else
                result = result & reqsNameExterminatorOccularEnhancement(i) & " " & CStr(amt) & ", "
            End If
        Next i
        Return Mid(result, 1, result.Length - 2) ' eliminate last ", "
    End Function

    Function getAlienEyeTooltip(ByVal ql As Integer) As String
        Dim s As String
        Dim p As Integer
        Dim sk As String
        Dim ska() As String
        Dim skv As String
        Dim skk As String
        Dim sc As New SortedList
        Dim de As DictionaryEntry
        Dim j As Integer

        sk = getAlienEyeBonuses(ql)
        ska = sk.Split("#")
        For j = 0 To ska.Length - 1
            p = ska(j).IndexOf(" : ")
            skk = ska(j).Substring(0, p)
            skv = ska(j).Substring(p + 3)
            If sc.ContainsKey(skk) Then
                sc(skk) = CStr(CInt(sc(skk)) + CInt(skv))
            Else
                sc.Add(skk, skv)
            End If
        Next
        s = ""
        For Each de In sc
            If s <> "" Then
                s &= Chr(10)
            End If
            s &= de.Key & " : " & de.Value
        Next
        Return s
    End Function


End Module
