'Copyright (c) 2005-2013 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.Collections
Imports System.Windows.Forms
Imports Microsoft.VisualBasic

Module modMain

    Public objFrmMain As frmMain

    Public impA As New impArray
    Public shopA As New shopArray

    Public currentFile As String = ""

    Public dbPath As String = ""

    Public benefitSortAsc As Integer = True
    Public lastBenefitCol As Integer = 0

    Public Const STR_UP As String = ChrW(923)
    Public Const STR_DN As String = ChrW(86)

    Public Const SEL_STRING As String = "                   ...                   "

    Public Const FIND_SEL_STRING As String = "<select cluster to find>"

    ' *** profession name list ***
    Public profNames() As String = { _
        "Adventurer", "Agent", "Bureaucrat", _
        "Doctor", "Enforcer", "Engineer", _
        "Fixer", "Keeper", "Martial Artist", _
        "Meta-Physicist", "Nano-Technician", "Shade", _
        "Soldier", "Trader" _
    }
    Public Const SHADE_ID As Integer = 12

    Public abilityAbrev() As String = {"Str", "Agl", "Sta", "Int", "Sen", "Psy"}
    Public abilityFull() As String = {"Strength", "Agility", "Stamina", "Intelligence", "Sense", "Psychic"}

    Public impSlots() As String = { _
      "Eye", "Head", "Ear", "Right Arm", "Chest", "Left Arm", _
      "Right Wrist", "Waist", "Left Wrist", "Right Hand", _
      "Legs", "Left Hand", "Feet" _
    }

    Public impMap() As Integer = {1, 2, 3, 11, 4, 8, 12, 5, 9, 13, 6, 10, 7}

    Public Sub main()
        objFrmMain = New frmMain
        objFrmMain.ShowDialog()
    End Sub

    Public Sub doBuild()
        Dim i As Integer
        Dim j As Integer
        Dim sk As String
        Dim ska() As String
        Dim skv As String
        Dim skk As String
        Dim p As Integer
        Dim sc As New SortedList
        Dim de As DictionaryEntry
        Dim reqs As String
        Dim reqsA() As String
        Dim npreq As Integer
        Dim lvi As ListViewItem
        Dim benefit_count As Integer = 1

        objFrmMain.Cursor = Cursors.WaitCursor
        ' do lots of work :D
        benefitSortAsc = True
        lastBenefitCol = 0
        objFrmMain.chBenefits1A.Text = "Skill, Ability or Statistic " & STR_UP
        objFrmMain.chBenefits1B.Text = "Benefit"
        objFrmMain.chBenefits2A.Text = "Skill, Ability or Statistic " & STR_UP
        objFrmMain.chBenefits2B.Text = "Benefit"
        objFrmMain.chBenefits3A.Text = "Skill, Ability or Statistic " & STR_UP
        objFrmMain.chBenefits3B.Text = "Benefit"
        objFrmMain.lstBenefits.Items.Clear()
        objFrmMain.lvBenefit1.Items.Clear()
        objFrmMain.lvBenefit2.Items.Clear()
        objFrmMain.lvBenefit3.Items.Clear()
        For i = 0 To 12
            If impA(i).SorI() = "I" Then
                If impA(i).ShinyCluster() <> SEL_STRING Then
                    If sc.ContainsKey(impA(i).ShinyCluster()) Then
                        sc(impA(i).ShinyCluster()) = CStr(CInt(sc(impA(i).ShinyCluster())) + impA(i).ShinyClusterBonus())
                    Else
                        sc.Add(impA(i).ShinyCluster(), CStr(impA(i).ShinyClusterBonus()))
                    End If
                End If
                If impA(i).BrightCluster() <> SEL_STRING Then
                    If sc.ContainsKey(impA(i).BrightCluster()) Then
                        sc(impA(i).BrightCluster()) = CStr(CInt(sc(impA(i).BrightCluster())) + impA(i).BrightClusterBonus())
                    Else
                        sc.Add(impA(i).BrightCluster(), CStr(impA(i).BrightClusterBonus()))
                    End If
                End If
                If impA(i).FadedCluster() <> SEL_STRING Then
                    If sc.ContainsKey(impA(i).FadedCluster()) Then
                        sc(impA(i).FadedCluster()) = CStr(CInt(sc(impA(i).FadedCluster())) + impA(i).FadedClusterBonus())
                    Else
                        sc.Add(impA(i).FadedCluster(), CStr(impA(i).FadedClusterBonus()))
                    End If
                End If
            ElseIf impA(i).SorI = "A" Then
                ' actual bonuses are fixed, just need to scale by QL...
                sk = getAlienEyeBonuses(impA(i).QL)
                ska = sk.Split("#")
                For j = 0 To ska.Length - 1
                    p = ska(j).IndexOf(" : ")
                    skk = ska(j).Substring(0, p)
                    skv = ska(j).Substring(p + 3)
                    If sc.ContainsKey(skk) Then
                        sc(skk) = CStr(CInt(sc(skk)) + CInt(skv))
                    Else
                        sc.Add(skk, skv)
                    End If
                Next
            Else
                If impA(i).SymbiantOrSpirit() <> SEL_STRING Then
                    sk = impA(i).SymbSpiritBonuses()
                    ska = sk.Split("#")
                    For j = 0 To ska.Length - 1
                        p = ska(j).IndexOf(" : ")
                        skk = ska(j).Substring(0, p)
                        skv = ska(j).Substring(p + 3)
                        If sc.ContainsKey(skk) Then
                            sc(skk) = CStr(CInt(sc(skk)) + CInt(skv))
                        Else
                            sc.Add(skk, skv)
                        End If
                    Next
                End If
            End If
        Next
        For Each de In sc
            objFrmMain.lstBenefits.Items.Add(de.Key & " : " & de.Value)
            lvi = New ListViewItem(CStr(de.Key))
            lvi.SubItems.Add(CStr(de.Value))
            If benefit_count > 54 Then
                objFrmMain.lvBenefit3.Items.Add(lvi)
            ElseIf benefit_count > 27 Then
                objFrmMain.lvBenefit2.Items.Add(lvi)
            Else
                objFrmMain.lvBenefit1.Items.Add(lvi)
            End If
            benefit_count += 1
        Next
        ' handle requisites too
        objFrmMain.lvReqs.Items.Clear()
        For i = 0 To 12
            reqs = impA(i).Requisites
            npreq = impA(i).NPRequisites
            lvi = New ListViewItem(impSlots(i))
            If reqs = "ERROR" Then
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
            ElseIf reqs = "" Then
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add("n/a")
            ElseIf impA(i).SorI = "I" Then
                reqsA = reqs.Split("|")
                lvi.SubItems.Add(reqsA(0))
                lvi.SubItems.Add("n/a")
                lvi.SubItems.Add(reqsA(1) & " " & reqsA(2))
                If npreq = -1 Then
                    lvi.SubItems.Add("unknown")
                Else
                    lvi.SubItems.Add(CStr(npreq))
                End If
            Else
                reqsA = reqs.Split("|")
                lvi.SubItems.Add(reqsA(1))
                lvi.SubItems.Add(reqsA(0))
                lvi.SubItems.Add(reqsA(2))
                lvi.SubItems.Add("n/a")
            End If
            objFrmMain.lvReqs.Items.Add(lvi)
        Next
        objFrmMain.miSaveAsAOSkills.Enabled = True
        objFrmMain.Cursor = Cursors.Default
    End Sub

    Public Sub doSuggest(ByVal abl As String)
        Dim i As Integer
        Dim j As Integer
        Dim k As Integer
        Dim res As String
        Dim resA() As String
        Dim resA2() As String
        Dim resA3() As String
        Dim lvi As ListViewItem

        objFrmMain.lvSuggest.Items.Clear()
        For i = 0 To 12
            If impA(i).SorI = "I" Then
                res = getSuggestions(impA(i).ShinyCluster, impA(i).BrightCluster, impA(i).FadedCluster, abl)
                If res <> "" Then
                    ' split into shiny, bright and faded suggestions.
                    resA = res.Split("|")
                    For j = 0 To resA.Length - 1
                        ' ensure there is data
                        If resA(j).Length > 0 Then
                            ' split into individual suggestions
                            resA2 = resA(j).Split(",")
                            For k = 0 To resA2.Length - 1
                                ' split into type/cluster/ability
                                resA3 = resA2(k).Split("=")
                                lvi = New ListViewItem(impSlots(i))
                                lvi.SubItems.Add(resA3(0))
                                lvi.SubItems.Add(resA3(1))
                                lvi.SubItems.Add(resA3(2))
                                objFrmMain.lvSuggest.Items.Add(lvi)
                            Next
                        End If
                    Next
                End If
            End If
        Next
    End Sub

    Public Sub doReset()
        Dim i As Integer

        ' reset everything to initial state
        For i = 0 To 12
            impA(i).resetAll()
            shopA(i).clearAll()
        Next
        objFrmMain.cmbProfession.SelectedIndex = 0
        objFrmMain.cmbFind.SelectedIndex = 0
        objFrmMain.lvReqs.Items.Clear()
        objFrmMain.lvBenefit1.Items.Clear()
        objFrmMain.lvBenefit2.Items.Clear()
        objFrmMain.lvBenefit3.Items.Clear()
        objFrmMain.lstBenefits.Items.Clear()
        objFrmMain.miSaveAsAOSkills.Enabled = False
    End Sub

    Public Sub doSortBenefits(ByVal col As Integer)
        Dim i As Integer
        Dim cnt As Integer = 1
        Dim sc As SortedList
        Dim de As DictionaryEntry
        Dim lvi As ListViewItem
        Dim tmp_num As Integer
        Dim tmp_str As String
        Dim tmpA() As String
        Dim zero As String = "0"

        ' sort across all 3 listviews (combine results back into a single list, sort it appropriately then redistribute)
        If lastBenefitCol = col Then
            benefitSortAsc = Not benefitSortAsc
        Else
            benefitSortAsc = Iif(col=0,True,False)
        End If
        If benefitSortAsc Then
            sc = New SortedList
            If col = 0 Then
                objFrmMain.chBenefits1A.Text = "Skill, Ability or Statistic " & STR_UP
                objFrmMain.chBenefits1B.Text = "Benefit"
                objFrmMain.chBenefits2A.Text = "Skill, Ability or Statistic " & STR_UP
                objFrmMain.chBenefits2B.Text = "Benefit"
                objFrmMain.chBenefits3A.Text = "Skill, Ability or Statistic " & STR_UP
                objFrmMain.chBenefits3B.Text = "Benefit"
            Else
                objFrmMain.chBenefits1A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits1B.Text = STR_UP & " Benefit"
                objFrmMain.chBenefits2A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits2B.Text = STR_UP & " Benefit"
                objFrmMain.chBenefits3A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits3B.Text = STR_UP & " Benefit"
            End If
        Else
            sc = New SortedList(New ReverseItemComparer)
            If col = 0 Then
                objFrmMain.chBenefits1A.Text = "Skill, Ability or Statistic " & STR_DN
                objFrmMain.chBenefits1B.Text = "Benefit"
                objFrmMain.chBenefits2A.Text = "Skill, Ability or Statistic " & STR_DN
                objFrmMain.chBenefits2B.Text = "Benefit"
                objFrmMain.chBenefits3A.Text = "Skill, Ability or Statistic " & STR_DN
                objFrmMain.chBenefits3B.Text = "Benefit"
            Else
                objFrmMain.chBenefits1A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits1B.Text = STR_DN & " Benefit"
                objFrmMain.chBenefits2A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits2B.Text = STR_DN & " Benefit"
                objFrmMain.chBenefits3A.Text = "Skill, Ability or Statistic"
                objFrmMain.chBenefits3B.Text = STR_DN & " Benefit"
            End If
        End If
        lastBenefitCol = col
        If col = 0 Then
            ' extract all list elements into the same sorted collection
            For i = 0 To objFrmMain.lvBenefit1.Items.Count - 1
                sc.Add(objFrmMain.lvBenefit1.Items(i).SubItems(0).Text, objFrmMain.lvBenefit1.Items(i).SubItems(1).Text)
            Next
            For i = 0 To objFrmMain.lvBenefit2.Items.Count - 1
                sc.Add(objFrmMain.lvBenefit2.Items(i).SubItems(0).Text, objFrmMain.lvBenefit2.Items(i).SubItems(1).Text)
            Next
            For i = 0 To objFrmMain.lvBenefit3.Items.Count - 1
                sc.Add(objFrmMain.lvBenefit3.Items(i).SubItems(0).Text, objFrmMain.lvBenefit3.Items(i).SubItems(1).Text)
            Next
            ' re-insert them
            objFrmMain.lvBenefit1.Items.Clear()
            objFrmMain.lvBenefit2.Items.Clear()
            objFrmMain.lvBenefit3.Items.Clear()
            For Each de In sc
                lvi = New ListViewItem(CStr(de.Key))
                lvi.SubItems.Add(CStr(de.Value))
                If cnt > 54 Then
                    objFrmMain.lvBenefit3.Items.Add(lvi)
                ElseIf cnt > 27 Then
                    objFrmMain.lvBenefit2.Items.Add(lvi)
                Else
                    objFrmMain.lvBenefit1.Items.Add(lvi)
                End If
                cnt += 1
            Next
        Else
            ' extract all list elements into the same sorted collection
            For i = 0 To objFrmMain.lvBenefit1.Items.Count - 1
                tmp_num = CInt(objFrmMain.lvBenefit1.Items(i).SubItems(1).Text)
                tmp_str = CStr(tmp_num).PadLeft(5, "0") & "|" & objFrmMain.lvBenefit1.Items(i).SubItems(0).Text
                sc.Add(tmp_str, objFrmMain.lvBenefit1.Items(i).SubItems(0).Text)
            Next
            For i = 0 To objFrmMain.lvBenefit2.Items.Count - 1
                tmp_num = CInt(objFrmMain.lvBenefit2.Items(i).SubItems(1).Text)
                tmp_str = CStr(tmp_num).PadLeft(5, "0") & "|" & objFrmMain.lvBenefit2.Items(i).SubItems(0).Text
                sc.Add(tmp_str, objFrmMain.lvBenefit2.Items(i).SubItems(0).Text)
            Next
            For i = 0 To objFrmMain.lvBenefit3.Items.Count - 1
                tmp_num = CInt(objFrmMain.lvBenefit3.Items(i).SubItems(1).Text)
                tmp_str = CStr(tmp_num).PadLeft(5, "0") & "|" & objFrmMain.lvBenefit3.Items(i).SubItems(0).Text
                sc.Add(tmp_str, objFrmMain.lvBenefit3.Items(i).SubItems(0).Text)
            Next
            ' re-insert them
            objFrmMain.lvBenefit1.Items.Clear()
            objFrmMain.lvBenefit2.Items.Clear()
            objFrmMain.lvBenefit3.Items.Clear()
            For Each de In sc
                tmpA = CStr(de.Key).Split("|")
                lvi = New ListViewItem(CStr(de.Value))
                If tmpA(0) = "00000" Then
                    lvi.SubItems.Add("0")
                Else
                    lvi.SubItems.Add(tmpA(0).TrimStart(zero.ToCharArray()))
                End If
                If cnt > 54 Then
                    objFrmMain.lvBenefit3.Items.Add(lvi)
                ElseIf cnt > 27 Then
                    objFrmMain.lvBenefit2.Items.Add(lvi)
                Else
                    objFrmMain.lvBenefit1.Items.Add(lvi)
                End If
                cnt += 1
            Next
        End If
    End Sub

    Public Sub loadWinSize()
        Dim sr As System.IO.StreamReader = New System.IO.StreamReader("ih_windows.ini")
        Dim ln As String
        ln = sr.ReadLine()
        objFrmMain.Width = CInt(ln.Split(Chr(61))(1))
        ln = sr.ReadLine()
        objFrmMain.Height = CInt(ln.Split(Chr(61))(1))
        sr.Close()
    End Sub

    Public Sub saveWinSize()
        Dim sw As System.IO.StreamWriter = New System.IO.StreamWriter("ih_windows.ini")
        sw.WriteLine("MainW=" & objFrmMain.Width)
        sw.WriteLine("MainH=" & objFrmMain.Height)
        sw.Close()
    End Sub

    ' Implements the manual sorting of items by columns.
    Class ReverseItemComparer : Implements IComparer
        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
            Return -String.Compare(CType(x, String), CType(y, String))
        End Function
    End Class

End Module
