'Copyright (c) 2005-2010 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports Microsoft.VisualBasic
Imports System.Xml

Module modXML

    ' *** skill name list ***
    Private skillNames() As String = { _
        "Body Development", "Nano Pool", _
        "Martial Arts", "Brawling", "Dimach", "Riposte", "Adventuring", "Swimming", _
        "1 Handed Blunt Weapons", "1 Handed Edged Weapon", "Piercing", "2 Handed Blunt Weapons", "2 Handed Edged Weapons", _
        "Melee Energy Weapons", "Parry", "Sneak Attack", "Multiple Melee Weapons", "Fast Attack", _
        "Sharp Objects", "Grenade Throwing", "Heavy Weapons", _
        "Bow", "Pistol", "Assault Rifle", "MG/SMG", "Shotgun", "Rifle", "Ranged Energy", _
        "Fling Shot", "Aimed Shot", "Burst", "Full Auto", "Bow Special Attack", "Multiple Ranged Weapons", _
        "Melee Weapons Initiative", "Ranged Initiative", "Physical Initiative", "Nano Initiative", "Dodge Ranged Attacks", _
        "Evade Close Combat", "Duck Explosives", "Nano Resistance", "Run Speed", _
        "Mechanical Engineering", "Electrical Engineering", "Quantum Physics", "Weapon Smithing", "Pharmaceuticals", _
        "Nano Programming", "Computer Literacy", "Psychology", "Chemistry", "Tutoring", _
        "Matter Metamorphosis", "Biological Metamorphosis", "Psychological Modifications", "Matter Creation", _
        "Time and Space", "Sensory Improvement", "First Aid", "Treatment", _
        "Concealment", "Breaking and Entry", "Trap Disarming", "Perception", _
        "Vehicle Air", "Vehicle Ground", "Vehicle Water", "Map Navigation" _
    }

    Private skillNamesAO() As String = { _
        "Body Dev", "Nano Pool", _
        "Martial Arts", "Brawling", "Dimach", "Riposte", "Adventuring", "Swimming", _
        "1h Blunt", "1h Edged", "Piercing", "2h Blunt", "2h Edged", _
        "Melee Energy", "Parry", "Sneak Attack", "Mult. Melee", "Fast Attack", _
        "Sharp Obj", "Grenade", "Heavy Weapons", _
        "Bow", "Pistol", "Assault Rif", "MG/SMG", "Shotgun", "Rifle", "Ranged Energy", _
        "Fling Shot", "Aimed Shot", "Burst", "Full Auto", "Bow Spc Att", "Multi Ranged", _
        "Melee Init", "Ranged Init", "Physical Init", "NanoC Init.", "Dodge-Rng", _
        "Evade-ClsC", "Duck-Exp", "Nano Resist", "Run Speed", _
        "Mech Eng", "Elec Eng", "Quantum FT", "Weapon Smith", "Pharma Tech", _
        "Nano Program", "Comp Lit", "Psychology", "Chemistry", "Tutoring", _
        "Mat Met", "Bio Met", "Psycho Modi", "Mat Create", _
        "Time & Space", "Sensory Imp", "First Aid", "Treatment", _
        "Concealment", "Break & Entry", "Trap Disarm.", "Perception", _
        "Vehicle Air", "Vehicle Ground", "Vehicle Water", "Map Navigation" _
    }

    ' *** ability name list ***
    Private attrNames() As String = { _
        "Strength", "Agility", "Stamina", "Intelligence", "Sense", "Psychic" _
    }

    Public Sub saveXML(ByVal filename As String)
        Dim i As Integer
        Dim xwriter As XmlTextWriter

        'Create a new XmlTextWriter.
        xwriter = New XmlTextWriter(filename, System.Text.Encoding.UTF8)
        xwriter.Indentation = 4
        xwriter.Formatting = Formatting.Indented
        'Write the beginning of the document including the document declaration. Standalone is true.
        xwriter.WriteStartDocument(True)
        'Write the initial elements
        xwriter.WriteStartElement("IMPLANTS")
        xwriter.WriteElementString("PROF", CStr(objFrmMain.cmbProfession.SelectedIndex))
        For i = 0 To 12
            If impA(i).SorI() = "I" Then
                xwriter.WriteStartElement("I_ITEM")
                xwriter.WriteElementString("QL", CStr(impA(i).QL))
                If impA(i).ShinyCluster() <> SEL_STRING Then
                    xwriter.WriteElementString("SHINY", impA(i).ShinyCluster())
                End If
                If impA(i).BrightCluster() <> SEL_STRING Then
                    xwriter.WriteElementString("BRIGHT", impA(i).BrightCluster())
                End If
                If impA(i).FadedCluster() <> SEL_STRING Then
                    xwriter.WriteElementString("FADED", impA(i).FadedCluster())
                End If
                xwriter.WriteEndElement()
            ElseIf impA(i).SorI() = "A" Then
                xwriter.WriteStartElement("A_ITEM")
                xwriter.WriteElementString("QL", CStr(impA(i).QL))
                xwriter.WriteEndElement()
            Else
                xwriter.WriteStartElement("S_ITEM")
                If impA(i).SymbiantOrSpirit() <> SEL_STRING Then
                    xwriter.WriteElementString("NAME", impA(i).SymbiantOrSpirit())
                End If
                xwriter.WriteEndElement()
            End If
        Next
        xwriter.WriteStartElement("SHOPPING")
        For i = 0 To 12
            xwriter.WriteElementString("STATUS", shopA(i).ShoppingStatus)
        Next
        xwriter.WriteEndElement()
        'End the document
        xwriter.WriteEndElement()
        xwriter.WriteEndDocument()
        'Flush the XML document to the underlying stream and close the underlying stream
        xwriter.Close()
    End Sub

    Public Sub loadXML(ByVal filename As String)
        Dim rdr As Xml.XmlTextReader
        Dim node_name As String = ""
        Dim noError As Boolean = True

        Dim prof As Integer = 0
        Dim ql(12) As Integer
        Dim sn(12) As String
        Dim bn(12) As String
        Dim fn(12) As String
        Dim nm(12) As String
        Dim sr(12) As String
        Dim ss(12) As String

        Dim i As Integer = 0
        Dim j As Integer

        For j = 0 To 12
            ss(j) = "NNN"
        Next
        j = 0
        Try
            rdr = New Xml.XmlTextReader(filename)
            Do While rdr.Read()
                Select Case rdr.NodeType
                    Case Xml.XmlNodeType.Element
                        Select Case rdr.Name
                            Case "I_ITEM"
                                sn(i) = ""
                                bn(i) = ""
                                fn(i) = ""
                                sr(i) = "I"
                            Case "S_ITEM"
                                If prof = 0 Then
                                    Throw New Exception
                                End If
                                nm(i) = ""
                                sr(i) = "S"
                            Case "A_ITEM"
                                If prof = 0 Then
                                    Throw New Exception
                                End If
                                sr(i) = "A"
                            Case Else
                                node_name = rdr.Name
                        End Select
                    Case Xml.XmlNodeType.Text
                        Select Case node_name
                            Case "PROF"
                                prof = CInt(rdr.Value)
                            Case "QL"
                                ql(i) = CInt(rdr.Value)
                            Case "SHINY"
                                sn(i) = rdr.Value
                            Case "BRIGHT"
                                bn(i) = rdr.Value
                            Case "FADED"
                                fn(i) = rdr.Value
                            Case "NAME"
                                nm(i) = rdr.Value
                            Case "STATUS"
                                ss(j) = rdr.Value
                                j += 1
                        End Select
                    Case Xml.XmlNodeType.EndElement
                        Select Case rdr.Name
                            Case "I_ITEM"
                                i += 1
                            Case "S_ITEM"
                                i += 1
                            Case "A_ITEM"
                                i += 1
                        End Select
                End Select
            Loop
        Catch
            noError = False
            MsgBox("There was a problem loading the file <" & filename & ">", CType(MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, Microsoft.VisualBasic.MsgBoxStyle), "File Open Error")
        Finally
            If Not (rdr Is Nothing) Then
                rdr.Close()
            End If
        End Try
        If noError Then
            objFrmMain.cmbProfession.SelectedIndex = prof
            For i = 0 To 12
                If sr(i) = "I" Then
                    impA(i).QL = ql(i)
                    impA(i).setElement("Shiny", sn(i))
                    impA(i).setElement("Bright", bn(i))
                    impA(i).setElement("Faded", fn(i))
                ElseIf sr(i) = "A" Then
                    impA(i).QL = ql(i)
                    impA(i).setElement("EOE", "") ' Exterminator Occular Enhancement
                Else
                    impA(i).setElement("", nm(i))
                End If
            Next
            For i = 0 To 12
                shopA(i).ShoppingStatus = ss(i)
            Next
        End If
    End Sub

    Public Sub saveAOSkillsXML(ByVal filename As String)
        Dim i As Integer
        Dim j As Integer
        Dim s As String
        Dim p As Integer
        Dim skill_name As String
        Dim benefit_value As String
        Dim abl(6) As Integer
        Dim skl(69) As Integer
        Dim hp As Integer = 0
        Dim np As Integer = 0
        Dim xwriter As XmlTextWriter

        For j = 0 To 5
            abl(j) = 0
        Next
        For j = 0 To 68
            skl(j) = 0
        Next
        For i = 0 To objFrmMain.lstBenefits.Items.Count - 1
            s = objFrmMain.lstBenefits.Items(i)
            p = s.IndexOf(" : ")
            skill_name = s.Substring(0, p)
            benefit_value = s.Substring(p + 3)
            For j = 0 To 5
                If skill_name = attrNames(j) Then
                    abl(j) = benefit_value
                End If
            Next
            For j = 0 To 68
                If skill_name = skillNames(j) Then
                    skl(j) = benefit_value
                End If
            Next
            If skill_name = "Max Health" Then
                hp = benefit_value
            End If
            If skill_name = "Max Nano" Then
                np = benefit_value
            End If
        Next
        'Create a new XmlTextWriter.
        xwriter = New XmlTextWriter(filename, System.Text.Encoding.UTF8)
        xwriter.Indentation = 4
        xwriter.Formatting = Formatting.Indented
        'Write the beginning of the document including the document declaration. Standalone is true.
        xwriter.WriteStartDocument(True)
        'Write the initial elements
        xwriter.WriteStartElement("IMP")
        ' Write Abilities, then Skills
        For i = 0 To 5
            If abl(i) <> 0 Then
                xwriter.WriteStartElement("ATTR")
                xwriter.WriteAttributeString("ID", CStr(i))
                xwriter.WriteAttributeString("NAME", attrNames(i))
                xwriter.WriteElementString("IMP", CStr(abl(i)))
                xwriter.WriteEndElement()
            End If
        Next
        For i = 0 To 68
            If skl(i) <> 0 Then
                xwriter.WriteStartElement("SKILL")
                xwriter.WriteAttributeString("ID", CStr(i))
                xwriter.WriteAttributeString("NAME", skillNamesAO(i))
                xwriter.WriteElementString("IMP", CStr(skl(i)))
                xwriter.WriteEndElement()
            End If
        Next
        xwriter.WriteStartElement("HP")
        xwriter.WriteElementString("IMP", CStr(hp))
        xwriter.WriteEndElement()
        xwriter.WriteStartElement("NANO")
        xwriter.WriteElementString("IMP", CStr(np))
        xwriter.WriteEndElement()
        'End the document
        xwriter.WriteEndElement()
        xwriter.WriteEndDocument()
        'Flush the XML document to the underlying stream and close the underlying stream
        xwriter.Close()
    End Sub

    Public Sub loadIMatrixXML(ByVal fname As String)
        Dim rdr As XmlTextReader
        Dim id As Integer = -1
        Dim ql As Integer = -1
        Dim st As Integer = -1
        Dim imp As String = ""
        Dim loc As Integer = -1
        Dim node_name As String
        Dim noError As Boolean = True
        Dim cluster(12, 2, 1) As Integer
        Dim symbiant(12, 1) As Integer
        Dim profid As Integer = -1
        Dim i As Integer

        For i = 0 To 12
            cluster(i, 0, 0) = -1
            cluster(i, 0, 1) = -1
            cluster(i, 1, 0) = -1
            cluster(i, 1, 1) = -1
            cluster(i, 2, 0) = -1
            cluster(i, 2, 1) = -1
            symbiant(i, 0) = -1
            symbiant(i, 1) = -1
        Next
        Try
            rdr = New XmlTextReader(fname)
            Do While rdr.Read()
                Select Case rdr.NodeType
                    Case Xml.XmlNodeType.Element
                        node_name = rdr.Name
                    Case Xml.XmlNodeType.Text
                        If node_name = "ClusterID" Then
                            id = CInt(rdr.Value)
                        End If
                        If node_name = "ID" Then
                            id = CInt(rdr.Value)
                        End If
                        If node_name = "Implant" Then
                            imp = rdr.Value
                        End If
                        If node_name = "QL" Then
                            ql = CInt(rdr.Value)
                        End If
                        If node_name = "LocationID" Then
                            loc = CInt(rdr.Value)
                        End If
                        If node_name = "SlotType" Then
                            If CStr(rdr.Value) = "Faded" Then
                                st = 0
                            End If
                            If CStr(rdr.Value) = "Bright" Then
                                st = 1
                            End If
                            If CStr(rdr.Value) = "Shining" Then
                                st = 2
                            End If
                        End If
                        If node_name = "ProfessionID" Then
                            profid = CInt(rdr.Value)
                            ' ensure iMatrix files with no profession specified are handled correctly
                            profid = IIf(profid = 15, -1, profid)
                        End If
                    Case Xml.XmlNodeType.EndElement
                            If rdr.Name = "ClusterList" Then
                                ' store cluster
                                ' we should have cluster id, cluster ql, cluster slot and implant
                                If id <> -1 And ql <> -1 And st <> -1 And imp <> "" Then
                                    ' convert imp into a number and store if cluster is not empty
                                    For i = 0 To 12
                                        If impSlots(i) = imp And id <> 117 Then
                                            cluster(i, st, 0) = id
                                            cluster(i, st, 1) = ql
                                        End If
                                    Next
                                Else
                                    ' throw exception here...
                                    Throw New Exception
                                End If
                                ' reset values to defaults
                                id = -1
                                ql = -1
                                st = -1
                                imp = ""
                            End If
                            If rdr.Name = "SymbiantList" Then
                                ' store symbiant
                                ' we should have symb id, loc id and ql
                                If id <> -1 And ql <> -1 And loc <> -1 Then
                                    ' store
                                    For i = 0 To 12
                                        If impMap(i) = loc Then
                                            symbiant(i, 0) = id
                                            symbiant(i, 1) = ql
                                        End If
                                    Next
                                Else
                                    ' throw exception here...
                                    Throw New Exception
                                End If
                                ' reset values to defaults
                                id = -1
                                ql = -1
                                loc = -1
                            End If
                End Select
            Loop
            rdr.Close()
            For i = 0 To 12
                If symbiant(i, 0) <> -1 And profid = -1 Then
                    ' if a symbiant specified and no profession...
                    Throw New Exception
                End If
            Next
        Catch
            noError = False
            MsgBox("There was a problem loading the file <" & fname & ">", CType(MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, Microsoft.VisualBasic.MsgBoxStyle), "IMatrix File Open Error")
        End Try
        If noError Then
            ' process results here
            doReset()
            ' set profession here if one specified
            If profid <> -1 Then
                objFrmMain.cmbProfession.SelectedIndex = profid
            End If
            For i = 0 To 12
                If symbiant(i, 0) = -1 Then
                    ' set this as an implant
                    If cluster(i, 0, 0) <> -1 Then
                        ' set faded cluster and ql for this implant
                        impA(i).QL = cluster(i, 0, 1)
                        impA(i).setElement("Faded", getLongNameFromID(cluster(i, 0, 0)))
                    End If
                    If cluster(i, 1, 0) <> -1 Then
                        ' set bright cluster and ql for this implant
                        impA(i).QL = cluster(i, 1, 1)
                        impA(i).setElement("Bright", getLongNameFromID(cluster(i, 1, 0)))
                    End If
                    If cluster(i, 2, 0) <> -1 Then
                        ' set shiny cluster and ql for this implant
                        impA(i).QL = cluster(i, 2, 1)
                        impA(i).setElement("Shiny", getLongNameFromID(cluster(i, 2, 0)))
                    End If
                Else
                    ' set this as a symbiant/spirit
                    impA(i).setElement("", getSymbiantFromID(symbiant(i, 0)) & " (QL" & CStr(symbiant(i, 1)) & ")")
                End If
            Next
        End If
    End Sub

End Module
