'Copyright (c) 2005-2010 Donald Milne
'All rights reserved.
'
'This file is part of implantHelper.
'
'implantHelper is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.
'
'Foobar is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with implantHelper.  If not, see <http://www.gnu.org/licenses/>.

Imports System

Public Class shopArray : Inherits System.Collections.CollectionBase

    Public Function AddNewShop(ByVal tp As System.Windows.Forms.TabPage, ByVal id As Integer) As ihControl2
        Dim aShop As New ihControl2
        Dim g As Graphics
        Dim dpi As Integer
        Dim scaleHeight As Double

        ' Add to the collection, and then add to the specified tab page
        Me.List.Add(aShop)
        tp.Controls.Add(aShop)
        aShop.ControlTabPage = tp
        ' Set default/initial properties for the object (we need to factor in DPI settings here!).
        g = tp.Parent.CreateGraphics()
        dpi = g.DpiX
        scaleHeight = CInt(24 * (dpi / 96))
        aShop.Top = 32 + id * (scaleHeight + 8)        ' Set default/initial properties for the object.
        aShop.Left = 8
        aShop.Width = 768
        aShop.Height = scaleHeight
        aShop.ItemIdx = id
        aShop.ImpName = impSlots(id)
        aShop.Tag = Me.Count - 1
        Return aShop
    End Function

    Public Sub Remove()
        ' Check to be sure there is an object to remove.
        If Me.Count > 0 Then
            ' Remove the last object added to the array from the tab page
            ' control's collection. Note the use of the default property in
            ' accessing the array.
            Me(Me.Count - 1).ControlTabPage.Controls.Remove(Me(Me.Count - 1))
            Me.List.RemoveAt(Me.Count - 1)
        End If
    End Sub

    Default Public ReadOnly Property Item(ByVal Index As Integer) As ihControl2
        Get
            Return CType(Me.List.Item(Index), ihControl2)
        End Get
    End Property

End Class
